package cn.ezhizao.framework.logGing;

import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

public class LoggerUtil {

    @Value("${file.upload.path}")
    private String uploadPath;

    private final Logger logger = Logger.getLogger(LoggerUtil.class.getName());
    private FileHandler fileHandler = null;

    public LoggerUtil() {
        try {
            // 设置日志文件的路径和文件名
            String logFileName = "/home/files/dms/upload/carrierNum.txt";
            fileHandler = new FileHandler(logFileName, true); // true表示追加模式
            fileHandler.setFormatter(new SimpleFormatter());

            // 将FileHandler添加到Logger中
            logger.addHandler(fileHandler);
        } catch (IOException e) {
            // 处理异常
            logger.warning("无法初始化日志文件: " + e.getMessage());
        }
    }

    public void logInfo(String message) {
        logger.info(message);
    }

    public void logWarning(String message) {
        logger.warning(message);
    }

    public void logSevere(String message) {
        logger.severe(message);
    }

    // 修改为非静态方法，关闭日志文件
    public void closeLogger() {
        if (fileHandler != null) {
            logger.removeHandler(fileHandler);
            fileHandler.close();
            fileHandler = null;
        }
    }
}