package cn.ezhizao.project.business.equipment.mapper;

import java.util.List;

import cn.ezhizao.project.business.equipment.domain.BizEquipmentDetail;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;


/**
 * 设备档案Mapper接口
 *
 * @author ezhizao
 * @date 2023-11-14
 */
public interface BizEquipmentDetailMapper extends BaseMapper<BizEquipmentDetail> {
    /**
     * 查询设备档案列表
     *
     * @param bizEquipmentDetail 设备档案
     * @return 设备档案集合
     */
    public List<BizEquipmentDetail> getList(BizEquipmentDetail bizEquipmentDetail);

    /**
     * 通过设备ID查询设备使用部门
     * @param equipmentDetailsId
     * @return
     */
    Long getUsageDeptIdByEquipmentDetailsId(Long equipmentDetailsId);

    /**
     * 物理删除
     *
     * @param bizEquipmentDetail
     * @return 删除结果
     */
    public int physicalDelete(BizEquipmentDetail bizEquipmentDetail);


}
