package cn.ezhizao.project.business.equipment.service;

import java.util.List;
import com.baomidou.mybatisplus.extension.service.IService;
import cn.ezhizao.project.business.equipment.domain.BizEquipmentDetail;

/**
 * 设备档案Service接口
 *
 * @author ezhizao
 * @date 2023-11-14
 */
public interface IBizEquipmentDetailService extends IService<BizEquipmentDetail>
{
    /**
     * 查询设备档案列表
     *
     * @param bizEquipmentDetail 设备档案
     * @return 设备档案集合
     */
    List<BizEquipmentDetail> getList(BizEquipmentDetail bizEquipmentDetail);

    /**
     * 通过设备ID查询设备使用部门
     * @param equipmentDetailsId
     * @return
     */
    Long getUsageDeptIdByEquipmentDetailsId(Long equipmentDetailsId);

    /**
     * 物理删除
     * @param bizEquipmentDetail
     * @return 删除结果
     */
    int physicalDelete(BizEquipmentDetail bizEquipmentDetail);

}
