package cn.ezhizao.project.business.equipment.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.equipment.domain.BizUserEquipment;
import cn.ezhizao.project.business.equipment.mapper.BizUserEquipmentMapper;
import cn.ezhizao.project.business.equipment.service.IBizUserEquipmentService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 员工绑定设备Service业务层处理
 *
 * @author ezhizao
 * @date 2023-12-08
 */
@Service
public class BizUserEquipmentServiceImpl  extends ServiceImpl<BizUserEquipmentMapper, BizUserEquipment> implements IBizUserEquipmentService
{
    @Resource
    private BizUserEquipmentMapper bizUserEquipmentMapper;

    /**
     * 查询员工绑定设备列表
     *
     * @param bizUserEquipment 员工绑定设备
     * @return 员工绑定设备
     */
    @Override
    public List<BizUserEquipment> getList(BizUserEquipment bizUserEquipment)
    {
        return bizUserEquipmentMapper.getList(bizUserEquipment);
    }

    /**
     * 物理删除
     * @param bizUserEquipment
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizUserEquipment bizUserEquipment){ return bizUserEquipmentMapper.physicalDelete(bizUserEquipment); }

    @Override
    public int saveUserEquipment(BizUserEquipment bizUserEquipment) {
        return bizUserEquipmentMapper.saveUserEquipment(bizUserEquipment);
    }

}
