package cn.ezhizao.project.business.feign.controller;

import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.project.business.feign.domain.FurnaceNoInfo;
import cn.ezhizao.project.business.feign.service.GetFurnaceNoInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/feign/getFurnaceNoInfo")
public class GetFurnaceNoInfoController {

    @Autowired
    private GetFurnaceNoInfoService getFurnaceNoInfoService;


    // 获取炉号信息
    @GetMapping("/getFurnaceNoInfo")
    @Log(title = "查询炉号信息", businessType = BusinessType.SELECT)
    public AjaxResult getFurnaceNoInfo(FurnaceNoInfo request){
        return getFurnaceNoInfoService.getFurnaceNoInfo(request);
    }

}
