package cn.ezhizao.project.business.innerTurnover.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * 工段内部人周转表对象 biz_inner_turnover
 *
 * @author ezhizao
 * @date 2024-07-08
 */
@Data
@TableName(value = "biz_inner_turnover")
public class BizInnerTurnover extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户ID */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 工段id */
    @ApiModelProperty(value = "${comment}")
    private Long deptId;

    /** 用户账号（编码） */
    @Excel(name = "用户账号", readConverterExp = "编=码")
    @ApiModelProperty(value = "用户账号")
    private String userName;
    private Long userId;

    /** 用户姓名 */
    @Excel(name = "用户姓名")
    @ApiModelProperty(value = "用户姓名")
    private String nickName;

    /** 手机号码 */
    @Excel(name = "手机号码")
    @ApiModelProperty(value = "手机号码")
    private String phoneNumber;

    /** 用户性别（未知、男、女） */
    @Excel(name = "用户性别", readConverterExp = "未=知、男、女")
    @ApiModelProperty(value = "用户性别")
    private String sex;

    /** 使用单位名称 */
    @Excel(name = "使用单位名称")
    @ApiModelProperty(value = "使用单位名称")
    private String usageCompanyName;

}
