package cn.ezhizao.project.business.inspection.service;

import cn.ezhizao.project.business.inspection.domain.BizInspectionCategory;
import cn.ezhizao.project.business.inspection.domain.InspectionCategoryOptions;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * 检查指导书类别Service接口
 *
 * @author zhuangdezheng
 * @date   2024-04-22
 */
public interface IBizInspectionCategoryService extends IService<BizInspectionCategory> {
    /**
     * 物理删除
     *
     * @param bizInspectionCategory 待删除
     * @return 删除结果
     */
    int physicalDelete(BizInspectionCategory bizInspectionCategory);
    List<InspectionCategoryOptions> getCategoryOptions(List<BizInspectionCategory> list);

    /**
     * 获取子类别
     * @param list 类别列表
     */
    List<BizInspectionCategory> recursionList(List<BizInspectionCategory> list, long parentId);
}
