package cn.ezhizao.project.business.inspection.service.impl;

import cn.ezhizao.project.business.inspection.domain.BizInspectionInstruction;
import cn.ezhizao.project.business.inspection.mapper.BizInspectionInstructionMapper;
import cn.ezhizao.project.business.inspection.service.IBizInspectionInstructionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 检查指导书Service业务层处理
 *
 * @author zhuangdezheng
 * date    2024-04-22
 */
@Service
public class BizInspectionInstructionServiceImpl extends ServiceImpl<BizInspectionInstructionMapper, BizInspectionInstruction> implements IBizInspectionInstructionService {
    @Resource
    private BizInspectionInstructionMapper bizInspectionInstructionMapper;

    /**
     * 查询检测指导书列表
     *
     * @param data 查询条件
     * @return 检测指导书集合
     */
    @Override
    public List<BizInspectionInstruction> getList(Map<String, Object> data)
    {
        return bizInspectionInstructionMapper.getList(data);
    }

    /**
     * 物理删除
     *
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizInspectionInstruction bizInspectionInstruction) {
        return bizInspectionInstructionMapper.physicalDelete(bizInspectionInstruction);
    }
}
