package cn.ezhizao.project.business.outsource.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.outsource.mapper.BizOutsourcedOrderDetailProcessMapper;
import cn.ezhizao.project.business.outsource.domain.BizOutsourcedOrderDetailProcess;
import cn.ezhizao.project.business.outsource.service.IBizOutsourcedOrderDetailProcessService;

/**
 * 外协单从对应的外协工序的从Service业务层处理
 *
 * @author ezhizao
 * @date 2024-05-28
 */
@Service
public class BizOutsourcedOrderDetailProcessServiceImpl  extends ServiceImpl<BizOutsourcedOrderDetailProcessMapper, BizOutsourcedOrderDetailProcess> implements IBizOutsourcedOrderDetailProcessService
{
    @Resource
    private BizOutsourcedOrderDetailProcessMapper bizOutsourcedOrderDetailProcessMapper;

    /**
     * 查询外协单从对应的外协工序的从列表
     *
     * @param bizOutsourcedOrderDetailProcess 外协单从对应的外协工序的从
     * @return 外协单从对应的外协工序的从
     */
    @Override
    public List<BizOutsourcedOrderDetailProcess> getList(BizOutsourcedOrderDetailProcess bizOutsourcedOrderDetailProcess)
    {
        return bizOutsourcedOrderDetailProcessMapper.getList(bizOutsourcedOrderDetailProcess);
    }

    /**
     * 物理删除
     * @param bizOutsourcedOrderDetailProcess
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizOutsourcedOrderDetailProcess bizOutsourcedOrderDetailProcess){ return bizOutsourcedOrderDetailProcessMapper.physicalDelete(bizOutsourcedOrderDetailProcess); };

}
