package cn.ezhizao.project.business.packageResourceGroup.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.system.domain.SysUser;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * 包装线对象 biz_package_resource_group
 *
 * @author ezhizao
 * @date 2024-09-03
 */
@Data
@TableName(value = "biz_package_resource_group")
public class BizPackageResourceGroup extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 工段id */
    @ApiModelProperty(value = "${comment}")
    private Long deptId;

    /** 包装线号 */
    @Excel(name = "包装线号")
    @ApiModelProperty(value = "包装线号")
    private Long packageLineNo;

    /** 工段线号 */
    @Excel(name = "工段线号")
    @ApiModelProperty(value = "工段线号")
    private Long deptNo;

    /** 包装线名称 */
    @Excel(name = "包装线名称")
    @ApiModelProperty(value = "包装线名称")
    private String name;

    /** 包装线当前编码 */
    @Excel(name = "包装线当前编码")
    @ApiModelProperty(value = "包装线当前编码")
    private String code;

    /** 年编码 */
    @Excel(name = "年编码")
    @ApiModelProperty(value = "年编码")
    private String year;

    /** 租户id */
    @ApiModelProperty(value = "年编码")
    private Long tenantId;

    /** 停用(0:否；1是） */
    @Excel(name = "停用(0:否；1是）")
    @ApiModelProperty(value = "停用(0:否；1是）")
    private Integer isDeactivate;

    @TableField(exist = false)
    private String deptName;
    @TableField(exist = false)
    private String deptCode;

    @TableField(exist = false)
    private List<SysUser> employees;

    @TableField(exist = false)
    private List<BizPackageResourceGroupDetail> bizPackageResourceGroupDetails;

}
