package cn.ezhizao.project.business.product.controller;

import cn.ezhizao.common.utils.CommonUtils;
import cn.ezhizao.common.utils.SecurityUtils;
import cn.ezhizao.common.utils.poi.ExcelUtil;
import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.project.business.deptProcess.domain.BizDeptProcess;
import cn.ezhizao.project.business.equipment.domain.BizEquipmentDetail;
import cn.ezhizao.project.business.outsource.domain.BizOutsourcedOrderDetailProcess;
import cn.ezhizao.project.business.outsource.service.IBizOutsourcedOrderDetailProcessService;
import cn.ezhizao.project.business.process.domain.BizProcess;
import cn.ezhizao.project.business.product.domain.*;
import cn.ezhizao.project.business.product.service.*;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupDetail;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupSubPlan;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupDetailService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupSubPlanService;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import cn.ezhizao.project.business.workshop.domain.BizWorkshop;
import cn.ezhizao.project.business.workshop.service.IBizWorkshopService;
import cn.ezhizao.project.system.domain.SysDept;
import cn.ezhizao.project.system.domain.SysUser;
import cn.ezhizao.project.system.service.ISysDeptService;
import cn.ezhizao.project.system.service.ISysUserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.models.auth.In;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static cn.hutool.poi.excel.sax.ElementName.v;

/**
 * 报工Controller
 *
 * @author ezhizao
 * @date 2023-11-29
 */
@RestController
@RequestMapping("/business/daywork")
public class BizDayworkController extends BaseController {
    @Resource
    private IBizDayworkService bizDayworkService;

    @Resource
    private IBizDayworkCarrierService bizDayworkCarrierService;

    @Resource
    private IBizFurnaceNoInfoService bizFurnaceNoInfoService;

    @Resource
    private IBizDayworkItemService bizDayworkItemService;

    @Resource
    private IBizTechnologicalProcessDetailService bizTechnologicalProcessDetailService;

    @Resource
    private IBizLotService bizLotService;

    @Resource
    private IBizCarrierService bizCarrierService;

    @Resource
    private IBizCarrierCategoryService carrierCategoryService;

    @Resource
    private IBizLotTechnologicalProcessDetailService bizLotTechnologicalProcessDetailService;

    @Resource
    private IBizProductionResourceGroupDetailService bizProductionResourceGroupDetailService;

    @Resource
    private IBizProductionPlanDetailService bizProductionPlanDetailService;
    @Resource
    private ISysUserService sysUserService;
    @Resource
    private IBizProductionResourceGroupService bizProductionResourceGroupService;
    @Resource
    private IBizProductionResourceGroupSubPlanService bizProductionResourceGroupSubPlanService;
    @Resource
    private ISysDeptService sysDeptService;
    @Resource
    private IBizWorkshopService bizWorkshopService;
    @Resource
    private IBizReturnReceiptDetailService bizReturnReceiptDetailService;
    @Resource
    private IBizOutsourcedOrderDetailProcessService bizOutsourcedOrderDetailProcessService;

    /*
    @Transactional
    @GetMapping("/list")
    public AjaxResult list(BizDaywork bizDaywork) {
        List<BizDaywork>list = new ArrayList<>();
        List<BizDaywork> dayworkList = bizDayworkService.getList(bizDaywork);
        //查询当前工段工序
        BizDeptProcess bizDeptProcess = new BizDeptProcess();
        bizDeptProcess.setDeptId(bizDaywork.getDeptId());
        List<BizDeptProcess> processList = bizDeptProcessService.getList(bizDeptProcess);
        List<Long> ids = new ArrayList<>();
        for (BizDeptProcess item: processList
             ) {
            ids.add(item.getProcessId());
        }
        for (BizDaywork daywork:dayworkList
             ) {
            //查询工段下工序有没有未周转的批次
            List<BizDayworkItem> itemList = bizDayworkItemService.query().eq("deleted", 0).eq("daywork_id", daywork.getId()).in("process_id", ids).lt("status", 4).orderByDesc("create_time").list();
            if (itemList.size()>0){
                BizProcess processItem = bizProcessService.query().eq("id", itemList.get(itemList.size() - 1).getProcessId()).one();
                daywork.setCurrentProcess(processItem);
                //如果最新的item 只有一条 且状态是未开始，那么整个批次报工为未开始状态
                if (daywork.getDayworkItemList().size() == 1 && daywork.getDayworkItemList().get(0).getStatus().equals("0")) {
                    daywork.setStatus(0);
                    //如果item有多条 且最新的一条状态为工序完成那么批次报工状态为待周转
                } else if (daywork.getDayworkItemList().size() > 0 && daywork.getDayworkItemList().get(0).getStatus().equals("3")) {
                    daywork.setStatus(2);
                    //如果item有多条 且最新的一条状态为待周转那么批次报工状态为周转中
                } else if (daywork.getDayworkItemList().size() > 0 && daywork.getDayworkItemList().get(0).getStatus().equals("4")) {
                    daywork.setStatus(3);
                    //判断item最新的一条是否为最后一道工序且工序已完成
                } else if( daywork.getDayworkItemList().get(0).getStatus().equals("4") && daywork.getDayworkItemList().get(0).getProcessId().equals(daywork.getProcessSequence().get(daywork.getProcessSequence().size() - 1).getId())){
                    daywork.setStatus(4);
                }else {
                    daywork.setStatus(1);
                }
            }
            list.add(daywork);
        }

        return success(list);
    }
     */

    /**
     * 查询报工列表
     */
    @Transactional
    @GetMapping("/list")
    @Log(title = "获取报工列表", businessType = BusinessType.SELECT)
    public AjaxResult list(BizDaywork bizDaywork) {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        Long userId = user.getUserId();
        Long productionPlanDetailId = bizDaywork.getProductionPlanDetailId();
        Long deptId = bizDaywork.getDeptId();
        String keywords = bizDaywork.getKeywords();

        // 如果关键字不为空，则根据关键字匹配批次，后面会根据批次进行daywork过滤
        List<BizLot> lots = new ArrayList<>();
        if (!keywords.isEmpty()) {
            List<BizLot> lotList1 = bizLotService.query()
                    .like("lot_code", keywords)
                    .list();
            List<Long> dayworkCarrierIds = bizDayworkCarrierService.query().like("carrier_code", keywords).eq("process_inspection_id", 0L).eq("is_changed",0).list().stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList());
            List<BizDaywork> dayworkByCarriers = bizDayworkService.query().in("id", dayworkCarrierIds.isEmpty() ? Collections.singletonList(0L) : dayworkCarrierIds).list();
            List<BizLot> lotList2 = bizLotService.query().in("id", dayworkByCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkByCarriers.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
            Set<BizLot> uniqueSet = Stream.of(lotList1, lotList2)
                    .flatMap(Collection::stream)
                    .collect(Collectors.toSet());
            lots = uniqueSet.stream().collect(Collectors.toList());
            if (lots.isEmpty()) {
                return success(new ArrayList<>());
            }
        }
        // 获取当前用户的，针对当前部门以及当前生产计划下的报工集合
        List<BizDayworkItem> myDayworkItems = bizDayworkItemService.query()
                .eq("dept_id", deptId)
                .eq("production_plan_detail_id", productionPlanDetailId)
                .eq("user_id", userId)
                .list();
        List<BizProductionPlanDetail> planDetailslanDetails = new ArrayList<>();
        List<BizDaywork> dayworks = new ArrayList<>();
        // 定义一个所有的报工集合，用于后续接收所有的某个批次的报工记录
        List<BizDayworkItem> allDayworkItems = new ArrayList<>();
        List<BizLot> lotList = new ArrayList<>();
        if (!myDayworkItems.isEmpty()) {
            // 将报工记录中的daywork_id，整个到一个List集合中，用于后续的查询
            List<Long> dayworkIds = myDayworkItems.stream()
                    .map(BizDayworkItem::getDayworkId)
                    .collect(Collectors.toList());
            // 再根据整合后报工明细中对应的 daywork_id 的集合，获取到对应的 daywork 集合
            if (keywords.isEmpty())
                dayworks = bizDayworkService.query().in("id", dayworkIds).list();
            else if (!lots.isEmpty()) {
                List<Long> lotIds = lots.stream().map(BizLot::getId).collect(Collectors.toList());
                dayworks = bizDayworkService.query()
                        .in("id", dayworkIds)
                        .in("lot_id", lotIds)
                        .list();
            }
            if (dayworks.isEmpty())
                return success(new ArrayList<>());

            planDetailslanDetails = bizProductionPlanDetailService.query().in("id", dayworks.stream().map(BizDaywork::getProductionPlanDetailId).collect(Collectors.toList())).list();
            // 根据得到的 daywork 集合，将 daywork_id 整合到集合中
            List<Long> allDayworkIdList = dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList());
            // 再根据得到的daywork_id集合，获取所有的报工明细
            allDayworkItems = bizDayworkItemService.query().in("daywork_id", allDayworkIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList())).list();
            // 获取所有lotId
            List<Long> allLotsIdList = dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            lotList = bizLotService.query().in("id", allLotsIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
        }

        // 定义一个daywork空的list集合，用于存储符合条件（根据daywork的id，获得到对应的最新一条daywork_item，当该条daywork_item的状态值 < 5时，则添加）的daywork
        List<BizDaywork> dayworkList = new ArrayList<>();
        // 对之前获取到的 daywork 集合进行过滤，将符合条件的daywork，添加到dayworkList集合中
        for (BizDaywork item : dayworks) {
            if (!planDetailslanDetails.isEmpty()) {
                //设置尾批量
                item.setLastLotQuantity(planDetailslanDetails.stream().filter(v -> v.getId().equals(item.getProductionPlanDetailId())).collect(Collectors.toList()).get(0).getLastLotQuantity());
            }
            //添加批次单批量
            item.setOneLotQuantity(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getProductionQuantity());
            //拿到批次是否批废信息
            item.setIsWaste(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getIsWaste());
            // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
            // 原代码中对报工进行了按当前登录者user_id的判断，这样，就无法真实获取到当前批次的状态，而是当前登录者的报工状态。
            // 如果该批次是一个人操作的，则没有问题，如果是多人（邀请报工），通过user_id过滤后，就会出现状态不准的情况。
            // 所以需要将filter中，user_id过滤去掉
            /*
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()) && di.getUserId().equals(userId))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
             */
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
            // 获取最后一条报工明细
            BizDayworkItem latest = currentDayworkItems.get(0);
            // 获取最后一条非周转报工，通过过滤掉“4”状态的报工明细，获取到最新的一条非“4”状态的报工明细，避免后续的与 < 5 的条件冲突
            BizDayworkItem latestNoTurnover = currentDayworkItems.stream().filter(v -> v.getStatus().compareTo("4") < 0)
                    .max(Comparator.comparing(BizDayworkItem::getCreateTime)).orElse(new BizDayworkItem());
            BizDayworkItem latestProcess = currentDayworkItems.stream().filter(v -> v.getProcessStepNumber().equals(latestNoTurnover.getProcessStepNumber()) && v.getUserId().equals(userId)).findFirst().orElse(null);
            String status = currentDayworkItems.stream().filter(v -> v.getTechnologicalProcessDetailId().equals(latest.getTechnologicalProcessDetailId()))
                    .collect(Collectors.toList())
                    .get(0)
                    .getStatus();
            // 原程序中这里的判断条件是：user_id == 当前登录者user_id && status < 5，但这里不应该判断登录者user_id，而是直接判断状态值，
            // 因为，如果该批次是多人操作的，那么，该批次的报工状态，应该是所有人的，所以，这里不应该判断user_id
            // if (latest.getUserId().equals(userId) && Integer.parseInt(status) < 5) {

            // 判断最后一道报工记录的部门id，与当前登录者的部门id相同，并且状态 < 5
            // 状态 == 5 时，说明已经进入周转中，那么该条daywork，将不再页面中显示，所以，通过对status的值的判断，添加到daywork集合中
            // 最后一条非周转报工的工段为当前工段。
            //20240806添加isSpecial!=1将最新一条报工为特殊报工的批次删除
            if (!latestNoTurnover.getIsSpecial().equals(1) && latestNoTurnover.getDeptId().equals(deptId) && Integer.parseInt(status) < 5 && latestProcess != null) {
                // 获取当前操作者自己的报工记录
                List<BizDayworkItem> currentMyDayworkItems = myDayworkItems.stream()
                        .filter(di -> di.getDayworkId().equals(item.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .collect(Collectors.toList());
                // 将获取到的 day_work_item 集合，赋值给daywork中的相对应属性
                item.setDayworkItemList(currentMyDayworkItems);
                dayworkList.add(item);
            }
        }

        // 如果有报工数据
        if (!dayworkList.isEmpty()) {
            // 将符合条件（需要在页面展示的daywork）的 dayworkList 中的 technologicalProcessId，整合到一个List集合中，需要根据这些technologicalProcessId，获取到相应的工艺工序清单
            System.out.println("有报工数据:" + dayworkList);
            List<Long> technologicalProcessIds = dayworkList.stream()
                    .map(BizDaywork::getTechnologicalProcessId)
                    .collect(Collectors.toList());
            // 根据 technologicalProcessIds 获取符合条件的所有工艺工序清单
            List<BizTechnologicalProcessDetail> technologicalProcessDetails = bizTechnologicalProcessDetailService.query()
                    .in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9)
                    .list();
            // 将符合条件的所有工艺工序清单中的工序id（process_id），整合到一个List集合中
            List<Long> processIds = technologicalProcessDetails.stream()
                    .map(BizTechnologicalProcessDetail::getProcessId)
                    .collect(Collectors.toList());
            // 根据得到的工序id集合，获得相对应的工序集合
            List<BizTechnologicalProcessDetail> allTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9).list();
            List<Long> finalProcessIds = processIds;
            List<BizTechnologicalProcessDetail> processList = allTechnologicalProcessDetails.stream().filter(ap -> finalProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());

            // 将最终要显示的daywork集合中的daywork_id整合到一个List集合中，用于后续根据daywork_id获取对应的箱号
            List<Long> dayworkIdList = dayworkList.stream()
                    .map(BizDaywork::getId)
                    .collect(Collectors.toList());

            /* ****************************** 获取daywork 与 箱子 carrier 相关 ****************************** */
            // 根据daywork_id的集合，获取到所有daywork与箱子关联的中间表 biz_daywork_carrier，用于在循环中精确查询匹配的箱子
            List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query()
                    .eq("process_inspection_id", 0L)
                    .in("daywork_id", dayworkIdList)
                    .eq("is_changed", 0)
                    .list();
            // 将箱子的id整合到一个List集合中，用于循环中，进行箱子的查询
            List<Long> carrierIds = dayworkCarriers.stream()
                    .map(BizDayworkCarrier::getCarrierId)
                    .collect(Collectors.toList());
            // 根据箱子id的集合，获取所有的箱子集合
            List<BizCarrier> carriers = new ArrayList<>();
            if (!carrierIds.isEmpty()) {
                carriers = bizCarrierService.query().in("id", carrierIds).list();
            }

            /* ****************************** 获取与 daywork 相关的所有批次，为了获取每个批次中的投产数 ****************************** */
            // 直接通过daywork中的 technological_process_id 组成的集合，获取到对应的批次工艺工序清单，解决【正常】与【异常】冲突的问题
            List<Long> allTechnologicalProcessIds = dayworkList.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());

            List<BizLotTechnologicalProcessDetail> allLotTechnologicalDetails = bizLotTechnologicalProcessDetailService.query()
                    .in("lot_technological_process_id", allTechnologicalProcessIds)
                    .list();

            List<BizLotTechnologicalProcessDetail> technologicalDetailList = new ArrayList<>();

            /* ****************************** 获取 daywork 与 【材质】相关 ****************************** */
            List<BizFurnaceNoInfo> furnaceNoInfos = bizFurnaceNoInfoService.query()
                    .in("daywork_id", dayworkIdList)
                    .list();
            //查询计划单下所有的报工记录
            List<BizDayworkItem> totalDayworkItemList = bizDayworkItemService.query().eq("production_plan_detail_id", productionPlanDetailId).list();

            // 循环最终要展示的 daywork 集合，根据每个daywork，精确赋予相关数据
            List<Long> allLotIds = dayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            List<BizLot> allLots = bizLotService.query().in("id", allLotIds).list();
            List<Long> allDayworkIds = dayworkList.stream().map(BizDaywork::getId).collect(Collectors.toList());
            //查找被邀请者的id
            List<BizProductionResourceGroupDetail> protemResourceGroupDetail = bizProductionResourceGroupDetailService.query().in("protem_daywork_id", allDayworkIds.isEmpty() ? Collections.singletonList(0L) : allDayworkIds)
                    .eq("common_id", userId).eq("common_type", "person").list();
            List<Long> protemUserIds = protemResourceGroupDetail.stream().map(BizProductionResourceGroupDetail::getCreatorId).distinct().collect(Collectors.toList());
            protemUserIds.add(0L);
            List<SysUser> sysUsers = sysUserService.selectUserListByIds(protemUserIds);
            //查找dayworkList工段所在的车间
            List<Long> deptIds = dayworkList.stream().map(BizDaywork::getDeptId).collect(Collectors.toList());
            SysDept dept = new SysDept();
            dept.setDeptIds(deptIds);
            List<SysDept> sysDeptList = sysDeptService.selectDeptList(dept);
            List<Long> workshopIds = sysDeptList.stream().map(SysDept::getWorkshopId).collect(Collectors.toList());
            List<BizWorkshop> workshopList = bizWorkshopService.query().in("id", workshopIds).list();
            for (BizDaywork daywork : dayworkList) {
                //把批次的lot投产数量加到daywork里
                allLots.stream().filter(l -> l.getId().equals(daywork.getLotId()))
                        .findFirst()
                        .ifPresent(lot -> daywork.setProductionQuantity(lot.getProductionQuantity()));

                // 根据当前的 daywork 的 id，获取到 daywork_item 的集合，并根据 daywork_item 的 create_time 进行倒叙
                // 之所以通过时间倒叙，目的是在后续过程中，通过get(0)的方式，获得最新的一条报工记录
                List<BizDayworkItem> tempDayworkItems = totalDayworkItemList.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                daywork.setDayworkItemList(tempDayworkItems);
                /* ************************** 配置当前工段车间 ************************** */
                SysDept sysDept = sysDeptList.stream().filter(v -> v.getDeptId().equals(daywork.getDeptId())).findFirst().orElse(null);
                System.out.println("daywork："+daywork);
                System.out.println("车间列表输出："+sysDeptList);
                System.out.println("车间输出："+sysDept);
                System.out.println("workshopList："+workshopList);
                daywork.setWorkshopName(workshopList.stream().filter(w -> w.getId().equals(sysDept.getWorkshopId())).findFirst().orElse(null).getName());
                /* ************************** 获取【daywork】所匹配的材质 ************************** */
                BizFurnaceNoInfo furnaceNoInfo = furnaceNoInfos.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .findFirst()
                        .orElse(null);
                daywork.setFurnaceNoInfo(furnaceNoInfo);

                /* ************************** 以下是获取daywork对应的箱号 ************************** */
                // 首先获取到该 daywork 对应的箱子的中间表数据
                List<BizDayworkCarrier> dayworkCarrierList = dayworkCarriers.stream()
                        .filter(dc -> dc.getDayworkId().equals(daywork.getId()))
                        .collect(Collectors.toList());
                // 再将中间表中的箱子id整合到List集合中
                List<Long> carrierIdList = dayworkCarrierList.stream()
                        .map(BizDayworkCarrier::getCarrierId)
                        .collect(Collectors.toList());
                // 中间表中存储的箱子id（carrier_id），过滤获得到箱子的集合
                List<BizCarrier> carrierList = carriers.stream()
                        .filter(c -> carrierIdList.contains(c.getId()))
                        .collect(Collectors.toList());
                // 得到箱子的集合后，将所有箱子的编码，整合成一个用中文“，”分割的字符串
                String carrierCodes = carrierList.stream()
                        .map(BizCarrier::getCode)
                        .collect(Collectors.joining("，"));
                daywork.setCarrierName(carrierCodes);

                /* ************************** 以下是为了获得到所在区域 ************************** */
                //select  place from biz_daywork_item where deleted =0 and daywork_id = #{id} and status =7 order by create_time desc limit 1
                tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) == 7)
                        .max(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .ifPresent(tempDayworkItem -> daywork.setPlace(tempDayworkItem.getPlace()));

                /* ************************** 以下是为了获得到上一道工序 ************************** */
                //获得该批的工序
                //如果该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序
                    List<BizLotTechnologicalProcessDetail> lotTechnologicalDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .collect(Collectors.toList());
                    // 将符合条件的所有工序清单中的工序id（process_id），整合到一个List集合中
                    processIds = lotTechnologicalDetails.stream()
                            .map(BizLotTechnologicalProcessDetail::getProcessId)
                            .collect(Collectors.toList());
                    List<Long> tempProcessIds = processIds;
                    // 根据得到的工序id集合，获得相对应的工序集合
                    technologicalDetailList = allLotTechnologicalDetails.stream().filter(ap -> daywork.getTechnologicalProcessId().equals(ap.getLotTechnologicalProcessId()) && tempProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());
                }
                // daywork_item的status > 4，表示已经离开当前工段，至少是周转中的状态
                List<BizDayworkItem> finishedTempDayworkItems = tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) > 4)
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                if (!finishedTempDayworkItems.isEmpty()) {
                    BizProcess prevProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            prevProcess.setId(technologicalDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            prevProcess.setId(technologicalProcessDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    daywork.setPrevProcess(prevProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的当前工序 ************************** */
                // 如果集合不为空，则获取最后一次报工，对应的工序
                if (!tempDayworkItems.isEmpty()) {
                    BizProcess tempProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            tempProcess.setId(technologicalDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getTechnologicalProcessId().equals(tempDayworkItems.get(0).getTechnologicalProcessId()) && tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            tempProcess.setId(technologicalProcessDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    // 最新的一条报工记录对应的工序，就是当前批次的当前工序
                    daywork.setCurrentProcess(tempProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的工艺工序清单 ************************** */
                List<BizTechnologicalProcessDetail> currentDayworkProcessDetails = new ArrayList<>();
                List<BizLotTechnologicalProcessDetail> currentLotDayworkDetails = new ArrayList<>();
                //该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序(正序排列
                    currentLotDayworkDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .sorted(Comparator.comparing((BizLotTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                } else {
                    // 将上面获得到的工艺数据，通过当前工艺主表的id，获得到当前的工艺列表，并根据工序序号，进行正序排列
                    currentDayworkProcessDetails = technologicalProcessDetails.stream()
                            .filter(pd -> pd.getTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()) && pd.getTenantId() != 9)
                            .sorted(Comparator.comparing((BizTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                }

                /* ************************** 以下是为了获得当前 daywork 的 processSequence ************************** */
                List<BizProcess> processSequence = new ArrayList<>();
                //废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    for (BizLotTechnologicalProcessDetail detail : currentLotDayworkDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                } else {
                    for (BizTechnologicalProcessDetail detail : currentDayworkProcessDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                }
                /* ************************** 以下是为了获得当前登录这资源组信息，判断邀请报工 ************************** */
                if (!sysUsers.isEmpty()) {
                    List<BizProductionResourceGroupDetail> protemDetailList = protemResourceGroupDetail.stream().filter(item -> item.getProtemDayworkId().equals(daywork.getId())).collect(Collectors.toList());
                    protemDetailList.forEach(item -> {
                        item.setProtemCreatorName(sysUsers.stream().filter(label -> label.getUserId().equals(item.getCreatorId())).collect(Collectors.toList()).get(0).getNickName());
                    });
                    daywork.setProtemResourceGroupDetailList(protemDetailList);
                }

                /* ************************** 以下是为了获得当前 daywork 的下一道工序 ************************** */
                // 判断当前工段
                if (daywork.getCurrentProcess() != null) {
                    //废品回用
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        for (int i = 0; i < currentLotDayworkDetails.size(); i++) {
                            if ((currentLotDayworkDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    && currentLotDayworkDetails.get(i).getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber()))
                                    && (i + 1) < currentLotDayworkDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizLotTechnologicalProcessDetail tempDetail = currentLotDayworkDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    } else {
                        for (int i = 0; i < currentDayworkProcessDetails.size(); i++) {
                            if (currentDayworkProcessDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    &&
                                    (i + 1) < currentDayworkProcessDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizTechnologicalProcessDetail tempDetail = currentDayworkProcessDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    }
                }

                /* ************************** 以下是为了获得当前 daywork 的状态，用于前端显示 ************************** */
                //查询工段下工序有没有未周转的批次
                if (!daywork.getDayworkItemList().isEmpty()) {
                    boolean foundStatus3 = false;
                    boolean foundStatus2 = false;
                    boolean foundStatus1 = false;

                    for (BizDayworkItem item : daywork.getDayworkItemList()) {
                        if (daywork.getCurrentProcess() != null && item.getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber())) {
                            // 最后一道工序的工序步骤序号
                            String lastProcessStepNumber = "";
                            if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                                lastProcessStepNumber = currentLotDayworkDetails.get(currentLotDayworkDetails.size() - 1).getProcessStepNumber();
                            } else {
                                lastProcessStepNumber = currentDayworkProcessDetails.get(currentDayworkProcessDetails.size() - 1).getProcessStepNumber();
                            }
                            // 如果工序为工艺最后一道工序且工序完成 ，那么状态为4 工序完成
                            if ("3".equals(item.getStatus()) && item.getProcessStepNumber().equals(lastProcessStepNumber)) {
                                daywork.setStatus(4);
                                break;
                            }
                            //如果item状态为待周转那么批次报工状态为周转中
                            else if ("4".equals(item.getStatus())) {
                                daywork.setStatus(3);
                                foundStatus3 = true;
                            }
                            //如果item状态为3待周转那么批次报工状态为待周转
                            else if ("3".equals(item.getStatus()) && !foundStatus3) {
                                daywork.setStatus(2);
                                foundStatus2 = true;
                            }
                            //如果item状态为1,2进行中那么批次报工状态为进行中
                            else if (("1".equals(item.getStatus()) || "2".equals(item.getStatus())) && !foundStatus3 && !foundStatus2) {
                                daywork.setStatus(1);
                                foundStatus1 = true;
                            }
                        }

                        if (!foundStatus3 && !foundStatus2 && !foundStatus1) {
                            // 如果最新的 item 只有一条且状态是未开始，那么整个批次报工为未开始状态
                            if (daywork.getDayworkItemList().size() == 1 && daywork.getDayworkItemList().get(0).getStatus().equals("0")) {
                                daywork.setStatus(0);
                            }
                        }
                    }
                }
            }
        }
        return success(dayworkList);
    }
    @Transactional
    @GetMapping("/innerList")
    @Log(title = "获取报工列表", businessType = BusinessType.SELECT)
    public AjaxResult innerList(BizDaywork bizDaywork) {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        Long userId = user.getUserId();
        Long productionPlanDetailId = bizDaywork.getProductionPlanDetailId();
        Long deptId = bizDaywork.getDeptId();
        String keywords = bizDaywork.getKeywords();

        // 如果关键字不为空，则根据关键字匹配批次，后面会根据批次进行daywork过滤
        List<BizLot> lots = new ArrayList<>();
        if (!keywords.isEmpty()) {
            List<BizLot> lotList1 = bizLotService.query()
                    .like("lot_code", keywords)
                    .list();
            List<Long> dayworkCarrierIds = bizDayworkCarrierService.query().like("carrier_code", keywords).eq("process_inspection_id", 0L).eq("is_changed",0).list().stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList());
            List<BizDaywork> dayworkByCarriers = bizDayworkService.query().in("id", dayworkCarrierIds.isEmpty() ? Collections.singletonList(0L) : dayworkCarrierIds).list();
            List<BizLot> lotList2 = bizLotService.query().in("id", dayworkByCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkByCarriers.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
            Set<BizLot> uniqueSet = Stream.of(lotList1, lotList2)
                    .flatMap(Collection::stream)
                    .collect(Collectors.toSet());
            lots = uniqueSet.stream().collect(Collectors.toList());
            if (lots.isEmpty()) {
                return success(new ArrayList<>());
            }
        }
        // 获取当前用户的，针对当前部门以及当前生产计划下的报工集合
        List<BizDayworkItem> myDayworkItems = bizDayworkItemService.query()
                .eq("dept_id", deptId)
                .eq("production_plan_detail_id", productionPlanDetailId)
                .eq("user_id", userId)
                .list();
        List<BizProductionPlanDetail> planDetailslanDetails = new ArrayList<>();
        List<BizDaywork> dayworks = new ArrayList<>();
        // 定义一个所有的报工集合，用于后续接收所有的某个批次的报工记录
        List<BizDayworkItem> allDayworkItems = new ArrayList<>();
        List<BizLot> lotList = new ArrayList<>();
        if (!myDayworkItems.isEmpty()) {
            // 将报工记录中的daywork_id，整个到一个List集合中，用于后续的查询
            List<Long> dayworkIds = myDayworkItems.stream()
                    .map(BizDayworkItem::getDayworkId)
                    .collect(Collectors.toList());
            // 再根据整合后报工明细中对应的 daywork_id 的集合，获取到对应的 daywork 集合
            if (keywords.isEmpty())
                dayworks = bizDayworkService.query().in("id", dayworkIds).eq("dept_id", deptId).list();
            else if (!lots.isEmpty()) {
                List<Long> lotIds = lots.stream().map(BizLot::getId).collect(Collectors.toList());
                dayworks = bizDayworkService.query()
                        .in("id", dayworkIds)
                        .in("lot_id", lotIds)
                        .eq("dept_id", deptId)
                        .list();
            }
            if (dayworks.isEmpty())
                return success(new ArrayList<>());

            planDetailslanDetails = bizProductionPlanDetailService.query().in("id", dayworks.stream().map(BizDaywork::getProductionPlanDetailId).collect(Collectors.toList())).list();
            // 根据得到的 daywork 集合，将 daywork_id 整合到集合中
            List<Long> allDayworkIdList = dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList());
            // 再根据得到的daywork_id集合，获取所有的报工明细
            allDayworkItems = bizDayworkItemService.query().in("daywork_id", allDayworkIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList())).list();
            // 获取所有lotId
            List<Long> allLotsIdList = dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            lotList = bizLotService.query().in("id", allLotsIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
        }
        List<Long> outsourceOrderDetailIds = new ArrayList<>();
        for (BizDaywork item : dayworks) {
                BizDayworkItem lastDayworkItem = allDayworkItems.stream().filter(v -> v.getDayworkId().equals(item.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed())
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .findFirst().orElse(new BizDayworkItem());
                outsourceOrderDetailIds.add(lastDayworkItem.getOutsourceDetailId());
            };
        //收回单明细
        List<BizReturnReceiptDetail> returnReceiptDetailList = bizReturnReceiptDetailService.query().in("outsource_detail_id", outsourceOrderDetailIds).list();
        //发出单工序
        List<BizOutsourcedOrderDetailProcess> outsourcedDetailProcessList = bizOutsourcedOrderDetailProcessService.query().in("detail_id", outsourceOrderDetailIds).list();
        // 定义一个daywork空的list集合，用于存储符合条件（根据daywork的id，获得到对应的最新一条daywork_item，当该条daywork_item的状态值 < 5时，则添加）的daywork
        List<BizDaywork> dayworkList = new ArrayList<>();
        // 对之前获取到的 daywork 集合进行过滤，将符合条件的daywork，添加到dayworkList集合中
        for (BizDaywork item : dayworks) {
            if (!planDetailslanDetails.isEmpty()) {
                //设置尾批量
                item.setLastLotQuantity(planDetailslanDetails.stream().filter(v -> v.getId().equals(item.getProductionPlanDetailId())).collect(Collectors.toList()).get(0).getLastLotQuantity());
            }
            //如果内部外协有收回单，则不展示
            BizDayworkItem lastDayworkItem = allDayworkItems.stream().filter(v -> v.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed())
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .findFirst().orElse(new BizDayworkItem());
            List<BizReturnReceiptDetail> returnReceiptDetail = returnReceiptDetailList.stream().filter(v -> v.getOutsourceDetailId().equals(lastDayworkItem.getOutsourceDetailId())).collect(Collectors.toList());
            //添加批次单批量
            item.setOneLotQuantity(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getProductionQuantity());
            //拿到批次是否批废信息
            item.setIsWaste(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getIsWaste());
            // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
            // 原代码中对报工进行了按当前登录者user_id的判断，这样，就无法真实获取到当前批次的状态，而是当前登录者的报工状态。
            // 如果该批次是一个人操作的，则没有问题，如果是多人（邀请报工），通过user_id过滤后，就会出现状态不准的情况。
            // 所以需要将filter中，user_id过滤去掉
            /*
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()) && di.getUserId().equals(userId))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
             */
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
            // 获取最后一条报工明细
            BizDayworkItem latest = currentDayworkItems.get(0);
            // 获取最后一条非周转报工，通过过滤掉“4”状态的报工明细，获取到最新的一条非“4”状态的报工明细，避免后续的与 < 5 的条件冲突
            BizDayworkItem latestNoTurnover = currentDayworkItems.stream().filter(v -> v.getStatus().compareTo("4") < 0)
                    .max(Comparator.comparing(BizDayworkItem::getCreateTime)).orElse(new BizDayworkItem());
            BizDayworkItem latestProcess = currentDayworkItems.stream().filter(v -> v.getProcessStepNumber().equals(latestNoTurnover.getProcessStepNumber()) && v.getUserId().equals(userId)).findFirst().orElse(null);
            String status = currentDayworkItems.stream().filter(v -> v.getTechnologicalProcessDetailId().equals(latest.getTechnologicalProcessDetailId()))
                    .collect(Collectors.toList())
                    .get(0)
                    .getStatus();
            // 原程序中这里的判断条件是：user_id == 当前登录者user_id && status < 5，但这里不应该判断登录者user_id，而是直接判断状态值，
            // 因为，如果该批次是多人操作的，那么，该批次的报工状态，应该是所有人的，所以，这里不应该判断user_id
            // if (latest.getUserId().equals(userId) && Integer.parseInt(status) < 5) {

            // 判断最后一道报工记录的部门id，与当前登录者的部门id相同，并且状态 < 5
            // 状态 == 5 时，说明已经进入周转中，那么该条daywork，将不再页面中显示，所以，通过对status的值的判断，添加到daywork集合中
            // 最后一条非周转报工的工段为当前工段。
            //20240806添加isSpecial!=1将最新一条报工为特殊报工的批次删除
            if (!latestNoTurnover.getIsSpecial().equals(1) && latestNoTurnover.getDeptId().equals(deptId) && Integer.parseInt(status) < 5 && latestProcess != null && returnReceiptDetail.size() == 0) {
                // 获取当前操作者自己的报工记录
                List<BizDayworkItem> currentMyDayworkItems = myDayworkItems.stream()
                        .filter(di -> di.getDayworkId().equals(item.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .collect(Collectors.toList());
                // 将获取到的 day_work_item 集合，赋值给daywork中的相对应属性
                item.setDayworkItemList(currentMyDayworkItems);
                dayworkList.add(item);
            }
        }


        // 如果有报工数据
        if (!dayworkList.isEmpty()) {
            // 将符合条件（需要在页面展示的daywork）的 dayworkList 中的 technologicalProcessId，整合到一个List集合中，需要根据这些technologicalProcessId，获取到相应的工艺工序清单
            System.out.println("有报工数据:" + dayworkList);
            List<Long> technologicalProcessIds = dayworkList.stream()
                    .map(BizDaywork::getTechnologicalProcessId)
                    .collect(Collectors.toList());
            // 根据 technologicalProcessIds 获取符合条件的所有工艺工序清单
            List<BizTechnologicalProcessDetail> technologicalProcessDetails = bizTechnologicalProcessDetailService.query()
                    .in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9)
                    .list();
            // 将符合条件的所有工艺工序清单中的工序id（process_id），整合到一个List集合中
            List<Long> processIds = technologicalProcessDetails.stream()
                    .map(BizTechnologicalProcessDetail::getProcessId)
                    .collect(Collectors.toList());
            // 根据得到的工序id集合，获得相对应的工序集合
            List<BizTechnologicalProcessDetail> allTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9).list();
            List<Long> finalProcessIds = processIds;
            List<BizTechnologicalProcessDetail> processList = allTechnologicalProcessDetails.stream().filter(ap -> finalProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());

            // 将最终要显示的daywork集合中的daywork_id整合到一个List集合中，用于后续根据daywork_id获取对应的箱号
            List<Long> dayworkIdList = dayworkList.stream()
                    .map(BizDaywork::getId)
                    .collect(Collectors.toList());

            /* ****************************** 获取daywork 与 箱子 carrier 相关 ****************************** */
            // 根据daywork_id的集合，获取到所有daywork与箱子关联的中间表 biz_daywork_carrier，用于在循环中精确查询匹配的箱子
            List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query()
                    .eq("process_inspection_id", 0L)
                    .in("daywork_id", dayworkIdList)
                    .eq("is_changed", 0)
                    .list();
            // 将箱子的id整合到一个List集合中，用于循环中，进行箱子的查询
            List<Long> carrierIds = dayworkCarriers.stream()
                    .map(BizDayworkCarrier::getCarrierId)
                    .collect(Collectors.toList());
            // 根据箱子id的集合，获取所有的箱子集合
            List<BizCarrier> carriers = new ArrayList<>();
            if (!carrierIds.isEmpty()) {
                carriers = bizCarrierService.query().in("id", carrierIds).list();
            }

            /* ****************************** 获取与 daywork 相关的所有批次，为了获取每个批次中的投产数 ****************************** */
            // 直接通过daywork中的 technological_process_id 组成的集合，获取到对应的批次工艺工序清单，解决【正常】与【异常】冲突的问题
            List<Long> allTechnologicalProcessIds = dayworkList.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());

            List<BizLotTechnologicalProcessDetail> allLotTechnologicalDetails = bizLotTechnologicalProcessDetailService.query()
                    .in("lot_technological_process_id", allTechnologicalProcessIds)
                    .list();

            List<BizLotTechnologicalProcessDetail> technologicalDetailList = new ArrayList<>();

            /* ****************************** 获取 daywork 与 【材质】相关 ****************************** */
            List<BizFurnaceNoInfo> furnaceNoInfos = bizFurnaceNoInfoService.query()
                    .in("daywork_id", dayworkIdList)
                    .list();
            //查询计划单下所有的报工记录
            List<BizDayworkItem> totalDayworkItemList = bizDayworkItemService.query().eq("production_plan_detail_id", productionPlanDetailId).list();

            // 循环最终要展示的 daywork 集合，根据每个daywork，精确赋予相关数据
            List<Long> allLotIds = dayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            List<BizLot> allLots = bizLotService.query().in("id", allLotIds).list();
            List<Long> allDayworkIds = dayworkList.stream().map(BizDaywork::getId).collect(Collectors.toList());
            //查找被邀请者的id
            List<BizProductionResourceGroupDetail> protemResourceGroupDetail = bizProductionResourceGroupDetailService.query().in("protem_daywork_id", allDayworkIds.isEmpty() ? Collections.singletonList(0L) : allDayworkIds)
                    .eq("common_id", userId).eq("common_type", "person").list();
            List<Long> protemUserIds = protemResourceGroupDetail.stream().map(BizProductionResourceGroupDetail::getCreatorId).distinct().collect(Collectors.toList());
            protemUserIds.add(0L);
            List<SysUser> sysUsers = sysUserService.selectUserListByIds(protemUserIds);
            //查找dayworkList工段所在的车间
            List<Long> deptIds = dayworkList.stream().map(BizDaywork::getDeptId).collect(Collectors.toList());
            SysDept dept = new SysDept();
            dept.setDeptIds(deptIds);
            List<SysDept> sysDeptList = sysDeptService.selectDeptList(dept);
            List<Long> workshopIds = sysDeptList.stream().map(SysDept::getWorkshopId).collect(Collectors.toList());
            List<BizWorkshop> workshopList = bizWorkshopService.query().in("id", workshopIds).list();
            for (BizDaywork daywork : dayworkList) {
                //把批次的lot投产数量加到daywork里
                allLots.stream().filter(l -> l.getId().equals(daywork.getLotId()))
                        .findFirst()
                        .ifPresent(lot -> daywork.setProductionQuantity(lot.getProductionQuantity()));

                // 根据当前的 daywork 的 id，获取到 daywork_item 的集合，并根据 daywork_item 的 create_time 进行倒叙
                // 之所以通过时间倒叙，目的是在后续过程中，通过get(0)的方式，获得最新的一条报工记录
                List<BizDayworkItem> tempDayworkItems = totalDayworkItemList.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                daywork.setDayworkItemList(tempDayworkItems);
                /* ************************** 配置当前工段车间 ************************** */
                SysDept sysDept = sysDeptList.stream().filter(v -> v.getDeptId().equals(daywork.getDeptId())).findFirst().orElse(null);
                System.out.println("daywork："+daywork);
                System.out.println("车间列表输出："+sysDeptList);
                System.out.println("车间输出："+sysDept);
                System.out.println("workshopList："+workshopList);
                daywork.setWorkshopName(workshopList.stream().filter(w -> w.getId().equals(sysDept.getWorkshopId())).findFirst().orElse(null).getName());
                /* ************************** 获取【daywork】所匹配的材质 ************************** */
                BizFurnaceNoInfo furnaceNoInfo = furnaceNoInfos.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .findFirst()
                        .orElse(null);
                daywork.setFurnaceNoInfo(furnaceNoInfo);

                /* ************************** 以下是获取daywork对应的箱号 ************************** */
                // 首先获取到该 daywork 对应的箱子的中间表数据
                List<BizDayworkCarrier> dayworkCarrierList = dayworkCarriers.stream()
                        .filter(dc -> dc.getDayworkId().equals(daywork.getId()))
                        .collect(Collectors.toList());
                // 再将中间表中的箱子id整合到List集合中
                List<Long> carrierIdList = dayworkCarrierList.stream()
                        .map(BizDayworkCarrier::getCarrierId)
                        .collect(Collectors.toList());
                // 中间表中存储的箱子id（carrier_id），过滤获得到箱子的集合
                List<BizCarrier> carrierList = carriers.stream()
                        .filter(c -> carrierIdList.contains(c.getId()))
                        .collect(Collectors.toList());
                // 得到箱子的集合后，将所有箱子的编码，整合成一个用中文“，”分割的字符串
                String carrierCodes = carrierList.stream()
                        .map(BizCarrier::getCode)
                        .collect(Collectors.joining("，"));
                daywork.setCarrierName(carrierCodes);

                /* ************************** 以下是为了获得到所在区域 ************************** */
                //select  place from biz_daywork_item where deleted =0 and daywork_id = #{id} and status =7 order by create_time desc limit 1
                tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) == 7)
                        .max(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .ifPresent(tempDayworkItem -> daywork.setPlace(tempDayworkItem.getPlace()));

                /* ************************** 以下是为了获得到上一道工序 ************************** */
                //获得该批的工序
                //如果该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序
                    List<BizLotTechnologicalProcessDetail> lotTechnologicalDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .collect(Collectors.toList());
                    // 将符合条件的所有工序清单中的工序id（process_id），整合到一个List集合中
                    processIds = lotTechnologicalDetails.stream()
                            .map(BizLotTechnologicalProcessDetail::getProcessId)
                            .collect(Collectors.toList());
                    List<Long> tempProcessIds = processIds;
                    // 根据得到的工序id集合，获得相对应的工序集合
                    technologicalDetailList = allLotTechnologicalDetails.stream().filter(ap -> daywork.getTechnologicalProcessId().equals(ap.getLotTechnologicalProcessId()) && tempProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());
                }
                // daywork_item的status > 4，表示已经离开当前工段，至少是周转中的状态
                List<BizDayworkItem> finishedTempDayworkItems = tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) > 4)
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                if (!finishedTempDayworkItems.isEmpty()) {
                    BizProcess prevProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            prevProcess.setId(technologicalDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            prevProcess.setId(technologicalProcessDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    daywork.setPrevProcess(prevProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的当前工序 ************************** */
                // 如果集合不为空，则获取最后一次报工，对应的工序
                if (!tempDayworkItems.isEmpty()) {
                    BizProcess tempProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            tempProcess.setId(technologicalDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getTechnologicalProcessId().equals(tempDayworkItems.get(0).getTechnologicalProcessId()) && tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            tempProcess.setId(technologicalProcessDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    // 最新的一条报工记录对应的工序，就是当前批次的当前工序
                    daywork.setCurrentProcess(tempProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的工艺工序清单 ************************** */
                List<BizTechnologicalProcessDetail> currentDayworkProcessDetails = new ArrayList<>();
                List<BizLotTechnologicalProcessDetail> currentLotDayworkDetails = new ArrayList<>();
                //该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序(正序排列
                    currentLotDayworkDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .sorted(Comparator.comparing((BizLotTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                } else {
                    // 将上面获得到的工艺数据，通过当前工艺主表的id，获得到当前的工艺列表，并根据工序序号，进行正序排列
                    currentDayworkProcessDetails = technologicalProcessDetails.stream()
                            .filter(pd -> pd.getTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()) && pd.getTenantId() != 9)
                            .sorted(Comparator.comparing((BizTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                }

                /* ************************** 以下是为了获得当前 daywork 的 processSequence ************************** */
                List<BizProcess> processSequence = new ArrayList<>();
                //废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    for (BizLotTechnologicalProcessDetail detail : currentLotDayworkDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                } else {
                    for (BizTechnologicalProcessDetail detail : currentDayworkProcessDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                }
                /* ************************** 以下是为了获得当前登录这资源组信息，判断邀请报工 ************************** */
                if (!sysUsers.isEmpty()) {
                    List<BizProductionResourceGroupDetail> protemDetailList = protemResourceGroupDetail.stream().filter(item -> item.getProtemDayworkId().equals(daywork.getId())).collect(Collectors.toList());
                    protemDetailList.forEach(item -> {
                        item.setProtemCreatorName(sysUsers.stream().filter(label -> label.getUserId().equals(item.getCreatorId())).collect(Collectors.toList()).get(0).getNickName());
                    });
                    daywork.setProtemResourceGroupDetailList(protemDetailList);
                }

                /* ************************** 以下是为了获得当前 daywork 的下一道工序 ************************** */
                // 判断当前工段
                if (daywork.getCurrentProcess() != null) {
                    //废品回用
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        for (int i = 0; i < currentLotDayworkDetails.size(); i++) {
                            if ((currentLotDayworkDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    && currentLotDayworkDetails.get(i).getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber()))
                                    && (i + 1) < currentLotDayworkDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizLotTechnologicalProcessDetail tempDetail = currentLotDayworkDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    } else {
                        for (int i = 0; i < currentDayworkProcessDetails.size(); i++) {
                            if (currentDayworkProcessDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    &&
                                    (i + 1) < currentDayworkProcessDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizTechnologicalProcessDetail tempDetail = currentDayworkProcessDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    }
                }

                /* ************************** 以下是为了获得当前 daywork 的状态，用于前端显示 ************************** */
                //查询工段下工序有没有未周转的批次
                if (!daywork.getDayworkItemList().isEmpty()) {
                    boolean foundStatus3 = false;
                    boolean foundStatus2 = false;
                    boolean foundStatus1 = false;
                    daywork.setHasFinishOutsource(false);
                    //如果干完了发往外协的序，则不显示申请周转按钮
                    BizOutsourcedOrderDetailProcess lastOutsourcedOrderDetailProcess = outsourcedDetailProcessList.stream().filter(v -> v.getDayworkId().equals(daywork.getId())).sorted(Comparator.comparing(BizOutsourcedOrderDetailProcess::getProcessStepNumber).reversed()).findFirst().orElse(null);
                    if(daywork.getDayworkItemList().get(0).getProcessStepNumber().equals(lastOutsourcedOrderDetailProcess.getProcessStepNumber()) && daywork.getDayworkItemList().stream().filter(v -> v.getProcessStepNumber().equals(lastOutsourcedOrderDetailProcess.getProcessStepNumber())).anyMatch(l->l.getStatus().equals("3"))){
                        daywork.setHasFinishOutsource(true);
                    }

                    for (BizDayworkItem item : daywork.getDayworkItemList()) {
                        if (daywork.getCurrentProcess() != null && item.getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber())) {
                            // 最后一道工序的工序步骤序号
                            String lastProcessStepNumber = "";
                            if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                                lastProcessStepNumber = currentLotDayworkDetails.get(currentLotDayworkDetails.size() - 1).getProcessStepNumber();
                            } else {
                                lastProcessStepNumber = currentDayworkProcessDetails.get(currentDayworkProcessDetails.size() - 1).getProcessStepNumber();
                            }
                            // 如果工序为工艺最后一道工序且工序完成 ，那么状态为4 工序完成
                            if ("3".equals(item.getStatus()) && item.getProcessStepNumber().equals(lastProcessStepNumber)) {
                                daywork.setStatus(4);
                                break;
                            }
                            //如果item状态为待周转那么批次报工状态为周转中
                            else if ("4".equals(item.getStatus())) {
                                daywork.setStatus(3);
                                foundStatus3 = true;
                            }
                            //如果item状态为3待周转那么批次报工状态为待周转
                            else if ("3".equals(item.getStatus()) && !foundStatus3) {
                                daywork.setStatus(2);
                                foundStatus2 = true;
                            }
                            //如果item状态为1,2进行中那么批次报工状态为进行中
                            else if (("1".equals(item.getStatus()) || "2".equals(item.getStatus())) && !foundStatus3 && !foundStatus2) {
                                daywork.setStatus(1);
                                foundStatus1 = true;
                            }
                        }

                        if (!foundStatus3 && !foundStatus2 && !foundStatus1) {
                            // 如果最新的 item 只有一条且状态是未开始，那么整个批次报工为未开始状态
                            if (daywork.getDayworkItemList().size() == 1 && daywork.getDayworkItemList().get(0).getStatus().equals("0")) {
                                daywork.setStatus(0);
                            }
                        }
                    }
                }
            }
        }
        //如果报工记录最新的记录的isSort是1才返回
        List<BizDaywork> newList = new ArrayList<>();
        if(dayworkList.size()>0){
            dayworkList.stream().forEach(v->{
                if(v.getDayworkItemList().get(0).getIsSort() == 0){
                    newList.add(v);
                }
            });
        }
        return success(newList);
    }

    @Transactional
    @GetMapping("/innerSortList")
    @Log(title = "获取报工列表", businessType = BusinessType.SELECT)
    public AjaxResult innerSortList(BizDaywork bizDaywork) {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        Long userId = user.getUserId();
        Long productionPlanDetailId = bizDaywork.getProductionPlanDetailId();
        Long deptId = bizDaywork.getDeptId();
        String keywords = bizDaywork.getKeywords();

        // 如果关键字不为空，则根据关键字匹配批次，后面会根据批次进行daywork过滤
        List<BizLot> lots = new ArrayList<>();
        if (!keywords.isEmpty()) {
            List<BizLot> lotList1 = bizLotService.query()
                    .like("lot_code", keywords)
                    .list();
            List<Long> dayworkCarrierIds = bizDayworkCarrierService.query().like("carrier_code", keywords).eq("process_inspection_id", 0L).eq("is_changed",0).list().stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList());
            List<BizDaywork> dayworkByCarriers = bizDayworkService.query().in("id", dayworkCarrierIds.isEmpty() ? Collections.singletonList(0L) : dayworkCarrierIds).list();
            List<BizLot> lotList2 = bizLotService.query().in("id", dayworkByCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkByCarriers.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
            Set<BizLot> uniqueSet = Stream.of(lotList1, lotList2)
                    .flatMap(Collection::stream)
                    .collect(Collectors.toSet());
            lots = uniqueSet.stream().collect(Collectors.toList());
            if (lots.isEmpty()) {
                return success(new ArrayList<>());
            }
        }
        // 获取当前用户的，针对当前部门以及当前生产计划下的报工集合
        List<BizDayworkItem> myDayworkItems = bizDayworkItemService.query()
                .eq("dept_id", deptId)
                .eq("production_plan_detail_id", productionPlanDetailId)
                .eq("user_id", userId)
                .list();
        List<BizProductionPlanDetail> planDetailslanDetails = new ArrayList<>();
        List<BizDaywork> dayworks = new ArrayList<>();
        // 定义一个所有的报工集合，用于后续接收所有的某个批次的报工记录
        List<BizDayworkItem> allDayworkItems = new ArrayList<>();
        List<BizLot> lotList = new ArrayList<>();
        if (!myDayworkItems.isEmpty()) {
            // 将报工记录中的daywork_id，整个到一个List集合中，用于后续的查询
            List<Long> dayworkIds = myDayworkItems.stream()
                    .map(BizDayworkItem::getDayworkId)
                    .collect(Collectors.toList());
            // 再根据整合后报工明细中对应的 daywork_id 的集合，获取到对应的 daywork 集合
            if (keywords.isEmpty())
                dayworks = bizDayworkService.query().in("id", dayworkIds).eq("dept_id", deptId).list();
            else if (!lots.isEmpty()) {
                List<Long> lotIds = lots.stream().map(BizLot::getId).collect(Collectors.toList());
                dayworks = bizDayworkService.query()
                        .in("id", dayworkIds)
                        .in("lot_id", lotIds)
                        .eq("dept_id", deptId)
                        .list();
            }
            if (dayworks.isEmpty())
                return success(new ArrayList<>());

            planDetailslanDetails = bizProductionPlanDetailService.query().in("id", dayworks.stream().map(BizDaywork::getProductionPlanDetailId).collect(Collectors.toList())).list();
            // 根据得到的 daywork 集合，将 daywork_id 整合到集合中
            List<Long> allDayworkIdList = dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList());
            // 再根据得到的daywork_id集合，获取所有的报工明细
            allDayworkItems = bizDayworkItemService.query().in("daywork_id", allDayworkIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList())).list();
            // 获取所有lotId
            List<Long> allLotsIdList = dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            lotList = bizLotService.query().in("id", allLotsIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
        }
        List<Long> outsourceOrderDetailIds = new ArrayList<>();
        for (BizDaywork item : dayworks) {
            BizDayworkItem lastDayworkItem = allDayworkItems.stream().filter(v -> v.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed())
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .findFirst().orElse(new BizDayworkItem());
            outsourceOrderDetailIds.add(lastDayworkItem.getOutsourceDetailId());
        };
        //收回单明细
        List<BizReturnReceiptDetail> returnReceiptDetailList = bizReturnReceiptDetailService.query().in("outsource_detail_id", outsourceOrderDetailIds).list();
        //发出单工序
        List<BizOutsourcedOrderDetailProcess> outsourcedDetailProcessList = bizOutsourcedOrderDetailProcessService.query().in("detail_id", outsourceOrderDetailIds).list();
        // 定义一个daywork空的list集合，用于存储符合条件（根据daywork的id，获得到对应的最新一条daywork_item，当该条daywork_item的状态值 < 5时，则添加）的daywork
        List<BizDaywork> dayworkList = new ArrayList<>();
        // 对之前获取到的 daywork 集合进行过滤，将符合条件的daywork，添加到dayworkList集合中
        for (BizDaywork item : dayworks) {
            if (!planDetailslanDetails.isEmpty()) {
                //设置尾批量
                item.setLastLotQuantity(planDetailslanDetails.stream().filter(v -> v.getId().equals(item.getProductionPlanDetailId())).collect(Collectors.toList()).get(0).getLastLotQuantity());
            }
            //如果内部外协有收回单，则不展示
            BizDayworkItem lastDayworkItem = allDayworkItems.stream().filter(v -> v.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed())
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .findFirst().orElse(new BizDayworkItem());
            List<BizReturnReceiptDetail> returnReceiptDetail = returnReceiptDetailList.stream().filter(v -> v.getOutsourceDetailId().equals(lastDayworkItem.getOutsourceDetailId())).collect(Collectors.toList());
            //添加批次单批量
            item.setOneLotQuantity(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getProductionQuantity());
            //拿到批次是否批废信息
            item.setIsWaste(lotList.stream().filter(v -> v.getId().equals(item.getLotId())).collect(Collectors.toList()).get(0).getIsWaste());
            // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
            // 原代码中对报工进行了按当前登录者user_id的判断，这样，就无法真实获取到当前批次的状态，而是当前登录者的报工状态。
            // 如果该批次是一个人操作的，则没有问题，如果是多人（邀请报工），通过user_id过滤后，就会出现状态不准的情况。
            // 所以需要将filter中，user_id过滤去掉
            /*
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()) && di.getUserId().equals(userId))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
             */
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(item.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
            // 获取最后一条报工明细
            BizDayworkItem latest = currentDayworkItems.get(0);
            // 获取最后一条非周转报工，通过过滤掉“4”状态的报工明细，获取到最新的一条非“4”状态的报工明细，避免后续的与 < 5 的条件冲突
            BizDayworkItem latestNoTurnover = currentDayworkItems.stream().filter(v -> v.getStatus().compareTo("4") < 0)
                    .max(Comparator.comparing(BizDayworkItem::getCreateTime)).orElse(new BizDayworkItem());
            BizDayworkItem latestProcess = currentDayworkItems.stream().filter(v -> v.getProcessStepNumber().equals(latestNoTurnover.getProcessStepNumber()) && v.getUserId().equals(userId)).findFirst().orElse(null);
            String status = currentDayworkItems.stream().filter(v -> v.getTechnologicalProcessDetailId().equals(latest.getTechnologicalProcessDetailId()))
                    .collect(Collectors.toList())
                    .get(0)
                    .getStatus();
            // 原程序中这里的判断条件是：user_id == 当前登录者user_id && status < 5，但这里不应该判断登录者user_id，而是直接判断状态值，
            // 因为，如果该批次是多人操作的，那么，该批次的报工状态，应该是所有人的，所以，这里不应该判断user_id
            // if (latest.getUserId().equals(userId) && Integer.parseInt(status) < 5) {

            // 判断最后一道报工记录的部门id，与当前登录者的部门id相同，并且状态 < 5
            // 状态 == 5 时，说明已经进入周转中，那么该条daywork，将不再页面中显示，所以，通过对status的值的判断，添加到daywork集合中
            // 最后一条非周转报工的工段为当前工段。
            //20240806添加isSpecial!=1将最新一条报工为特殊报工的批次删除
            if (!latestNoTurnover.getIsSpecial().equals(1) && latestNoTurnover.getDeptId().equals(deptId) && Integer.parseInt(status) < 5 && latestProcess != null && returnReceiptDetail.size() == 0) {
                // 获取当前操作者自己的报工记录
                List<BizDayworkItem> currentMyDayworkItems = myDayworkItems.stream()
                        .filter(di -> di.getDayworkId().equals(item.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .collect(Collectors.toList());
                // 将获取到的 day_work_item 集合，赋值给daywork中的相对应属性
                item.setDayworkItemList(currentMyDayworkItems);
                dayworkList.add(item);
            }
        }


        // 如果有报工数据
        if (!dayworkList.isEmpty()) {
            // 将符合条件（需要在页面展示的daywork）的 dayworkList 中的 technologicalProcessId，整合到一个List集合中，需要根据这些technologicalProcessId，获取到相应的工艺工序清单
            System.out.println("有报工数据:" + dayworkList);
            List<Long> technologicalProcessIds = dayworkList.stream()
                    .map(BizDaywork::getTechnologicalProcessId)
                    .collect(Collectors.toList());
            // 根据 technologicalProcessIds 获取符合条件的所有工艺工序清单
            List<BizTechnologicalProcessDetail> technologicalProcessDetails = bizTechnologicalProcessDetailService.query()
                    .in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9)
                    .list();
            // 将符合条件的所有工艺工序清单中的工序id（process_id），整合到一个List集合中
            List<Long> processIds = technologicalProcessDetails.stream()
                    .map(BizTechnologicalProcessDetail::getProcessId)
                    .collect(Collectors.toList());
            // 根据得到的工序id集合，获得相对应的工序集合
            List<BizTechnologicalProcessDetail> allTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9).list();
            List<Long> finalProcessIds = processIds;
            List<BizTechnologicalProcessDetail> processList = allTechnologicalProcessDetails.stream().filter(ap -> finalProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());

            // 将最终要显示的daywork集合中的daywork_id整合到一个List集合中，用于后续根据daywork_id获取对应的箱号
            List<Long> dayworkIdList = dayworkList.stream()
                    .map(BizDaywork::getId)
                    .collect(Collectors.toList());

            /* ****************************** 获取daywork 与 箱子 carrier 相关 ****************************** */
            // 根据daywork_id的集合，获取到所有daywork与箱子关联的中间表 biz_daywork_carrier，用于在循环中精确查询匹配的箱子
            List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query()
                    .eq("process_inspection_id", 0L)
                    .in("daywork_id", dayworkIdList)
                    .eq("is_changed", 0)
                    .list();
            // 将箱子的id整合到一个List集合中，用于循环中，进行箱子的查询
            List<Long> carrierIds = dayworkCarriers.stream()
                    .map(BizDayworkCarrier::getCarrierId)
                    .collect(Collectors.toList());
            // 根据箱子id的集合，获取所有的箱子集合
            List<BizCarrier> carriers = new ArrayList<>();
            if (!carrierIds.isEmpty()) {
                carriers = bizCarrierService.query().in("id", carrierIds).list();
            }

            /* ****************************** 获取与 daywork 相关的所有批次，为了获取每个批次中的投产数 ****************************** */
            // 直接通过daywork中的 technological_process_id 组成的集合，获取到对应的批次工艺工序清单，解决【正常】与【异常】冲突的问题
            List<Long> allTechnologicalProcessIds = dayworkList.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());

            List<BizLotTechnologicalProcessDetail> allLotTechnologicalDetails = bizLotTechnologicalProcessDetailService.query()
                    .in("lot_technological_process_id", allTechnologicalProcessIds)
                    .list();

            List<BizLotTechnologicalProcessDetail> technologicalDetailList = new ArrayList<>();

            /* ****************************** 获取 daywork 与 【材质】相关 ****************************** */
            List<BizFurnaceNoInfo> furnaceNoInfos = bizFurnaceNoInfoService.query()
                    .in("daywork_id", dayworkIdList)
                    .list();
            //查询计划单下所有的报工记录
            List<BizDayworkItem> totalDayworkItemList = bizDayworkItemService.query().eq("production_plan_detail_id", productionPlanDetailId).list();

            // 循环最终要展示的 daywork 集合，根据每个daywork，精确赋予相关数据
            List<Long> allLotIds = dayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            List<BizLot> allLots = bizLotService.query().in("id", allLotIds).list();
            List<Long> allDayworkIds = dayworkList.stream().map(BizDaywork::getId).collect(Collectors.toList());
            //查找被邀请者的id
            List<BizProductionResourceGroupDetail> protemResourceGroupDetail = bizProductionResourceGroupDetailService.query().in("protem_daywork_id", allDayworkIds.isEmpty() ? Collections.singletonList(0L) : allDayworkIds)
                    .eq("common_id", userId).eq("common_type", "person").list();
            List<Long> protemUserIds = protemResourceGroupDetail.stream().map(BizProductionResourceGroupDetail::getCreatorId).distinct().collect(Collectors.toList());
            protemUserIds.add(0L);
            List<SysUser> sysUsers = sysUserService.selectUserListByIds(protemUserIds);
            //查找dayworkList工段所在的车间
            List<Long> deptIds = dayworkList.stream().map(BizDaywork::getDeptId).collect(Collectors.toList());
            SysDept dept = new SysDept();
            dept.setDeptIds(deptIds);
            List<SysDept> sysDeptList = sysDeptService.selectDeptList(dept);
            List<Long> workshopIds = sysDeptList.stream().map(SysDept::getWorkshopId).collect(Collectors.toList());
            List<BizWorkshop> workshopList = bizWorkshopService.query().in("id", workshopIds).list();
            for (BizDaywork daywork : dayworkList) {
                //把批次的lot投产数量加到daywork里
                allLots.stream().filter(l -> l.getId().equals(daywork.getLotId()))
                        .findFirst()
                        .ifPresent(lot -> daywork.setProductionQuantity(lot.getProductionQuantity()));

                // 根据当前的 daywork 的 id，获取到 daywork_item 的集合，并根据 daywork_item 的 create_time 进行倒叙
                // 之所以通过时间倒叙，目的是在后续过程中，通过get(0)的方式，获得最新的一条报工记录
                List<BizDayworkItem> tempDayworkItems = totalDayworkItemList.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                daywork.setDayworkItemList(tempDayworkItems);
                /* ************************** 配置当前工段车间 ************************** */
                SysDept sysDept = sysDeptList.stream().filter(v -> v.getDeptId().equals(daywork.getDeptId())).findFirst().orElse(null);
                System.out.println("daywork："+daywork);
                System.out.println("车间列表输出："+sysDeptList);
                System.out.println("车间输出："+sysDept);
                System.out.println("workshopList："+workshopList);
                daywork.setWorkshopName(workshopList.stream().filter(w -> w.getId().equals(sysDept.getWorkshopId())).findFirst().orElse(null).getName());
                /* ************************** 获取【daywork】所匹配的材质 ************************** */
                BizFurnaceNoInfo furnaceNoInfo = furnaceNoInfos.stream()
                        .filter(di -> di.getDayworkId().equals(daywork.getId()))
                        .findFirst()
                        .orElse(null);
                daywork.setFurnaceNoInfo(furnaceNoInfo);

                /* ************************** 以下是获取daywork对应的箱号 ************************** */
                // 首先获取到该 daywork 对应的箱子的中间表数据
                List<BizDayworkCarrier> dayworkCarrierList = dayworkCarriers.stream()
                        .filter(dc -> dc.getDayworkId().equals(daywork.getId()))
                        .collect(Collectors.toList());
                // 再将中间表中的箱子id整合到List集合中
                List<Long> carrierIdList = dayworkCarrierList.stream()
                        .map(BizDayworkCarrier::getCarrierId)
                        .collect(Collectors.toList());
                // 中间表中存储的箱子id（carrier_id），过滤获得到箱子的集合
                List<BizCarrier> carrierList = carriers.stream()
                        .filter(c -> carrierIdList.contains(c.getId()))
                        .collect(Collectors.toList());
                // 得到箱子的集合后，将所有箱子的编码，整合成一个用中文“，”分割的字符串
                String carrierCodes = carrierList.stream()
                        .map(BizCarrier::getCode)
                        .collect(Collectors.joining("，"));
                daywork.setCarrierName(carrierCodes);

                /* ************************** 以下是为了获得到所在区域 ************************** */
                //select  place from biz_daywork_item where deleted =0 and daywork_id = #{id} and status =7 order by create_time desc limit 1
                tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) == 7)
                        .max(Comparator.comparing(BizDayworkItem::getCreateTime))
                        .ifPresent(tempDayworkItem -> daywork.setPlace(tempDayworkItem.getPlace()));

                /* ************************** 以下是为了获得到上一道工序 ************************** */
                //获得该批的工序
                //如果该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序
                    List<BizLotTechnologicalProcessDetail> lotTechnologicalDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .collect(Collectors.toList());
                    // 将符合条件的所有工序清单中的工序id（process_id），整合到一个List集合中
                    processIds = lotTechnologicalDetails.stream()
                            .map(BizLotTechnologicalProcessDetail::getProcessId)
                            .collect(Collectors.toList());
                    List<Long> tempProcessIds = processIds;
                    // 根据得到的工序id集合，获得相对应的工序集合
                    technologicalDetailList = allLotTechnologicalDetails.stream().filter(ap -> daywork.getTechnologicalProcessId().equals(ap.getLotTechnologicalProcessId()) && tempProcessIds.contains(ap.getProcessId())).collect(Collectors.toList());
                }
                // daywork_item的status > 4，表示已经离开当前工段，至少是周转中的状态
                List<BizDayworkItem> finishedTempDayworkItems = tempDayworkItems.stream()
                        .filter(di -> Integer.parseInt(di.getStatus()) > 4)
                        .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                        .collect(Collectors.toList());
                if (!finishedTempDayworkItems.isEmpty()) {
                    BizProcess prevProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            prevProcess.setId(technologicalDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(finishedTempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            prevProcess.setId(technologicalProcessDetail.getProcessId());
                            prevProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            prevProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            prevProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    daywork.setPrevProcess(prevProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的当前工序 ************************** */
                // 如果集合不为空，则获取最后一次报工，对应的工序
                if (!tempDayworkItems.isEmpty()) {
                    BizProcess tempProcess = new BizProcess();
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        BizLotTechnologicalProcessDetail technologicalDetail = technologicalDetailList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalDetail != null) {
                            tempProcess.setId(technologicalDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalDetail.getProcessStepNumber());
                        }
                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = processList.stream()
                                // 通过get(0)的方式，获得最新的一条报工记录
                                .filter(tp -> tp.getTechnologicalProcessId().equals(tempDayworkItems.get(0).getTechnologicalProcessId()) && tp.getProcessStepNumber().equals(tempDayworkItems.get(0).getProcessStepNumber()))
                                .findFirst().orElse(null);
                        if (technologicalProcessDetail != null) {
                            tempProcess.setId(technologicalProcessDetail.getProcessId());
                            tempProcess.setProcessAlias(technologicalProcessDetail.getProcessAlias());
                            tempProcess.setProcessCode(technologicalProcessDetail.getProcessCode());
                            tempProcess.setProcessStepNumber(technologicalProcessDetail.getProcessStepNumber());
                        }
                    }
                    // 最新的一条报工记录对应的工序，就是当前批次的当前工序
                    daywork.setCurrentProcess(tempProcess);
                }

                /* ************************** 以下是为了获得当前 daywork 的工艺工序清单 ************************** */
                List<BizTechnologicalProcessDetail> currentDayworkProcessDetails = new ArrayList<>();
                List<BizLotTechnologicalProcessDetail> currentLotDayworkDetails = new ArrayList<>();
                //该批是废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    //如果是废品回用，则它的工序从biz_technology_waste_recycling表查
                    //拿到对应工艺id
                    //废品回用的工序(正序排列
                    currentLotDayworkDetails = allLotTechnologicalDetails.stream()
                            .filter(twrd -> twrd.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()))
                            .sorted(Comparator.comparing((BizLotTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                } else {
                    // 将上面获得到的工艺数据，通过当前工艺主表的id，获得到当前的工艺列表，并根据工序序号，进行正序排列
                    currentDayworkProcessDetails = technologicalProcessDetails.stream()
                            .filter(pd -> pd.getTechnologicalProcessId().equals(daywork.getTechnologicalProcessId()) && pd.getTenantId() != 9)
                            .sorted(Comparator.comparing((BizTechnologicalProcessDetail::getProcessStepNumber)))
                            .collect(Collectors.toList());
                }

                /* ************************** 以下是为了获得当前 daywork 的 processSequence ************************** */
                List<BizProcess> processSequence = new ArrayList<>();
                //废品回用
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    for (BizLotTechnologicalProcessDetail detail : currentLotDayworkDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                } else {
                    for (BizTechnologicalProcessDetail detail : currentDayworkProcessDetails) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                }
                /* ************************** 以下是为了获得当前登录这资源组信息，判断邀请报工 ************************** */
                if (!sysUsers.isEmpty()) {
                    List<BizProductionResourceGroupDetail> protemDetailList = protemResourceGroupDetail.stream().filter(item -> item.getProtemDayworkId().equals(daywork.getId())).collect(Collectors.toList());
                    protemDetailList.forEach(item -> {
                        item.setProtemCreatorName(sysUsers.stream().filter(label -> label.getUserId().equals(item.getCreatorId())).collect(Collectors.toList()).get(0).getNickName());
                    });
                    daywork.setProtemResourceGroupDetailList(protemDetailList);
                }

                /* ************************** 以下是为了获得当前 daywork 的下一道工序 ************************** */
                // 判断当前工段
                if (daywork.getCurrentProcess() != null) {
                    //废品回用
                    if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                        for (int i = 0; i < currentLotDayworkDetails.size(); i++) {
                            if ((currentLotDayworkDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    && currentLotDayworkDetails.get(i).getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber()))
                                    && (i + 1) < currentLotDayworkDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizLotTechnologicalProcessDetail tempDetail = currentLotDayworkDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    } else {
                        for (int i = 0; i < currentDayworkProcessDetails.size(); i++) {
                            if (currentDayworkProcessDetails.get(i).getProcessId().equals(daywork.getCurrentProcess().getId())
                                    &&
                                    (i + 1) < currentDayworkProcessDetails.size()) {
                                // 根据工艺单查询下一道工序
                                BizTechnologicalProcessDetail tempDetail = currentDayworkProcessDetails.get(i + 1);
                                BizProcess nextProcess = new BizProcess();
                                nextProcess.setId(tempDetail.getProcessId());
                                nextProcess.setProcessCode(tempDetail.getProcessCode());
                                nextProcess.setProcessAlias(tempDetail.getProcessAlias());
                                nextProcess.setProcessStepNumber(tempDetail.getProcessStepNumber());
                                daywork.setNextProcess(nextProcess);
                                // 先给一个默认的下道序
                                daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                            }
                        }
                    }
                }

                /* ************************** 以下是为了获得当前 daywork 的状态，用于前端显示 ************************** */
                //查询工段下工序有没有未周转的批次
                if (!daywork.getDayworkItemList().isEmpty()) {
                    boolean foundStatus3 = false;
                    boolean foundStatus2 = false;
                    boolean foundStatus1 = false;
                    daywork.setHasFinishOutsource(false);
                    //如果干完了发往外协的序，则不显示申请周转按钮
                    BizOutsourcedOrderDetailProcess lastOutsourcedOrderDetailProcess = outsourcedDetailProcessList.stream().filter(v -> v.getDayworkId().equals(daywork.getId())).sorted(Comparator.comparing(BizOutsourcedOrderDetailProcess::getProcessStepNumber).reversed()).findFirst().orElse(null);
                    if(daywork.getDayworkItemList().get(0).getProcessStepNumber().equals(lastOutsourcedOrderDetailProcess.getProcessStepNumber()) && daywork.getDayworkItemList().stream().filter(v -> v.getProcessStepNumber().equals(lastOutsourcedOrderDetailProcess.getProcessStepNumber())).anyMatch(l->l.getStatus().equals("3"))){
                        daywork.setHasFinishOutsource(true);
                    }

                    for (BizDayworkItem item : daywork.getDayworkItemList()) {
                        if (daywork.getCurrentProcess() != null && item.getProcessStepNumber().equals(daywork.getCurrentProcess().getProcessStepNumber())) {
                            // 最后一道工序的工序步骤序号
                            String lastProcessStepNumber = "";
                            if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                                lastProcessStepNumber = currentLotDayworkDetails.get(currentLotDayworkDetails.size() - 1).getProcessStepNumber();
                            } else {
                                lastProcessStepNumber = currentDayworkProcessDetails.get(currentDayworkProcessDetails.size() - 1).getProcessStepNumber();
                            }
                            // 如果工序为工艺最后一道工序且工序完成 ，那么状态为4 工序完成
                            if ("3".equals(item.getStatus()) && item.getProcessStepNumber().equals(lastProcessStepNumber)) {
                                daywork.setStatus(4);
                                break;
                            }
                            //如果item状态为待周转那么批次报工状态为周转中
                            else if ("4".equals(item.getStatus())) {
                                daywork.setStatus(3);
                                foundStatus3 = true;
                            }
                            //如果item状态为3待周转那么批次报工状态为待周转
                            else if ("3".equals(item.getStatus()) && !foundStatus3) {
                                daywork.setStatus(2);
                                foundStatus2 = true;
                            }
                            //如果item状态为1,2进行中那么批次报工状态为进行中
                            else if (("1".equals(item.getStatus()) || "2".equals(item.getStatus())) && !foundStatus3 && !foundStatus2) {
                                daywork.setStatus(1);
                                foundStatus1 = true;
                            }
                        }

                        if (!foundStatus3 && !foundStatus2 && !foundStatus1) {
                            // 如果最新的 item 只有一条且状态是未开始，那么整个批次报工为未开始状态
                            if (daywork.getDayworkItemList().size() == 1 && daywork.getDayworkItemList().get(0).getStatus().equals("0")) {
                                daywork.setStatus(0);
                            }
                        }
                    }
                }
            }
        }
        //如果报工记录最新的记录的isSort是1才返回
        List<BizDaywork> newList = new ArrayList<>();
        if(dayworkList.size()>0){
            dayworkList.stream().forEach(v->{
                if(v.getDayworkItemList().get(0).getIsSort() == 1){
                    newList.add(v);
                }
            });
        }
        return success(newList);
    }

    private void setAllDayworkItemsAndLots(List<BizDayworkItem> myDayworkItems, String keywords, List<BizDaywork> dayworks, List<BizDayworkItem> allDayworkItems, List<BizLot> lotList, List<BizLot> lots) {
        List<Long> dayworkIds = myDayworkItems.stream()
                .map(BizDayworkItem::getDayworkId)
                .collect(Collectors.toList());
        // 再根据整合后报工明细中对应的 daywork_id 的集合，获取到对应的 daywork 集合
        if (keywords.isEmpty())
            dayworks = bizDayworkService.query().in("id", dayworkIds).list();
        else if (!lots.isEmpty()) {
            List<Long> lotIds = lots.stream().map(BizLot::getId).collect(Collectors.toList());
            dayworks = bizDayworkService.query()
                    .in("id", dayworkIds)
                    .in("lot_id", lotIds)
                    .list();
        }
        // 根据得到的 daywork 集合，将 daywork_id 整合到集合中
        List<Long> allDayworkIdList = dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList());
        // 再根据得到的daywork_id集合，获取所有的报工明细
        allDayworkItems = bizDayworkItemService.query().in("daywork_id", allDayworkIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getId).collect(Collectors.toList())).list();
        //获取所有lotId
        List<Long> allLotsIdList = dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
        lotList = bizLotService.query().in("id", allLotsIdList.isEmpty() ? Collections.singletonList(0L) : dayworks.stream().map(BizDaywork::getLotId).collect(Collectors.toList())).list();
    }

    private void dayworkListAddItem(List<BizDaywork> dayworkList, BizDaywork daywork, List<BizLot> lotList, List<BizDayworkItem> allDayworkItems, List<BizDayworkItem> myDayworkItems) {
        //添加批次单批量
        daywork.setOneLotQuantity(lotList.stream().filter(v -> v.getId().equals(daywork.getLotId())).collect(Collectors.toList()).get(0).getProductionQuantity());
        //拿到批次是否批废信息
        daywork.setIsWaste(lotList.stream().filter(v -> v.getId().equals(daywork.getLotId())).collect(Collectors.toList()).get(0).getIsWaste());
        // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
        List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                .filter(di -> di.getDayworkId().equals(daywork.getId()))
                .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                .collect(Collectors.toList());
        // 获取最后一条报工明细
        BizDayworkItem latest = currentDayworkItems.get(0);
        String status = currentDayworkItems.stream().filter(v -> v.getTechnologicalProcessDetailId().equals(latest.getTechnologicalProcessDetailId()))
                .collect(Collectors.toList())
                .get(0)
                .getStatus();
        // 状态 == 5 时，说明已经进入周转中，那么该条daywork，将不再页面中显示，所以，通过对status的值的判断，添加到daywork集合中
        if (Integer.parseInt(status) < 5) {
            // 获取当前操作者自己的报工记录
            List<BizDayworkItem> currentMyDayworkItems = myDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(daywork.getId()))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime))
                    .collect(Collectors.toList());
            // 将获取到的 day_work_item 集合，赋值给daywork中的相对应属性
            daywork.setDayworkItemList(currentMyDayworkItems);
            dayworkList.add(daywork);
        }
    }

    /**
     * @param bizDaywork 查询条件
     * @return AjaxResult
     */
    @GetMapping("/selectProcessList")
    @Log(title = "报工批次工艺列表", businessType = BusinessType.SELECT)
    public AjaxResult selectProcessList(BizDaywork bizDaywork) {
        //查询计划单异常批
        if (!bizDaywork.getIsNormalLot()) {
            List<BizDaywork> abNormalList = bizDayworkService.query()
                    .eq("production_plan_detail_id", bizDaywork.getProductionPlanDetailId())
                    .eq("dept_id", bizDaywork.getDeptId())
                    .and(wrapper -> wrapper.eq("is_waste_recycling", 1).or().eq("is_amend", 1))
                    .list().stream().distinct().collect(Collectors.toList());
            List<Long> abNormalLotIds = abNormalList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            if (!abNormalLotIds.isEmpty()) {
                List<BizLotTechnologicalProcessDetail> abNormalTechnologicalProcessList = bizLotTechnologicalProcessDetailService.query()
                        .in("lot_id", abNormalLotIds)
                        .eq("deleted", 0)
                        .list();
                return success(abNormalTechnologicalProcessList);
            }
        }
        List<BizDaywork> normalList = bizDayworkService.query()
                .eq("production_plan_detail_id", bizDaywork.getProductionPlanDetailId())
                .eq("dept_id", bizDaywork.getDeptId())
                .eq("is_waste_recycling", 0)
                .eq("is_amend", 0)
                .list().stream().distinct().collect(Collectors.toList());
        List<Long> abNormalTechnologicalProcessIds = normalList.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
        if (!abNormalTechnologicalProcessIds.isEmpty()) {
            List<BizTechnologicalProcessDetail> normalTechnologicalProcessList = bizTechnologicalProcessDetailService.query()
                    .in("technological_process_id", abNormalTechnologicalProcessIds)
                    .ne("tenant_id", 9)
                    .eq("deleted", 0)
                    .list();
            return success(normalTechnologicalProcessList);
        }
        return error("没有批次");
    }

    /*
    public AjaxResult list(BizDaywork bizDaywork) {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDaywork.setUserId(user.getUserId());
        List<BizDaywork> dayworks = bizDayworkService.getList(bizDaywork);
        List<BizDaywork> dayworkList = new ArrayList<>();
        //把周转状态下的批次报工隐藏
        for (BizDaywork item : dayworks
        ) {
            BizDayworkItem latest = item.getDayworkItemList().get(0);
            //如果最新的一条是周转状态，则不显示
            if (Integer.parseInt(item.getDayworkItemList().stream().filter(v -> v.getTechnologicalProcessDetailId().equals(latest.getTechnologicalProcessDetailId())).collect(Collectors.toList()).get(0).getStatus()) < 5) {
                dayworkList.add(item);
            }
        }
        for (BizDaywork daywork : dayworkList) {
            //用于判断下一道非本工段工序
            boolean isShow = false;
            //判断当前工段
            if (daywork.getCurrentProcess() != null) {
                for (int i = 0; i < daywork.getProcessSequence().size(); i++) {
                    if (daywork.getProcessSequence().get(i).getId().equals(daywork.getCurrentProcess().getId())) {
                        //根据工艺单查询下一道工序
                        if ((i + 1) < daywork.getProcessSequence().size()) {
                            daywork.setNextProcess(daywork.getProcessSequence().get(i + 1));
                            //先给一个默认的下道序
                            daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias());
                        }
                    }

                }

                // 0226下一工段的第一道序禁用，改为查看工艺列表
//                Integer num = 0;
//                for (int i = 0; i < daywork.getProcessSequence().size(); i++) {
//                    //判断下个工序以后的工段工序
//                    if (daywork.getCurrentProcess().getId().equals(daywork.getProcessSequence().get(i).getId())){
//                        num = i+2;
//                    }
//                }
//
//                for (int i = num ; i < daywork.getProcessSequence().size(); i++
//                     ) {
//                    //查询出非本工段的第一道序
//                    if (i< daywork.getProcessSequence().size()){
//                        for (BizDeptProcess deptProcess: daywork.getProcessSequence().get(i).getDeptProcess()
//                        ) {
//
//                                if (!deptProcess.getDeptId().equals(daywork.getDeptId()) && !isShow){
//                                    if (daywork.getNextProcess() !=null){
//                                        daywork.setNextDeptProcess(daywork.getNextProcess().getProcessAlias() + "、" +deptProcess.getProcessAlias());
//                                        isShow = true;
//                                        break;
//                                    }
//
//                                }
//                        }
//                    }
//
//                }

            }
            //查询工段下工序有没有未周转的批次
            if (daywork.getDayworkItemList().size() > 0) {

                boolean foundStatus4 = false;
                boolean foundStatus3 = false;
                boolean foundStatus2 = false;
                boolean foundStatus1 = false;

                for (BizDayworkItem item : daywork.getDayworkItemList()) {
                    //如果工序为工艺最后一道工序且工序完成 ，那么状态为4 工序完成
                    if (daywork.getCurrentProcess() != null && item.getProcessId().equals(daywork.getCurrentProcess().getId())) {
                        if (item.getStatus().equals("3") && item.getProcessId().equals(daywork.getProcessSequence().get(daywork.getProcessSequence().size() - 1).getId())) {
                            daywork.setStatus(4);
                            foundStatus4 = true;
                            break;
                            //如果item状态为待周转那么批次报工状态为周转中
                        } else if (item.getStatus().equals("4") && !foundStatus4) {
                            daywork.setStatus(3);
                            foundStatus3 = true;
                            //如果item状态为3待周转那么批次报工状态为待周转
                        } else if (item.getStatus().equals("3") && !foundStatus3) {
                            daywork.setStatus(2);
                            foundStatus2 = true;
                            //如果item状态为1,2进行中那么批次报工状态为进行中
                        } else if ((item.getStatus().equals("1") || item.getStatus().equals("2")) && !foundStatus3 && !foundStatus2) {
                            daywork.setStatus(1);
                            foundStatus1 = true;
                        }
                    }

                    if (!foundStatus3 && !foundStatus2 && !foundStatus1) {
                        // 如果最新的 item 只有一条且状态是未开始，那么整个批次报工为未开始状态
                        if (daywork.getDayworkItemList().size() == 1 && daywork.getDayworkItemList().get(0).getStatus().equals("0")) {
                            daywork.setStatus(0);
                        }
                    }
                }
            }
        }

        return success(dayworkList);
    }
     */

    /**
     * 导出报工列表
     */
    //    @PreAuthorize("@ss.hasPermi('business:daywork:export')")
    @Log(title = "导出报工信息", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BizDaywork bizDaywork) throws NoSuchFieldException, IllegalAccessException {
        List<BizDaywork> list = bizDayworkService.getList(bizDaywork);
        ExcelUtil<BizDaywork> util = new ExcelUtil<BizDaywork>(BizDaywork.class);
        util.exportExcel(response, list, "报工数据");
    }

    @PostMapping("/getDayworkInfoById")
    @Log(title = "查询报工信息", businessType = BusinessType.SELECT)
    public AjaxResult getDayworkInfoById(@RequestBody BizDaywork bizDaywork) throws NoSuchFieldException, IllegalAccessException {
        List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().eq("daywork_id", bizDaywork.getId()).orderByDesc("process_step_number").list();
        List<BizDayworkItem> latestDayworkItem = dayworkItemList.stream().filter(item -> item.getProcessStepNumber().equals(dayworkItemList.get(0).getProcessStepNumber())).collect(Collectors.toList());
        List<BizEquipmentDetail> equipmentDetailList = new ArrayList<>();
        latestDayworkItem.forEach(item -> {
            BizEquipmentDetail equipmentDetail = new BizEquipmentDetail();
            equipmentDetail.setEquipmentId(item.getEquipmentDetailId());
            equipmentDetail.setEquipmentCode(item.getEquipmentDetailCode());
            equipmentDetailList.add(equipmentDetail);
        });
        bizDaywork = bizDayworkService.getDayworkInfoById(bizDaywork);
        bizDaywork.setEquipmentDetails(equipmentDetailList.stream().distinct().collect(Collectors.toList()));
        return success(bizDaywork);
    }

    /**
     * 获取报工详细信息
     */
    //    @PreAuthorize("@ss.hasPermi('business:daywork:query')")
    @GetMapping(value = "/{id}")
    @Log(title = "查询报工详细信息", businessType = BusinessType.SELECT)
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(bizDayworkService.getById(id));
    }

    /**
     * 新增报工
     */
    //    @PreAuthorize("@ss.hasPermi('business:daywork:add')")
    @Log(title = "新增报工", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping
    public AjaxResult add(@RequestBody BizDaywork bizDaywork) throws NoSuchFieldException, IllegalAccessException {
        System.out.println("新增报工数据：" + bizDaywork);
        if (bizDaywork.getId() == null) {
            //单批量
            BizLot bizLot = bizLotService.query().eq("lot_code", bizDaywork.getLotCode()).one();
            //查询出该生产计划的投产总批数
            Integer lotNumber = bizDayworkService.getLotNumber(bizDaywork.getProductionPlanDetailId());
            //查询出该生产计划的当前生产批数
            Integer getdayworkNum = bizDayworkService.getdayworkNum(bizDaywork.getProductionPlanDetailId());
            Integer num = (getdayworkNum != null) ? getdayworkNum.intValue() : 0; // 如果 dayworkNum 为 null，则赋值为默认值 0
            if (num < lotNumber || (bizDaywork.getIsWasteRecycling() == null ? false : bizDaywork.getIsWasteRecycling() == 1) || bizDaywork.getFromId() != 0 || bizDaywork.getIsSuperaddition() == 1) {
                //查询该批次号是否已经被领取
                List<BizDaywork> lotId = bizDayworkService.query().eq("lot_id", bizDaywork.getLotId()).list();
                if (!lotId.isEmpty()) {
                    return error("批次号已被领取");
                } else {
                    //查询出该工段下的工序
                    BizDeptProcess bizDeptProcess = new BizDeptProcess();
                    bizDeptProcess.setDeptId(bizDaywork.getDeptId());
                    BizLot lot = bizLotService.getById(bizDaywork.getLotId());
                    bizDaywork.setProductId(lot.getProductId());
                    //开始新批次的时候将daywork主表的status设置为1
                    bizDaywork.setStatus(1);
                    //不需要当前序
                    bizDayworkService.save(bizDaywork);
                    //保存炉号信息
                    if (bizDaywork.getFurnaceNoInfo() != null) {
                        bizDaywork.getFurnaceNoInfo().setDayworkId(bizDaywork.getId());
                        bizDaywork.getFurnaceNoInfo().setProductionPlanDetailId(bizDaywork.getProductionPlanDetailId());
                        bizFurnaceNoInfoService.save(bizDaywork.getFurnaceNoInfo());
                    }
                    /** 添加一条报工批次时生成一条未开始的Item */
                    BizDayworkItem bizDayworkItem = new BizDayworkItem();
                    bizDayworkItem.setDayworkId(bizDaywork.getId());
                    bizDayworkItem.setDeptId(bizDaywork.getDeptId());
                    bizDayworkItem.setProductionPlanDetailId(bizDaywork.getProductionPlanDetailId());
                    bizDayworkItem.setTechnologicalProcessId(bizDaywork.getTechnologicalProcessId());
                    bizDayworkItem.setQualifiedNum(bizDaywork.getProcessQualifiedNum());
                    bizDayworkItem.setProdNum(bizLot.getProductionQuantity());
                    bizDayworkItem.setProcessStepNumber(bizDaywork.getProcessStepNumber());
                    bizDayworkItem.setTenantId(bizDaywork.getTenantId());
                    /* 20230408修改 */
                    // 如果是修改，则取当前工序的工序详情
                    if ((bizDaywork.getIsAmend() != null || bizDaywork.getIsWasteRecycling() != null) && (bizDaywork.getIsAmend() == 1 || bizDaywork.getIsWasteRecycling() == 1)) {
                        BizLotTechnologicalProcessDetail lotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("process_id", bizDaywork.getProcessId()).eq("lot_technological_process_id", bizDaywork.getTechnologicalProcessId()).orderByAsc("process_step_number").last("limit 1").one();
                        bizDayworkItem.setTechnologicalProcessDetailId(lotTechnologicalProcessDetail.getId());

                    } else {
                        BizTechnologicalProcessDetail technologicalProcessDetail = bizTechnologicalProcessDetailService.query().eq("process_id", bizDaywork.getProcessId()).eq("technological_process_id", bizDaywork.getTechnologicalProcessId()).ne("tenant_id", 9).orderByAsc("process_step_number").last("limit 1").one();
                        bizDayworkItem.setTechnologicalProcessDetailId(technologicalProcessDetail.getId());
                    }

                    /* 20230408修改完成 */
                    SysUser user = SecurityUtils.getLoginUser().getUser();
                    bizDayworkItem.setUserId(user.getUserId());
                    bizDayworkItem.setUserName(user.getUserName());
                    bizDayworkItem.setNickName(user.getNickName());
                    bizDayworkItem.setLotId(bizDaywork.getLotId());
                    bizDayworkItem.setProcessId(bizDaywork.getProcessId());
                    return toAjax(bizDayworkItemService.save(bizDayworkItem));
                }

            } else {
                return error("当前计划单暂无新批次，请重新确认生产计划");
            }

        } else {
            /** 查询当前批次报工的载具，ischanged 为当前载具 */
            if (bizDaywork.getDayworkCarriers().isEmpty()) {
                return error("该批次未选择载具");
            }
            List<BizDayworkItem> currentItems = bizDayworkItemService.query().eq("daywork_id", bizDaywork.getId()).orderByDesc("create_time").list();
            // 校验铁箱不能不同计划单绑定同一个箱子,同一计划单不能绑定两个铁箱
            List<BizCarrier> carriers = bizCarrierService.query().in("id", bizDaywork.getDayworkCarriers().isEmpty() ? Collections.singletonList(0L) : bizDaywork.getDayworkCarriers().stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
            // 判断是否同时有蓝箱和铁箱
            List<BizCarrierCategory> categories = carrierCategoryService.query().in("id", carriers.isEmpty() ? Collections.singletonList(0L) : carriers.stream().map(BizCarrier::getCategoryId).collect(Collectors.toList())).list();
            if (categories.stream().anyMatch(v -> v.getIsAllowMore().equals(1)) && categories.stream().anyMatch(v -> v.getIsAllowMore().equals(0))) {
                return AjaxResult.error("不能同时绑定蓝箱和铁箱。");
            }
            int count = 0;
            for (BizDayworkCarrier item : bizDaywork.getDayworkCarriers()) {
                BizCarrier carrier = bizCarrierService.getOne(new QueryWrapper<BizCarrier>().eq("id", item.getCarrierId()));
                BizCarrierCategory carrierCategory = bizCarrierService.getCarrierCategory(carrier.getCategoryId());
                if (carrierCategory.getIsAllowMore() == 1) {
                    // 如果是铁箱,查询该铁箱下绑定的批次是否是同一批次
                    // 先查询该铁箱是够绑定了其他批次,并获取该批次计划单号
                    List<BizDayworkCarrier> carrierList =
                            bizDayworkCarrierService.query().eq("carrier_id", item.getCarrierId())
                                    .eq("is_changed", 0)
                                    .eq("process_inspection_id", 0L)
//                                    .last("and exists (select 1 from biz_daywork where biz_daywork.id = biz_daywork_carrier.daywork_id and biz_daywork.deleted = 0)")
                                    .list();
                    bizDayworkCarrierService.list(new QueryWrapper<BizDayworkCarrier>());
                    if (!carrierList.isEmpty()) {
                        BizDaywork daywork = bizDayworkService.getById(carrierList.get(0).getDayworkId());
                        List<BizDayworkItem> itemList = bizDayworkItemService.query().eq("daywork_id", daywork.getId()).orderByDesc("create_time").list();
                        if (!daywork.getProductionPlanDetailId().equals(bizDaywork.getProductionPlanDetailId()) || !currentItems.get(0).getTechnologicalProcessDetailId().equals(itemList.get(0).getTechnologicalProcessDetailId())) {
                            return error("当前存在绑定其他计划单/工序的铁箱,请重新选择");
                        }
                    }
                    count++;
                }
                if (count > 1) {
                    return error("同一计划单不能绑定两个铁箱");
                }
            }

            // 绑定
            for (BizDayworkCarrier item : bizDaywork.getDayworkCarriers()) {
                item.setDayworkId(bizDaywork.getId());
            }
            List<BizDayworkCarrier> oldList = bizDayworkCarrierService.query().eq("daywork_id", bizDaywork.getId()).eq("process_inspection_id", 0L).eq("is_changed", 0).list();
            return toAjax(saveOrUpdateCarrierBatch(bizDayworkCarrierService, bizDaywork.getDayworkCarriers(), oldList));
        }
    }

    @Log(title = "扫码查询批次信息", businessType = BusinessType.SELECT)
    @PostMapping("/getLotInformation")
    public AjaxResult getLotInformation(@RequestBody BizDaywork bizDaywork) {

        BizDaywork daywork = bizDayworkService.getLotInfo(bizDaywork);
        System.out.println("扫码查询批次信息：------------------------------------" + daywork);
        List<BizTechnologicalProcessDetail> normalTechnologicalProcessDetailList = new ArrayList<>();
        List<BizLotTechnologicalProcessDetail> abNormalTechnologicalProcessDetailList = new ArrayList<>();
        //最新的工序步骤
        String lastProcessStepNumber = daywork.getDayworkItemList().stream().sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed()).sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList()).get(0).getProcessStepNumber();
        List<BizDayworkItem> lastDayworkItemList = daywork.getDayworkItemList().stream().filter(info -> info.getProcessStepNumber().equals(lastProcessStepNumber)).collect(Collectors.toList());
        //当前设备
        daywork.setCurrentEquipmentCode(lastDayworkItemList.stream().sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList()).get(0).getEquipmentDetailCode());
        //当前操作者
        daywork.setCurrentNickName(lastDayworkItemList.stream().sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList()).get(0).getNickName());
        //合格数量
        daywork.setTotalQuantityNum(lastDayworkItemList.stream().filter(info -> info.getStatus().equals("1") || info.getStatus().equals("2") || info.getStatus().equals("3")).map(BizDayworkItem::getQualifiedNum).reduce(0, Integer::sum));
        if (daywork.getIsWasteRecycling() == 1 || daywork.getIsAmend() == 1) {
            abNormalTechnologicalProcessDetailList = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", daywork.getTechnologicalProcessId()).orderByAsc("process_step_number").list();
            List<BizProcess> processSequence = new ArrayList<>();
            for (BizLotTechnologicalProcessDetail detail : abNormalTechnologicalProcessDetailList) {
                BizProcess newProcess = new BizProcess();
                newProcess.setId(detail.getProcessId());
                newProcess.setProcessCode(detail.getProcessCode());
                newProcess.setProcessAlias(detail.getProcessAlias());
                newProcess.setTechnologicalProcessDetailId(detail.getId());
                newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                processSequence.add(newProcess);
            }
            daywork.setProcessSequence(processSequence);
            BizLotTechnologicalProcessDetail currentProcessDetail = abNormalTechnologicalProcessDetailList.stream().filter(info -> info.getProcessStepNumber().equals(lastProcessStepNumber)).collect(Collectors.toList()).get(0);
            BizProcess currentProcess = new BizProcess();
            currentProcess.setProcessStepNumber(lastProcessStepNumber);
            currentProcess.setProcessAlias(lastDayworkItemList.get(0).getProcessAlias());
            daywork.setCurrentProcess(currentProcess);
            //上一道序
            List<BizDayworkItem> filteredList = daywork.getDayworkItemList().stream()
                    .filter(info -> !info.getProcessStepNumber().equals(lastProcessStepNumber))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
            BizProcess prevProcess = new BizProcess();
            if (!filteredList.isEmpty()) {
                prevProcess.setProcessAlias(filteredList.get(0).getProcessAlias());
                daywork.setPrevProcess(prevProcess);
            }
            BizProcess nextProcess = new BizProcess();
            if (abNormalTechnologicalProcessDetailList.indexOf(currentProcessDetail) != abNormalTechnologicalProcessDetailList.size() - 1) {
                nextProcess.setProcessAlias(abNormalTechnologicalProcessDetailList.get(abNormalTechnologicalProcessDetailList.indexOf(currentProcessDetail) + 1).getProcessAlias());
                daywork.setNextProcess(nextProcess);
            }
        } else {
            normalTechnologicalProcessDetailList = bizTechnologicalProcessDetailService.query().eq("technological_process_id", daywork.getTechnologicalProcessId()).ne("tenant_id", 9).orderByAsc("process_step_number").list();
            List<BizProcess> processSequence = new ArrayList<>();
            for (BizTechnologicalProcessDetail detail : normalTechnologicalProcessDetailList) {
                BizProcess newProcess = new BizProcess();
                newProcess.setId(detail.getProcessId());
                newProcess.setProcessCode(detail.getProcessCode());
                newProcess.setProcessAlias(detail.getProcessAlias());
                newProcess.setTechnologicalProcessDetailId(detail.getId());
                newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                processSequence.add(newProcess);
            }
            daywork.setProcessSequence(processSequence);
            BizTechnologicalProcessDetail currentProcessDetail = normalTechnologicalProcessDetailList.stream().filter(info -> info.getProcessStepNumber().equals(lastProcessStepNumber)).collect(Collectors.toList()).get(0);
            BizProcess currentProcess = new BizProcess();
            currentProcess.setProcessStepNumber(lastProcessStepNumber);
            currentProcess.setProcessAlias(lastDayworkItemList.get(0).getProcessAlias());
            daywork.setCurrentProcess(currentProcess);
            //上一道序
            List<BizDayworkItem> filteredList = daywork.getDayworkItemList().stream()
                    .filter(info -> !info.getProcessStepNumber().equals(lastProcessStepNumber))
                    .sorted(Comparator.comparing(BizDayworkItem::getProcessStepNumber).reversed())
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());
            BizProcess prevProcess = new BizProcess();
            if (!filteredList.isEmpty()) {
                prevProcess.setProcessAlias(filteredList.get(0).getProcessAlias());
                daywork.setPrevProcess(prevProcess);
            }
            BizProcess nextProcess = new BizProcess();
            if (normalTechnologicalProcessDetailList.indexOf(currentProcessDetail) != normalTechnologicalProcessDetailList.size() - 1) {
                nextProcess.setProcessAlias(normalTechnologicalProcessDetailList.get(normalTechnologicalProcessDetailList.indexOf(currentProcessDetail) + 1).getProcessAlias());
                daywork.setNextProcess(nextProcess);
            }
        }
        daywork.setStatus(bizDayworkService.getStatus(daywork));
        return success(daywork);
    }

    @Transactional
    @PostMapping("/check")
    @Log(title = "检查报工载具", businessType = BusinessType.SELECT)
    public AjaxResult check(@RequestBody BizDaywork bizDaywork) {

        List<BizDayworkCarrier> list = bizDayworkCarrierService.query().eq("is_changed", 0).eq("daywork_id", bizDaywork.getId()).list();
        if (list.isEmpty()) {
            return error("该批次未绑定载具");
        }
        return success();
    }

    /**
     * 非手续扫码获取批次报工详细信息
     * 扫码开始新批次时，调用
     */
    //    @PreAuthorize("@ss.hasPermi('business:daywork:query')")
    @Transactional
    @Log(title = "扫码开始报工查询报工信息", businessType = BusinessType.SELECT)
    // @GetMapping(value = "/showDaywork")
    public AjaxResult getDayworkByCarrier(BizDayworkItem bizDayworkItem) {
        // 判断是否被领取
        List<BizCarrier> availableCarrierList = bizDayworkService.getAvailableCarrierList(new BizCarrier());
        List<BizCarrier> isReceived = availableCarrierList.stream().filter(item -> bizDayworkItem.getCarrierId().equals(item.getCarrierId())).collect(Collectors.toList());
        if (isReceived.isEmpty()) {
            return error("该批次已被领取");
        }
        /*
        根据前端传递的箱id和状态，查询daywork_item时，会匹配到同一批次下的多条daywork_item记录
        最终需要把重复的daywork排除掉，组成集合，返回给前端
         */
        List<BizDayworkItem> dayworkItemByCarrier = bizDayworkItemService.getDayworkItemByCarrier(bizDayworkItem);
        //1225一个箱可能在多个批次中
        BizDayworkItem lastItem = null;
        List<BizDayworkItem> newItemList = new ArrayList<>();
        //先根据批次号排序
        dayworkItemByCarrier = dayworkItemByCarrier.stream().sorted(Comparator.comparing(BizDayworkItem::getDayworkId)).collect(Collectors.toList());

        for (BizDayworkItem item : dayworkItemByCarrier) {
            //如果是同一批次的话保留该批次下最新的工序
            if (lastItem == null || !lastItem.getDayworkId().equals(item.getDayworkId())) {
                // 如果当前对象的dayworkId与上一个对象不同，则将上一个对象添加到新数组中
                newItemList.add(lastItem);
                lastItem = item;
            } else if (item.getCreateTime().after(lastItem.getCreateTime())) {
                //如果当前对象的dayworkId与上一个对象相同，但是创建时间更晚，则替换为更晚的对象
                lastItem = item;
            }
        }
        // dayworkItemByCarrier.get(0).setDaywork(daywork.get(0));

        // 将最后一个对象添加到新数组中
        if (lastItem != null) {
            newItemList.add(lastItem);
        }
        if (!newItemList.isEmpty()) {
            newItemList.remove(0);
        }

        return success(newItemList);
    }

    /**
     * 扫码获取批次报工详细信息
     *
     * @param bizDayworkItem
     * @return
     */
    @GetMapping(value = "/showDaywork")
    @Log(title = "扫码获取报工详细信息", businessType = BusinessType.SELECT)
    public AjaxResult getDayworkByCarrierId(BizDayworkItem bizDayworkItem) {
        try {
            // 根据箱号，获取箱子
            BizCarrier bizCarrier = bizCarrierService.query().eq("code", bizDayworkItem.getCarrierCode()).one();
            if (bizCarrier == null) {
                return error("该箱号不存在");
            }
            // 判断该批次是否已被领取
            // 获取该批次最后一条的状态
            List<BizDayworkCarrier> bizDayworkCarriers = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("carrier_id", bizCarrier.getId()).eq("is_changed", 0).list();
            if (bizDayworkCarriers.isEmpty()) {
                throw new RuntimeException("该载具未绑定任何批次！");
            }

            List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", bizDayworkCarriers.isEmpty()
                            ?
                            Collections.singletonList(0L)
                            :
                            bizDayworkCarriers.stream()
                                    .map(BizDayworkCarrier::getDayworkId)
                                    .collect(Collectors.toList())
                    )
                    .list();

            List<BizDayworkItem> allBizDayworkItem = bizDayworkItemService.query().in("daywork_id", bizDayworks.isEmpty() ? Collections.singletonList(0L) : bizDayworks.stream().map(BizDaywork::getId).collect(Collectors.toList())).orderByDesc("create_time").list();
            bizDayworks.forEach(l -> l.setDayworkItemList(allBizDayworkItem.stream().filter(v -> v.getDayworkId().equals(l.getId())).sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList())));
            List<BizDayworkItem> turnoverItems = new ArrayList<>();
            for (BizDaywork bizDaywork : bizDayworks) {
                if (bizDaywork.getDayworkItemList().get(0).getStatus().equals("4")
                        || bizDaywork.getDayworkItemList().get(0).getStatus().equals("5")
                        || bizDaywork.getDayworkItemList().get(0).getStatus().equals("7")) {
                    turnoverItems.add(bizDaywork.getDayworkItemList().get(0));
                }
            }
            if (!turnoverItems.isEmpty()) {
                BizDayworkItem conditions = new BizDayworkItem();
                conditions.setIds(turnoverItems.stream().map(BizDayworkItem::getId).collect(Collectors.toList()));
                List<BizDayworkItem> items = bizDayworkItemService.getList(conditions);
                //拿到生产计划id
                List<Long> productionPlanDetailIds = items.stream().map(BizDayworkItem::getProductionPlanDetailId).collect(Collectors.toList());
                List<BizProductionPlanDetail> bizProductionPlanDetails = bizProductionPlanDetailService.query().in("id", productionPlanDetailIds.isEmpty() ? Collections.singletonList(0L) : productionPlanDetailIds).list();
                //查找批次id
                List<Long> bizLotIds = bizDayworks.stream()
                        .filter(v -> v.getIsWasteRecycling() == 1 || v.getIsAmend() == 1)
                        .map(BizDaywork::getLotId).collect(Collectors.toList());
                List<Long> LotTechnologicalProcessesIds = bizLotService.query().in("id", bizLotIds.isEmpty() ? Collections.singletonList(0L) : bizDayworks.stream()
                        .filter(v -> v.getIsWasteRecycling() == 1 || v.getIsAmend() == 1)
                        .map(BizDaywork::getLotId).collect(Collectors.toList())).list().stream().map(BizLot::getTechnologicalProcessId).collect(Collectors.toList());
                //判断如果单批单改，废品回用，processSequence重新取
                List<BizDaywork> unNormalDaywork = bizDayworks.stream().filter(item -> item.getIsAmend() == 1 || item.getIsWasteRecycling() == 1).collect(Collectors.toList());
                List<BizLotTechnologicalProcessDetail> lotTechnologicalProcessList = new ArrayList<>();
                if(!unNormalDaywork.isEmpty()) {
                    List<Long> unTechnologicaProcessIds = unNormalDaywork.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
                    lotTechnologicalProcessList = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", unTechnologicaProcessIds).list();

                }
                List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", LotTechnologicalProcessesIds.isEmpty() ? Collections.singletonList(0L) : LotTechnologicalProcessesIds).list();
                for (BizDayworkItem item : items) {
                    //添加产品描述
                    item.setProductDescription(bizProductionPlanDetails.stream().filter(v -> v.getId().equals(item.getProductionPlanDetailId())).collect(Collectors.toList()).get(0).getProductDescription());
                    //如果不是正常批次，则工艺重新取
                    if (bizLotIds.contains(item.getLotId())) {
                        List<BizLotTechnologicalProcessDetail> processDetail = bizLotTechnologicalProcessDetails.stream().filter(v -> v.getLotTechnologicalProcessId().equals(item.getTechnologicalProcessId())).collect(Collectors.toList());
                        BizLotTechnologicalProcessDetail process = processDetail.stream().filter(v -> v.getProcessStepNumber().equals(item.getProcessStepNumber())).findFirst().orElse(null);
                        BizTechnologicalProcessDetail technologicalProcessDetail = new BizTechnologicalProcessDetail();
                        technologicalProcessDetail.setProcessAlias(process.getProcessAlias());
                        technologicalProcessDetail.setProcessCode(process.getProcessCode());
                        technologicalProcessDetail.setProductDescription(process.getProductDescription());
                        technologicalProcessDetail.setProcessStepNumber(process.getProcessStepNumber());
                        item.setTechnologicalProcessDetail(technologicalProcessDetail);
                    }
                    //给特殊批次重新赋值processSequence
                    if(item.getDaywork().getIsAmend() == 1 || item.getDaywork().getIsWasteRecycling() == 1) {
                        List<BizLotTechnologicalProcessDetail> currentDetails = lotTechnologicalProcessList.stream().filter(v -> v.getLotTechnologicalProcessId().equals(item.getDaywork().getTechnologicalProcessId())).collect(Collectors.toList());
                       List<BizProcess> processList = new ArrayList<>();
                        for (BizLotTechnologicalProcessDetail detail : currentDetails) {
                            BizProcess newProcess = new BizProcess();
                            newProcess.setId(detail.getProcessId());
                            newProcess.setProcessCode(detail.getProcessCode());
                            newProcess.setProcessAlias(detail.getProcessAlias());
                            newProcess.setTechnologicalProcessDetailId(detail.getId());
                            newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                            processList.add(newProcess);
                        }
                        item.setProcessSequence(processList);
                    }
                }
                return success(items);
            } else {
                return success(turnoverItems);
            }
        } catch (Exception e) {
            return error("箱子数据有误");
        }
    }


    /**
     * 非首序扫码添加批次
     */
    // @PreAuthorize("@ss.hasPermi('business:daywork:add')")
    @Log(title = "非首序扫码添加批次报工", businessType = BusinessType.INSERT)
    @Transactional
    // @PostMapping("/showDayworkSave")
    public AjaxResult showDaywork(@RequestBody List<BizDaywork> bizDaywork) {

        List<BizDayworkItem> list = new ArrayList<>();
        for (BizDaywork item : bizDaywork) {
            BizDaywork newDaywork = new BizDaywork();
            newDaywork.setId(item.getId());
            BizDaywork daywork = bizDayworkService.getList(newDaywork).get(0);

            /* 添加一条报工批次时生成一条未开始的Item */
            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(daywork.getId());
            bizDayworkItem.setProductionPlanDetailId(daywork.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessId(item.getTechnologicalProcessId());
            SysUser user = SecurityUtils.getLoginUser().getUser();
            bizDayworkItem.setUserId(user.getUserId());
            bizDayworkItem.setUserName(user.getUserName());
            bizDayworkItem.setNickName(user.getNickName());
            bizDayworkItem.setQualifiedNum(item.getProcessQualifiedNum());
            bizDayworkItem.setProdNum(item.getProcessQualifiedNum());
            // 0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(item.getProcessId());
            bizDayworkItem.setTechnologicalProcessDetailId(item.getTechnologicalProcessDetailId());
            bizDayworkItem.setDeptId(item.getDeptId());
            bizDayworkItem.setLotId(item.getLotId());
            list.add(bizDayworkItem);
        }
        return toAjax(bizDayworkItemService.saveBatch(list));
    }

    @Log(title = "保存信息报工", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/showDayworkSave")
    public AjaxResult addNewDayworkItem(@RequestBody List<BizDayworkItem> dayworkItemList) {
        // 新建报工明细
        List<BizDayworkItem> adds = new ArrayList<>();
        //dayworkID的所有报工
        List<BizDayworkItem> dayworkItemList1 = bizDayworkItemService.query().in("daywork_id", dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList())).list();
        // 更新报工明细
        List<BizDayworkItem> updates = new ArrayList<>();
        // 更新报工
        List<BizDaywork> updateDaywork = new ArrayList<>();
        dayworkItemList.forEach(l -> {
            int sum = dayworkItemList1.stream().filter(m -> m.getDayworkId().equals(l.getDayworkId()) && (m.getProcessStepNumber().equals(l.getProcessStepNumber())) && (("2".equals(m.getStatus())) || "3".equals(m.getStatus())))
                    .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                    .sum();
//             l.getDaywork().setProcessQualifiedNum(l.getProdNum());
//            l.getDaywork().setProcessQualifiedNum(sum);
            l.getDaywork().setProcessQualifiedNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            if (l.getStatus().equals("4")) {
                l.setStatus("7");
                updates.add(l);
                l.getDaywork().setDeptId(l.getDeptId());
            }
            if (l.getStatus().equals("7")) {
                BizDaywork daywork = l.getDaywork();
                daywork.setProtemProcessId(l.getProcessId());
                daywork.setProtemProcessStepNumber(l.getProcessStepNumber());
                // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
            }
            updateDaywork.add(l.getDaywork());

            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(l.getDayworkId());
            ;
            if (l.getDaywork().getIsAmend() == 1) {
                bizDayworkItem.setFormDayworkItemId(1L);
            }
            bizDayworkItem.setProcessStepNumber(l.getDaywork().getProcessStepNumber());
            bizDayworkItem.setProductionPlanDetailId(l.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessId(l.getDaywork().getTechnologicalProcessId());
            SysUser user = SecurityUtils.getLoginUser().getUser();
            bizDayworkItem.setUserId(user.getUserId());
            bizDayworkItem.setUserName(user.getUserName());
            bizDayworkItem.setProdNum(sum);
            bizDayworkItem.setNickName(user.getNickName());
            // 0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(l.getDaywork().getProcessId());
            bizDayworkItem.setTechnologicalProcessDetailId(l.getDaywork().getTechnologicalProcessDetailId());
            bizDayworkItem.setDeptId(l.getDeptId());
            bizDayworkItem.setIsSort(l.getIsSort());
            bizDayworkItem.setDeptName(l.getDeptName());
            bizDayworkItem.setLotId(l.getDaywork().getLotId());
            bizDayworkItem.setTenantId(l.getTenantId());
            adds.add(bizDayworkItem);
        });

        return toAjax((updates.isEmpty() || bizDayworkItemService.updateBatchById(updates)) && (updateDaywork.isEmpty() || bizDayworkService.updateBatchById(updateDaywork)) && bizDayworkItemService.saveBatch(adds));
    }
    @Log(title = "保存信息报工", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/showDayworkInnerSave")
    public AjaxResult addNewInnerDayworkItem(@RequestBody List<BizDayworkItem> dayworkItemList) {
        // 新建报工明细
        List<BizDayworkItem> adds = new ArrayList<>();
        //dayworkID的所有报工
        List<BizDayworkItem> dayworkItemList1 = bizDayworkItemService.query().in("daywork_id", dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList())).list();
        // 更新报工明细
        List<BizDayworkItem> updates = new ArrayList<>();
        // 更新报工
        List<BizDaywork> updateDaywork = new ArrayList<>();
        dayworkItemList.forEach(l -> {
            l.getDaywork().setProcessQualifiedNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            if (l.getStatus().equals("4")) {
                l.setStatus("7");
                updates.add(l);
                l.getDaywork().setDeptId(l.getDeptId());
            }
            if (l.getStatus().equals("7")) {
                BizDaywork daywork = l.getDaywork();
                daywork.setProtemProcessId(l.getProcessId());
                daywork.setProtemProcessStepNumber(l.getProcessStepNumber());
                // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
            }
            updateDaywork.add(l.getDaywork());

            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(l.getDayworkId());
            ;
            if (l.getDaywork().getIsAmend() == 1) {
                bizDayworkItem.setFormDayworkItemId(1L);
            }
            bizDayworkItem.setProcessStepNumber(l.getDaywork().getProcessStepNumber());
            bizDayworkItem.setProductionPlanDetailId(l.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessId(l.getDaywork().getTechnologicalProcessId());
            SysUser user = SecurityUtils.getLoginUser().getUser();
            bizDayworkItem.setUserId(user.getUserId());
            bizDayworkItem.setUserName(user.getUserName());
            bizDayworkItem.setProdNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            bizDayworkItem.setNickName(user.getNickName());
            // 0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(l.getDaywork().getProcessId());
            bizDayworkItem.setTechnologicalProcessDetailId(l.getDaywork().getTechnologicalProcessDetailId());
            bizDayworkItem.setDeptId(l.getDeptId());
            bizDayworkItem.setIsSort(l.getIsSort());
            bizDayworkItem.setDeptName(l.getDeptName());
            bizDayworkItem.setLotId(l.getDaywork().getLotId());
            bizDayworkItem.setOutsourceDetailId(l.getOutsourceDetailId());
            bizDayworkItem.setTenantId(l.getTenantId());
            bizDayworkItem.setIsWx(1);
            adds.add(bizDayworkItem);
        });

        return toAjax((updates.isEmpty() || bizDayworkItemService.updateBatchById(updates)) && (updateDaywork.isEmpty() || bizDayworkService.updateBatchById(updateDaywork)) && bizDayworkItemService.saveBatch(adds));
    }


    /**
     * 修改报工
     */
    // @PreAuthorize("@ss.hasPermi('business:daywork:edit')")
    @Log(title = "修改报工信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody BizDaywork bizDaywork) throws NoSuchFieldException, IllegalAccessException {
        return toAjax(bizDayworkService.updateById(bizDaywork));
    }


    /**
     * 删除报工
     */
    // @PreAuthorize("@ss.hasPermi('business:daywork:remove')")
    @Log(title = "删除报工信息", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable List<Long> ids) {
        return toAjax(bizDayworkService.removeBatchByIds(ids));
    }


    /**
     * 取消周转
     */
    // @PreAuthorize("@ss.hasPermi('business:daywork:remove')")
    @Log(title = "取消周转", businessType = BusinessType.DELETE)
    @DeleteMapping("/turnoverDelete")
    @Transactional
    public AjaxResult removeTurnover(@RequestBody BizDaywork bizDaywork) {
        // 先修改daywork 里面的部门id再删除
        BizDayworkItem item = bizDayworkItemService.query().eq("daywork_id", bizDaywork.getId())
                .eq("status", 3).orderByDesc("create_time").list().get(0);
        BizDaywork daywork = bizDayworkService.query().eq("id", bizDaywork.getId()).one();
        daywork.setDeptId(item.getDeptId());
        bizDayworkService.updateById(daywork);

        // 删除周转信息，删除所有周转箱关联的Item
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).eq("daywork_id", bizDaywork.getId()).list();
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
        List<BizDayworkItem> list = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).eq("status", 4).list();
        return toAjax(bizDayworkItemService.removeBatchByIds(list.stream().map(BizDayworkItem::getId).collect(Collectors.toList())));
    }
    @GetMapping("/getCarrierTotalList")
    public AjaxResult getCarrierTotalList(BizDaywork daywork) {
        startPage();
        List<BizDayworkItem> dayworkItemList = bizDayworkItemService.getTurnoverList(daywork);

        for (BizDayworkItem item : dayworkItemList) {
            if (item.getTurnoverArea() != null &&!item.getTurnoverArea().equals("车间内周转看place字段")) {
                item.setPlace(item.getTurnoverArea());
            }

        }
        return success(dayworkItemList);
    }


    @GetMapping("/getAvailableCarrierList")
    @Log(title = "获取可用载具列表", businessType = BusinessType.SELECT)
    public AjaxResult getAvailableCarrierList(BizCarrier carrier) {
        //根据工段，计划单，找到daywork
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query()
                .eq("production_plan_detail_id", carrier.getPlanDetailId())
                .eq("dept_id", carrier.getDeptId())
                .list();

        // 按daywork_id分组
        Map<Long, List<BizDayworkItem>> groupedByDayworkId = bizDayworkItemList.stream()
                .collect(Collectors.groupingBy(BizDayworkItem::getDayworkId));

        // 根据biz_daywork_item里的start_time字段倒序排序，取第一个，仅当状态为7时才保留
        List<BizDayworkItem> dayworkItemList = groupedByDayworkId.values().stream()
                .map(items -> {
                    items.sort(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()); // 在每个分组内按时间倒序排序
                    return items.get(0); // 获取排序后的第一条记录
                })
                .filter(item -> item.getStatus().compareTo("3")>0) // 仅保留状态为7的记录
                .collect(Collectors.toList());
        // 车间内周转dayworkItem
        List<BizDayworkItem> dayworkItemList1 = groupedByDayworkId.values().stream().filter(items -> {
            items.sort(Comparator.comparing(BizDayworkItem::getCreateTime).reversed());
            if (items.size() >= 2) {
                BizDayworkItem lastItem = items.get(0);
//                BizDayworkItem secondItem = items.stream().filter(v -> v.getStatus().compareTo("4") < 0).findFirst().orElse(new BizDayworkItem());
                return lastItem.getTurnoverType().equals("1") && (items.get(0).getStatus().equals("4") || items.get(0).getStatus().equals("7"));
            } else {
                return false;
            }
        }).map(items -> {
            items.sort(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()); // 在每个分组内按时间倒序排序
            return items.get(0); // 获取排序后的第一条记录
        }).collect(Collectors.toList());
        dayworkItemList.addAll(dayworkItemList1);
        dayworkItemList = dayworkItemList.stream().filter(CommonUtils.distinctByKey(BizDayworkItem::getId)).collect(Collectors.toList());
        //根据dayworkId，取daywork_carrier查箱号
        List<Long> dayworkIds = dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList());
        List<BizDaywork> dayworks = bizDayworkService.query().in("id", dayworkIds.isEmpty() ? Collections.singletonList(0L) : dayworkIds).list();
        dayworkItemList = dayworkItemList.stream().filter(v -> dayworks.stream().filter(e -> e.getId().equals(v.getDayworkId())).anyMatch(e -> e.getDeptId().equals(v.getDeptId()))).collect(Collectors.toList());
        dayworkIds = dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList());
        //正常批次列表
        List<BizDaywork> normalDayworkList = new ArrayList<>();
        //z正常批号
        List<Long> normalLotList = new ArrayList<>();
        //正常批次下工序
        List<BizTechnologicalProcessDetail> technologicalProcessDetailList = new ArrayList<>();
        //不正常批次的工序
        List<BizLotTechnologicalProcessDetail> lotTechnologicalProcessDetailList = new ArrayList<>();
        //批次绑定的载具
        List<BizDayworkCarrier> bizDayworkCarrier = new ArrayList<>();
        if (!dayworkIds.isEmpty()) {
            bizDayworkCarrier = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).in("daywork_id", dayworkIds).list();
            //查找所有批次
            List<BizDaywork> dayworkList = bizDayworkService.query().in("id", dayworkIds).list();
            //正常批次
            normalDayworkList = dayworkList.stream().filter(nd -> nd.getIsWasteRecycling() == 0 && nd.getIsAmend() == 0).collect(Collectors.toList());
            normalLotList = normalDayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            if (!normalDayworkList.isEmpty()) {
                List<Long> technologicalProcessIds = normalDayworkList.stream().map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
                technologicalProcessDetailList = bizTechnologicalProcessDetailService.query().in("technological_process_id", technologicalProcessIds).ne("tenant_id", 9).list();
            }
            //不正常批次
            List<BizDaywork> abNormalDayworkList = dayworkList.stream().filter(abnd -> abnd.getIsWasteRecycling() == 1 || abnd.getIsAmend() == 1).collect(Collectors.toList());
            List<Long> abNormalLotList = abNormalDayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
            if (!abNormalDayworkList.isEmpty()) {
                List<Long> abLots = abNormalDayworkList.stream().map(BizDaywork::getLotId).collect(Collectors.toList());
                lotTechnologicalProcessDetailList = bizLotTechnologicalProcessDetailService.query().in("lot_id", abLots).list();
            }
        }

        List<BizDayworkItem> list = new ArrayList<>();
        for (BizDayworkItem item : dayworkItemList) {
            if (!item.getTurnoverArea().equals("车间内周转看place字段")) {
                item.setPlace(item.getTurnoverArea());
            }
            List<BizProcess> processSequence = new ArrayList<>();
            String carrierCode = "";
            //分配日计划单
            item.setLotCode(bizLotService.query().eq("id", item.getLotId()).list().get(0).getLotCode());
            //分配没有完成的工序
            if (normalLotList.contains(item.getLotId())) {
                List<BizTechnologicalProcessDetail> collect = technologicalProcessDetailList.stream()
                        .filter(tpd -> tpd.getTechnologicalProcessId().equals(item.getTechnologicalProcessId()))
                        .filter(tpd -> tpd.getProcessStepNumber().compareTo(item.getProcessStepNumber()) > 0)
                        .sorted(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber))
                        .collect(Collectors.toList());
                for (BizTechnologicalProcessDetail info : collect) {
                    BizProcess bizProcess = new BizProcess();
                    bizProcess.setProcessAlias(info.getProcessAlias());
                    bizProcess.setProcessCode(info.getProcessCode());
                    bizProcess.setProcessStepNumber(info.getProcessStepNumber());
                    bizProcess.setId(info.getProcessId());
                    processSequence.add(bizProcess);
                }
                item.setProcessSequence(processSequence);
            } else {
                List<BizLotTechnologicalProcessDetail> collect = lotTechnologicalProcessDetailList.stream()
                        .filter(tpd -> tpd.getLotId().equals(item.getLotId()))
                        .filter(tpd -> tpd.getProcessStepNumber().compareTo(item.getProcessStepNumber()) > 0)
                        .sorted(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber))
                        .collect(Collectors.toList());
                for (BizLotTechnologicalProcessDetail info : collect) {
                    BizProcess bizProcess = new BizProcess();
                    bizProcess.setProcessAlias(info.getProcessAlias());
                    bizProcess.setProcessCode(info.getProcessCode());
                    bizProcess.setProcessStepNumber(info.getProcessStepNumber());
                    bizProcess.setId(info.getProcessId());
                    processSequence.add(bizProcess);
                }
                item.setProcessSequence(processSequence);
            }
            //分配箱号
            List<String> carrierList = bizDayworkCarrier.stream().filter(bdc -> bdc.getDayworkId().equals(item.getDayworkId())).map(BizDayworkCarrier::getCarrierCode).collect(Collectors.toList());
            carrierCode = carrierList.stream().collect(Collectors.joining("、"));
            item.setCarrierCode(carrierCode);
        }
        return success(dayworkItemList.stream().sorted(Comparator.comparing(BizDayworkItem::getLotCode)).collect(Collectors.toList()));
    }
}
