package cn.ezhizao.project.business.product.controller;

import cn.ezhizao.common.utils.SecurityUtils;
import cn.ezhizao.common.utils.bean.BeanUtils;
import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.project.business.inspection.domain.BizInspectionCategory;
import cn.ezhizao.project.business.inspection.domain.BizInspectionInstruction;
import cn.ezhizao.project.business.inspection.domain.BizProductInspectionInstruction;
import cn.ezhizao.project.business.inspection.service.IBizInspectionCategoryService;
import cn.ezhizao.project.business.inspection.service.IBizInspectionInstructionService;
import cn.ezhizao.project.business.inspection.service.IBizProductInspectionInstructionService;
import cn.ezhizao.project.business.outsource.domain.BizOutsourcedOrderDetailProcess;
import cn.ezhizao.project.business.outsource.service.IBizOutsourcedOrderDetailProcessService;
import cn.ezhizao.project.business.packageResourceGroup.domain.BizPackageResourceGroupDetail;
import cn.ezhizao.project.business.packageResourceGroup.service.IBizPackageResourceGroupDetailService;
import cn.ezhizao.project.business.process.domain.BizProcess;
import cn.ezhizao.project.business.process.service.IBizProcessService;
import cn.ezhizao.project.business.product.domain.*;
import cn.ezhizao.project.business.product.service.*;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupDetailService;
import cn.ezhizao.project.business.storageRetrieval.domain.BizStorageRetrieval;
import cn.ezhizao.project.business.storageRetrieval.service.IBizStorageRetrievalService;
import cn.ezhizao.project.business.technologicalProcess.domain.BizTechnologicalProcess;
import cn.ezhizao.project.business.technologicalProcess.service.IBizTechnologicalProcessService;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import cn.ezhizao.project.business.technologicalProcessDetailDrawing.domain.BizTechnologicalProcessDetailDrawing;
import cn.ezhizao.project.business.technologicalProcessDetailDrawing.service.IBizTechnologicalProcessDetailDrawingService;
import cn.ezhizao.project.system.domain.SysUser;
import cn.ezhizao.project.system.service.ISysUserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.context.annotation.Bean;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.management.Query;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

// 分选报工controller
@RestController
@RequestMapping("/business/sortDaywork")
public class SortDayworkController extends BaseController {
    @Resource
    private IBizDayworkItemService bizDayworkItemService;
    @Resource
    private IBizInspectionInstructionService bizInspectionInstructionService;
    @Resource
    private IBizDayworkItemConsultService bizDayworkItemConsultService;
    @Resource
    private IBizProductInspectionInstructionService bizProductInspectionInstructionService;
    @Resource
    private IBizDayworkItemRejectService bizDayworkItemRejectService;
    @Resource
    private IBizProductService productService;
    @Resource
    private IBizProductionPlanDetailService productionPlanDetailService;
    @Resource
    private IBizLotService bizLotService;
    @Resource
    private IBizDayworkService bizDayworkService;
    @Resource
    private IBizLotTechnologicalProcessDetailService bizLotTechnologicalProcessDetailService;
    @Resource
    private IBizTechnologicalProcessDetailService bizTechnologicalProcessDetailService;
    @Resource
    private IBizDayworkCarrierService bizDayworkCarrierService;
    @Resource
    private IBizLotTechnologicalProcessService bizLotTechnologicalProcessService;
    @Resource
    private IBizTechnologicalProcessService bizTechnologicalProcessService;
    @Resource
    private ISysUserService sysUserService;
    @Resource
    private IBizDayworkItemConsultPictureService bizDayworkItemConsultPictureService;
    @Resource
    private IBizCarrierService bizCarrierService;
    @Resource
    private IBizProductionResourceGroupDetailService bizProductionResourceGroupDetailService;
    @Resource
    private IBizPackageResourceGroupDetailService bizPackageResourceGroupDetailService;
    @Resource
    private IBizStorageRetrievalService bizStorageRetrievalService;
    @Resource
    private IBizProcessService bizProcessService;
    @Resource
    private IBizInspectionCategoryService bizInspectionCategoryService;
    @Resource
    private IBizTechnologicalProcessDetailDrawingService bizTechnologicalProcessDetailDrawingService;
    @Resource
    private IBizOutsourcedOrderDetailProcessService bizOutsourcedOrderDetailProcessService;
    // 修改报工状态为开始
    @PostMapping("/start")
    @Transactional
    @Log(title = "分选报工开始报工", businessType = BusinessType.UPDATE)
    public AjaxResult start(@RequestBody BizDaywork bizDaywork) {
        // 获取最新报工
        List<BizDayworkItem> items = bizDayworkItemService.query().eq("daywork_id", bizDaywork.getId()).orderByDesc("create_time").lt("status", "4").list();
        BizDaywork currentDaywork = bizDayworkService.getById(bizDaywork.getId());
        BizDayworkItem item = items.get(0);
        if (item.getStatus().equals("0")) {
            item.setStatus("1");
            item.setStartTime(new Date());
            item.setIsSort(1);
            bizDayworkItemService.updateById(item);
        }
        BizDayworkItem conditions = new BizDayworkItem();
        conditions.setId(item.getId());
        List<BizDayworkItem> firstList = bizDayworkItemService.getList(conditions);
        item = firstList.isEmpty() ? item : firstList.get(0);
        List<BizDayworkItemReject> rejectList = bizDayworkItemRejectService.query().eq("daywork_item_id", item.getId()).eq("process_inspection_id", 0L).list();
        item.setRejectList(rejectList);
        List<Long> dayworkItemIds = new ArrayList<>();
        dayworkItemIds.add(item.getId());
        List<BizDayworkItemConsult> consults = bizDayworkItemConsultService.getListByDayworkItemIds(dayworkItemIds);
        item.setConsults(consults);
        BizProductionPlanDetail productionPlanDetail = productionPlanDetailService.getById(item.getProductionPlanDetailId());
        BizProduct product = productService.getById(productionPlanDetail.getProductId());
        BizProcess process = bizProcessService.query().eq("id", item.getProcessId()).one();
        List<BizTechnologicalProcessDetailDrawing> technologicalProcessDetailDrawingList = bizTechnologicalProcessDetailDrawingService.query().eq("product_id", product.getId()).eq("process_code", process.getProcessCode()).orderByDesc("create_time").list();
        if(!technologicalProcessDetailDrawingList.isEmpty()){
            SysUser user = sysUserService.selectUserById(technologicalProcessDetailDrawingList.get(0).getCreatorId());
            item.setTechnicianName(user == null ? "" : user.getNickName());
            item.setTechnicianId(user == null ? 0L : user.getUserId());
        }else{
            item.setTechnicianName("");
            item.setTechnicianId(0L);
        }

        //零存零取
        List<BizStorageRetrieval> storageList = bizStorageRetrievalService.query().eq("lot_id", item.getLotId()).list();
        BizStorageRetrieval storage = new BizStorageRetrieval();
        if(!storageList.isEmpty()) {
            storage = storageList.get(0);
        }
        item.setStorageInfo(storage);
        List<BizStorageRetrieval> retrievalList = bizStorageRetrievalService.query().eq("retrieval_lot_id", item.getLotId()).list();
        item.setRetrievalInfo(retrievalList.isEmpty()?new ArrayList<>():retrievalList);
        return success(item);
    }

    @PostMapping("/getInspectionList")
    @Log(title = "获取分选报工列表", businessType = BusinessType.SELECT)
    public AjaxResult getInspectionList(@RequestBody BizDayworkItem bizDayworkItem) {
        Map<String, Object> map = new HashMap<>();
        //判断该报工是否是正常批次
        BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
        if(bizLot.getIsAmend() == 1 || bizLot.getIsWasteRecycling()==1) {
            //如果是废品回用或者是单批单改的批次，工艺id通过lot表的工艺版本和产品id找出来对应的工艺
            BizTechnologicalProcess bizTechnologicalProcess = bizTechnologicalProcessService.query().eq("technology_version", bizLot.getTechnologyVersion()).eq("product_id", bizLot.getProductId()).list().get(0);
            bizDayworkItem.setTechnologicalProcessId(bizTechnologicalProcess.getId());
        }
        // 查找所有该工序和产品对应的分选标准和检查指导书
        List<BizProductInspectionInstruction> list;

        if (bizDayworkItem.getKeywords() != null ) {
            // 如果 keywords 不为空或空字符串，则添加 LIKE 条件
            list = bizProductInspectionInstructionService.query()
                    .eq("product_id", bizLot.getProductId())
                    .eq("technology_version", bizLot.getTechnologyVersion())
                    .eq("process_code", bizDayworkItem.getProcessCode())
                    .like("standard", bizDayworkItem.getKeywords()) // 添加 LIKE 条件
                    .list();
        } else {
            // 如果 keywords 为空，则不添加 LIKE 条件
            list = bizProductInspectionInstructionService.query()
                    .eq("product_id", bizLot.getProductId())
                    .eq("technology_version", bizLot.getTechnologyVersion())
                    .eq("process_code", bizDayworkItem.getProcessCode())
                    .list();
        }
       // List<BizProductInspectionInstruction> list = bizProductInspectionInstructionService.query().eq("technological_process_id", bizDayworkItem.getTechnologicalProcessId()).eq("process_id", bizDayworkItem.getProcessId()).list();

        // 查询所有的分选标准
        List<BizInspectionInstruction> inspectionStandard = bizInspectionInstructionService.query().in("id", list.isEmpty() ? Collections.singletonList("0"): list.stream().map(BizProductInspectionInstruction::getInspectionInstructionId).collect(Collectors.toList())).eq("type", 1).list();
        // 查询所有的检查指导书
        List<BizInspectionInstruction> inspectionInstructions = bizInspectionInstructionService.query().in("id", list.isEmpty() ? Collections.singletonList("0"): list.stream().map(BizProductInspectionInstruction::getInspectionInstructionId).collect(Collectors.toList())).eq("type", 2).list();
        map.put("instructions", inspectionInstructions);
        map.put("standards", inspectionStandard);
        return success(map);
    }
    @PostMapping("getInstructionList")
    @Log(title = "获取分选报工选项列表", businessType = BusinessType.SELECT)
    public AjaxResult getInstructionList(@RequestBody BizDayworkItem bizDayworkItem) {
        BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
        List<BizProductInspectionInstruction> list = bizProductInspectionInstructionService.query()
                .eq("product_id", bizLot.getProductId())
                .eq("technology_version", bizLot.getTechnologyVersion())
                .eq("process_code", bizDayworkItem.getProcessCode())
                .eq("type", 1)
                .list();
        List<BizInspectionInstruction> inspectionInstructions = new ArrayList<>();
        list.forEach(item->{
            BizInspectionInstruction inspectionInstruction = new BizInspectionInstruction();
            inspectionInstruction.setId(item.getInspectionInstructionId());
            inspectionInstruction.setStandard(item.getStandard());
            inspectionInstruction.setType(1);
            inspectionInstructions.add(inspectionInstruction);
        });
        return success(inspectionInstructions);
    }
    @PostMapping("selectInstructionList")
    @Log(title = "分选报工列表", businessType = BusinessType.SELECT)
    public AjaxResult selectInstructionList(@RequestBody BizDayworkItem bizDayworkItem) {
        BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
        List<BizProductInspectionInstruction> list = bizProductInspectionInstructionService.query()
                .eq("product_id", bizLot.getProductId())
                .eq("technology_version", bizLot.getTechnologyVersion())
                .eq("process_code", bizDayworkItem.getProcessCode())
                .eq("type", 1)
                .list();
        if(list.size() >0){
            return success(true);
        }
        return success(false);
    }
    @GetMapping("/getStandardList")
    @Log(title = "获取分选报工检测标准列表", businessType = BusinessType.SELECT)
    public AjaxResult getStandardList(BizInspectionInstruction bizInspectionInstruction) {
        //分选标准
        List<BizInspectionCategory> list = bizInspectionCategoryService.query().eq("tenant_id", bizInspectionInstruction.getTenantId()).eq("type", 1).list();
        if(!list.isEmpty()){
            List<Long> categoryIds = list.stream().map(BizInspectionCategory::getId).collect(Collectors.toList());
            List<BizInspectionInstruction> inspectionInstructionList = bizInspectionInstructionService.query().in("category_id", categoryIds).list();
            if(!inspectionInstructionList.isEmpty()){
                inspectionInstructionList.forEach(item->{
                    item.setType(1);
                });
            }
            list.forEach(item->{
                item.setInstructionList(inspectionInstructionList.stream().filter(inspectionInstruction -> inspectionInstruction.getCategoryId().equals(item.getId())).collect(Collectors.toList()));
            });
        }
        return success(list);
    }

    @PostMapping("saveConsult")
    @Log(title = "保存分选报工咨询信息", businessType = BusinessType.SELECT)
    @Transactional
    public AjaxResult saveConsult(@RequestBody BizDayworkItemConsult bizDayworkItemConsult) {
            List<BizDayworkItemConsult> needAdd = new ArrayList<>();
            bizDayworkItemConsult.getDepartments().forEach(item ->{
                BizDayworkItemConsult consult = new BizDayworkItemConsult();
                BeanUtils.copyProperties(bizDayworkItemConsult,consult);
                consult.setConsultDepartment(item);
                needAdd.add(consult);
        });
            bizDayworkItemConsultService.saveBatch(needAdd);
            List<BizDayworkItemConsultPicture> pictures = new ArrayList<>();
            for(int i = 0;i<needAdd.size();i++) {
                for(int j = 0;j<bizDayworkItemConsult.getPictures().size();j++) {
                    BizDayworkItemConsultPicture consultPicture = new BizDayworkItemConsultPicture();
                    consultPicture.setDayworkItemConsultId(needAdd.get(i).getId());
                    consultPicture.setPictureName(bizDayworkItemConsult.getPictures().get(j).getPictureName());
                    consultPicture.setUrl(bizDayworkItemConsult.getPictures().get(j).getUrl());
                    pictures.add(consultPicture);
                }
            }
        bizDayworkItemConsultPictureService.saveBatch(pictures);
            List<BizDayworkItemConsult> bizDayworkItemConsults = bizDayworkItemConsultService.query().eq("daywork_item_id", bizDayworkItemConsult.getDayworkItemId()).list();
             List<Long> consultIds = bizDayworkItemConsults.stream().map(BizDayworkItemConsult::getId).collect(Collectors.toList());
        List<BizDayworkItemConsultPicture> consultPictures = bizDayworkItemConsultPictureService.query().in("daywork_item_consult_id", consultIds.isEmpty() ? Collections.singletonList("0") : consultIds).list();
        bizDayworkItemConsults.forEach(info ->{
            List<BizDayworkItemConsultPicture> pic = consultPictures.stream().filter(picture -> picture.getDayworkItemConsultId().equals(info.getId())).collect(Collectors.toList());
            info.setPictures(pic);
        });
        return success(bizDayworkItemConsults);
    }

    @PostMapping("update")
    @Log(title = "更新分选报工信息", businessType = BusinessType.SELECT)
    public AjaxResult update(@RequestBody BizDayworkItem bizDayworkItem) {
        BizDayworkItem item = bizDayworkItemService.getById(bizDayworkItem.getId());
        List<BizDayworkItemReject> rejectList = bizDayworkItem.getRejectList();
        BizDayworkItemReject delCondition = new BizDayworkItemReject();
        delCondition.setDayworkItemId(item.getId());
        bizDayworkItemRejectService.physicalDelete(delCondition);
        rejectList.forEach(l -> {
            l.setDayworkId(item.getDayworkId());
            l.setDayworkItemId(item.getId());
            l.setLotId(item.getLotId());
            l.setUserId(item.getUserId());
            l.setProductionPlanDetailId(item.getProductionPlanDetailId());
            l.setProductionPlanDetailSubDetailId(item.getProductionPlanDetailSubDetailId());
            l.setReason(l.getReason());
        });
        boolean result = rejectList.isEmpty() || bizDayworkItemRejectService.saveBatch(rejectList);
        item.setRejectNum(bizDayworkItem.getRejectNum());
        item.setRejectSum(bizDayworkItem.getRejectSum());
        item.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        item.setRemark(bizDayworkItem.getRemark());
        item.setIsSort(1);
        result = result && bizDayworkItemService.updateById(item);
        //零存
        //判断该批次是否存过
        List<BizStorageRetrieval> storage = bizStorageRetrievalService.query().eq("lot_id",item.getLotId()).list();
        Optional.ofNullable(bizDayworkItem.getStorageInfo())
                .ifPresent(storageInfo -> {
                    // 对象不为空，执行操作
                    if(storage.isEmpty()) {
                        //新增
                        bizStorageRetrievalService.save(bizDayworkItem.getStorageInfo());
                    }
                });
        //零取
        if( bizDayworkItem.getRetrievalInfo().size() > 0){
            List<BizStorageRetrieval> needUpdate = bizDayworkItem.getRetrievalInfo().stream().filter(v -> v.getStatus() == 0).collect(Collectors.toList());
            if(!needUpdate.isEmpty()) {
                needUpdate.forEach(l -> l.setStatus(1));
                bizStorageRetrievalService.updateBatchById(needUpdate);
            }
        }

        return result ? success() : error("保存失败");
    }

    @PostMapping("finish")
    @Log(title = "结束分选报工", businessType = BusinessType.SELECT)
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult finish(@RequestBody BizDayworkItem bizDayworkItem) {
        BizDayworkItem item = bizDayworkItemService.getById(bizDayworkItem.getId());
        BizDayworkItemReject delCondition = new BizDayworkItemReject();
        delCondition.setDayworkItemId(item.getId());
        bizDayworkItemRejectService.physicalDelete(delCondition);
        List<BizDayworkItemReject> rejectList = bizDayworkItem.getRejectList();
        rejectList.forEach(l -> {
            l.setDayworkId(item.getDayworkId());
            l.setDayworkItemId(item.getId());
            l.setLotId(item.getLotId());
            l.setUserId(item.getUserId());
            l.setProductionPlanDetailId(item.getProductionPlanDetailId());
            l.setProductionPlanDetailSubDetailId(item.getProductionPlanDetailSubDetailId());
            l.setReason(l.getReason());
            l.setDeptId(item.getDeptId());
            l.setProcessId(item.getProcessId());
        });
        boolean result = rejectList.isEmpty() || bizDayworkItemRejectService.saveBatch(rejectList);
        BizProcess process = bizProcessService.query().eq("id", item.getProcessId()).one();
        Long packageLineId = bizPackageResourceGroupDetailService.query().eq("user_id", item.getUserId()).list().stream().findFirst().orElse(new BizPackageResourceGroupDetail()).getPackageResourceGroupId();
        item.setRejectNum(bizDayworkItem.getRejectNum());
        item.setRejectSum(bizDayworkItem.getRejectSum());
        item.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        item.setRemark(bizDayworkItem.getRemark());
        if(item.getStartTime() == null){
            item.setStartTime(new Date());
        }
        item.setStatus("3");
        item.setEndTime(new Date());
        item.setIsSort(1);
        item.setWorkingHours(item.getEndTime().getTime() - item.getStartTime().getTime());
        boolean returnCarrier;
        boolean isLatest;
        BizDaywork bizDaywork = bizDayworkService.getById(item.getDayworkId());
        bizDaywork.setTemporaryProcessQualifiedNum(bizDayworkItem.getQualifiedNum());
        if (bizDaywork.getIsAmend().equals(1) || bizDaywork.getIsWasteRecycling().equals(1)) {
//            List<BizLotTechnologicalProcess> processes = bizLotTechnologicalProcessService.query().eq("lot_id", bizDaywork.getLotId()).list();
//            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", processes.stream().map(BizLotTechnologicalProcess::getId).collect(Collectors.toList())).list();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber());
//                    item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)));
            isLatest = bizLotTechnologicalProcessDetails.stream().sorted(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber).reversed()).collect(Collectors.toList()).get(0).getProcessStepNumber().equals(item.getProcessStepNumber());
        } else {
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().ne("tenant_id", 9).eq("technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizTechnologicalProcessDetails.stream().max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber());
            isLatest = bizTechnologicalProcessDetails.stream().sorted(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber).reversed()).collect(Collectors.toList()).get(0).getProcessStepNumber().equals(item.getProcessStepNumber());
        }
        if(isLatest) {
            bizDaywork.setIsCertificate(1);
            bizDaywork.setPackageResourceGroupId(packageLineId);
            //包装线的所有员工
            String packageResourceGroupDetailUserIds = bizPackageResourceGroupDetailService.query().eq("package_resource_group_id", packageLineId).list().stream()
                    .map(BizPackageResourceGroupDetail::getUserId)
                    .map(Object::toString)
                    .collect(Collectors.joining(","));
            item.setPackageResourceGroupId(packageLineId);
            item.setPackageResourceGroupDetailUserId(packageResourceGroupDetailUserIds);
        }
        result = result && bizDayworkItemService.updateById(item);
        //解绑设备，将daywork状态设置为完成
        if (returnCarrier) {
            List<BizDayworkCarrier> bizDayworkCarriers = bizDayworkCarrierService.query().eq("daywork_id", item.getDayworkId()).eq("process_inspection_id", 0L).eq("is_changed", 0).list();
            bizDayworkCarriers.forEach(l -> {
                l.setIsChanged(1);
            });
            //最后一道序结束报工的时候，将daywork主表的status设置为2
            bizDaywork.setStatus(2);
            result = result && (bizDayworkCarriers.isEmpty() || bizDayworkCarrierService.updateBatchById(bizDayworkCarriers));
        }
        bizDayworkService.updateById(bizDaywork);
        //零存
        //判断该批次是否存过
        List<BizStorageRetrieval> storage = bizStorageRetrievalService.query().eq("lot_id",item.getLotId()).list();
        Optional.ofNullable(bizDayworkItem.getStorageInfo())
                .ifPresent(storageInfo -> {
                    // 对象不为空，执行操作
                    if(storage.isEmpty()) {
                        //新增
                        bizStorageRetrievalService.save(bizDayworkItem.getStorageInfo());
                    }
                });
        //零取
        List<BizStorageRetrieval> retrievalList = bizStorageRetrievalService.query().eq("retrieval_lot_id",item.getLotId()).list();
        if( bizDayworkItem.getRetrievalInfo().size() > 0){
            List<BizStorageRetrieval> needUpdate = bizDayworkItem.getRetrievalInfo().stream().filter(v -> v.getStatus() == 0).collect(Collectors.toList());
                if(!needUpdate.isEmpty()) {
                    needUpdate.forEach(l -> l.setStatus(1));
                    bizStorageRetrievalService.updateBatchById(needUpdate);
                }
            }
        return result ? success() : error("结束失败");
    }
    @PostMapping("finishInner")
    @Log(title = "结束分选外协报工", businessType = BusinessType.SELECT)
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult finishInner(@RequestBody BizDayworkItem bizDayworkItem) {
        BizDayworkItem item = bizDayworkItemService.getById(bizDayworkItem.getId());
        //修改发出单报工合格数，投产数及折损率
        BizOutsourcedOrderDetailProcess outsourcedOrderDetailProcess = bizOutsourcedOrderDetailProcessService.query().eq("daywork_id", item.getDayworkId()).eq("process_step_number", item.getProcessStepNumber()).one();
        outsourcedOrderDetailProcess.setProductionNum(bizDayworkItem.getProdNum());
        outsourcedOrderDetailProcess.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        float percent = ((outsourcedOrderDetailProcess.getProductionNum() - outsourcedOrderDetailProcess.getQualifiedNum()) / (float) outsourcedOrderDetailProcess.getProductionNum()) * 100;
        outsourcedOrderDetailProcess.setLoss(BigDecimal.valueOf(percent));
        outsourcedOrderDetailProcess.setStatus(1);
        bizOutsourcedOrderDetailProcessService.updateById(outsourcedOrderDetailProcess);
        BizDayworkItemReject delCondition = new BizDayworkItemReject();
        delCondition.setDayworkItemId(item.getId());
        bizDayworkItemRejectService.physicalDelete(delCondition);
        List<BizDayworkItemReject> rejectList = bizDayworkItem.getRejectList();
        rejectList.forEach(l -> {
            l.setDayworkId(item.getDayworkId());
            l.setDayworkItemId(item.getId());
            l.setLotId(item.getLotId());
            l.setUserId(item.getUserId());
            l.setProductionPlanDetailId(item.getProductionPlanDetailId());
            l.setProductionPlanDetailSubDetailId(item.getProductionPlanDetailSubDetailId());
            l.setReason(l.getReason());
            l.setDeptId(item.getDeptId());
            l.setProcessId(item.getProcessId());
        });
        boolean result = rejectList.isEmpty() || bizDayworkItemRejectService.saveBatch(rejectList);
        BizProcess process = bizProcessService.query().eq("id", item.getProcessId()).one();
        Long packageLineId = bizPackageResourceGroupDetailService.query().eq("user_id", item.getUserId()).list().stream().findFirst().orElse(new BizPackageResourceGroupDetail()).getPackageResourceGroupId();
        item.setRejectNum(bizDayworkItem.getRejectNum());
        item.setRejectSum(bizDayworkItem.getRejectSum());
        item.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        item.setRemark(bizDayworkItem.getRemark());
        if(item.getStartTime() == null){
            item.setStartTime(new Date());
        }
        item.setStatus("3");
        item.setEndTime(new Date());
        item.setIsSort(1);
        item.setWorkingHours(item.getEndTime().getTime() - item.getStartTime().getTime());
        boolean returnCarrier;
        boolean isLatest;
        BizDaywork bizDaywork = bizDayworkService.getById(item.getDayworkId());
        bizDaywork.setTemporaryProcessQualifiedNum(bizDayworkItem.getQualifiedNum());
        if (bizDaywork.getIsAmend().equals(1) || bizDaywork.getIsWasteRecycling().equals(1)) {
//            List<BizLotTechnologicalProcess> processes = bizLotTechnologicalProcessService.query().eq("lot_id", bizDaywork.getLotId()).list();
//            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", processes.stream().map(BizLotTechnologicalProcess::getId).collect(Collectors.toList())).list();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber());
//                    item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)));
            isLatest = bizLotTechnologicalProcessDetails.stream().sorted(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber).reversed()).collect(Collectors.toList()).get(0).getProcessStepNumber().equals(item.getProcessStepNumber());
        } else {
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().ne("tenant_id", 9).eq("technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizTechnologicalProcessDetails.stream().max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber());
            isLatest = bizTechnologicalProcessDetails.stream().sorted(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber).reversed()).collect(Collectors.toList()).get(0).getProcessStepNumber().equals(item.getProcessStepNumber());
        }
        if(isLatest) {
            bizDaywork.setIsCertificate(1);
            bizDaywork.setPackageResourceGroupId(packageLineId);
            //包装线的所有员工
            String packageResourceGroupDetailUserIds = bizPackageResourceGroupDetailService.query().eq("package_resource_group_id", packageLineId).list().stream()
                    .map(BizPackageResourceGroupDetail::getUserId)
                    .map(Object::toString)
                    .collect(Collectors.joining(","));
            item.setPackageResourceGroupId(packageLineId);
            item.setPackageResourceGroupDetailUserId(packageResourceGroupDetailUserIds);
        }
        result = result && bizDayworkItemService.updateById(item);
        //解绑设备，将daywork状态设置为完成
        if (returnCarrier) {
            List<BizDayworkCarrier> bizDayworkCarriers = bizDayworkCarrierService.query().eq("daywork_id", item.getDayworkId()).eq("process_inspection_id", 0L).eq("is_changed", 0).list();
            bizDayworkCarriers.forEach(l -> {
                l.setIsChanged(1);
            });
            //最后一道序结束报工的时候，将daywork主表的status设置为2
            bizDaywork.setStatus(2);
            result = result && (bizDayworkCarriers.isEmpty() || bizDayworkCarrierService.updateBatchById(bizDayworkCarriers));
        }
        bizDayworkService.updateById(bizDaywork);
        //零存
        //判断该批次是否存过
        List<BizStorageRetrieval> storage = bizStorageRetrievalService.query().eq("lot_id",item.getLotId()).list();
        Optional.ofNullable(bizDayworkItem.getStorageInfo())
                .ifPresent(storageInfo -> {
                    // 对象不为空，执行操作
                    if(storage.isEmpty()) {
                        //新增
                        bizStorageRetrievalService.save(bizDayworkItem.getStorageInfo());
                    }
                });
        //零取
        List<BizStorageRetrieval> retrievalList = bizStorageRetrievalService.query().eq("retrieval_lot_id",item.getLotId()).list();
        if( bizDayworkItem.getRetrievalInfo().size() > 0){
            List<BizStorageRetrieval> needUpdate = bizDayworkItem.getRetrievalInfo().stream().filter(v -> v.getStatus() == 0).collect(Collectors.toList());
            if(!needUpdate.isEmpty()) {
                needUpdate.forEach(l -> l.setStatus(1));
                bizStorageRetrievalService.updateBatchById(needUpdate);
            }
        }
        return result ? success() : error("结束失败");
    }

    @Log(title = "保存分选报工", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/showDayworkSave")
    public AjaxResult addNewDayworkItem(@RequestBody List<BizDayworkItem> dayworkItemList) {
        // 新建报工明细
        List<BizDayworkItem> adds = new ArrayList<>();
        //dayworkID的所有报工
        List<BizDayworkItem> dayworkItemList1 = bizDayworkItemService.query().in("daywork_id", dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList())).list();
        // 更新报工明细
        List<BizDayworkItem> updates = new ArrayList<>();
        // 判断是否是最后一道工序，假设是的话，判断是否有包装线，假设没有则删除该报工。
        Long technologicalProcessDetailId = dayworkItemList.get(0).getDaywork().getTechnologicalProcessDetailId();
        boolean isLatest;
        Long packageLineId = bizPackageResourceGroupDetailService.query().eq("user_id", getLoginUser().getUserId()).list().stream().findFirst().orElse(new BizPackageResourceGroupDetail()).getPackageResourceGroupId();
        Long technologicalProcessId = dayworkItemList.get(0).getDaywork().getTechnologicalProcessId();
        BizDaywork bizDaywork = bizDayworkService.getById(dayworkItemList.get(0).getDayworkId());
        if(bizDaywork.getIsAmend().equals(1) || bizDaywork.getIsWasteRecycling().equals(1)) {
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", technologicalProcessId).ne("tenant_id", 9).orderByDesc("process_step_number").list();
            isLatest = bizLotTechnologicalProcessDetails.get(0).getId().equals(technologicalProcessDetailId);
        } else {
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().eq("technological_process_id", technologicalProcessId).ne("tenant_id", 9).orderByDesc("process_step_number").list();
            isLatest = bizTechnologicalProcessDetails.get(0).getId().equals(technologicalProcessDetailId);
        }
        List<BizDaywork> dayworkList = dayworkItemList.stream().map(BizDayworkItem::getDaywork).collect(Collectors.toList());
        List<Long> processIds = dayworkList.stream().map(v -> v.getProcessId()).collect(Collectors.toList());
        List<BizProcess> processList = bizProcessService.query().in("id", processIds).list();
        boolean isFx = false;
        for(int i = 0;i< processList.size();i++) {
            if (processList.get(i).getProcessAlias().contains("包装")) {
                isFx = true;
            }
        }
        if (isFx && (packageLineId == null || packageLineId == 0L)) {
            return error("该员工不在包装线中，不能进行包装");
        }

        // 更新报工
        List<BizDaywork> updateDaywork = new ArrayList<>();
        dayworkItemList.forEach(l -> {
            int sum = dayworkItemList1.stream().filter(m -> m.getDayworkId().equals(l.getDayworkId()) && (m.getProcessStepNumber().equals(l.getProcessStepNumber())) && (("2".equals(m.getStatus())) || "3".equals(m.getStatus())))
                    .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                    .sum();
//             l.getDaywork().setProcessQualifiedNum(l.getProdNum());
//            l.getDaywork().setProcessQualifiedNum(sum);
            l.getDaywork().setProcessQualifiedNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            if (l.getStatus().equals("4")) {
                l.setStatus("7");
                updates.add(l);
                l.getDaywork().setDeptId(l.getDeptId());
            }
            if (l.getStatus().equals("7")) {
                BizDaywork daywork = l.getDaywork();
                daywork.setProtemProcessId(l.getProcessId());
                daywork.setProtemProcessStepNumber(l.getProcessStepNumber());
                // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
            }
            updateDaywork.add(l.getDaywork());

            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(l.getDayworkId());
            ;
            if (l.getDaywork().getIsAmend() == 1) {
                bizDayworkItem.setFormDayworkItemId(1L);
            }
            bizDayworkItem.setProcessStepNumber(l.getDaywork().getProcessStepNumber());
            bizDayworkItem.setProductionPlanDetailId(l.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessId(l.getDaywork().getTechnologicalProcessId());
            SysUser user = SecurityUtils.getLoginUser().getUser();
            bizDayworkItem.setUserId(user.getUserId());
            bizDayworkItem.setUserName(user.getUserName());
            bizDayworkItem.setProdNum(sum);
            bizDayworkItem.setNickName(user.getNickName());
            // 0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(l.getDaywork().getProcessId());
            bizDayworkItem.setTechnologicalProcessDetailId(l.getDaywork().getTechnologicalProcessDetailId());
            bizDayworkItem.setDeptId(l.getDeptId());
            bizDayworkItem.setIsSort(l.getIsSort());
            bizDayworkItem.setDeptName(l.getDeptName());
            bizDayworkItem.setTenantId(l.getTenantId());
            bizDayworkItem.setLotId(l.getDaywork().getLotId());
            adds.add(bizDayworkItem);
        });

        return toAjax((updates.isEmpty() || bizDayworkItemService.updateBatchById(updates)) && (updateDaywork.isEmpty() || bizDayworkService.updateBatchById(updateDaywork)) && bizDayworkItemService.saveBatch(adds));
    }
    @Log(title = "保存分选报工", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/showDayworkSaveInner")
    public AjaxResult showDayworkSaveInner(@RequestBody List<BizDayworkItem> dayworkItemList) {
        // 新建报工明细
        List<BizDayworkItem> adds = new ArrayList<>();
        //dayworkID的所有报工
        List<BizDayworkItem> dayworkItemList1 = bizDayworkItemService.query().in("daywork_id", dayworkItemList.stream().map(BizDayworkItem::getDayworkId).collect(Collectors.toList())).list();
        // 更新报工明细
        List<BizDayworkItem> updates = new ArrayList<>();
        // 判断是否是最后一道工序，假设是的话，判断是否有包装线，假设没有则删除该报工。
        Long technologicalProcessDetailId = dayworkItemList.get(0).getDaywork().getTechnologicalProcessDetailId();
        boolean isLatest;
        Long packageLineId = bizPackageResourceGroupDetailService.query().eq("user_id", getLoginUser().getUserId()).list().stream().findFirst().orElse(new BizPackageResourceGroupDetail()).getPackageResourceGroupId();
        Long technologicalProcessId = dayworkItemList.get(0).getDaywork().getTechnologicalProcessId();
        BizDaywork bizDaywork = bizDayworkService.getById(dayworkItemList.get(0).getDayworkId());
        if(bizDaywork.getIsAmend().equals(1) || bizDaywork.getIsWasteRecycling().equals(1)) {
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", technologicalProcessId).ne("tenant_id", 9).orderByDesc("process_step_number").list();
            isLatest = bizLotTechnologicalProcessDetails.get(0).getId().equals(technologicalProcessDetailId);
        } else {
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().eq("technological_process_id", technologicalProcessId).ne("tenant_id", 9).orderByDesc("process_step_number").list();
            isLatest = bizTechnologicalProcessDetails.get(0).getId().equals(technologicalProcessDetailId);
        }
        List<BizDaywork> dayworkList = dayworkItemList.stream().map(BizDayworkItem::getDaywork).collect(Collectors.toList());
        List<Long> processIds = dayworkList.stream().map(v -> v.getProcessId()).collect(Collectors.toList());
        List<BizProcess> processList = bizProcessService.query().in("id", processIds).list();
        boolean isFx = false;
        for(int i = 0;i< processList.size();i++) {
            if (processList.get(i).getProcessAlias().contains("包装")) {
                isFx = true;
            }
        }
        if (isFx && (packageLineId == null || packageLineId == 0L)) {
            return error("该员工不在包装线中，不能进行包装");
        }

        // 更新报工
        List<BizDaywork> updateDaywork = new ArrayList<>();
        dayworkItemList.forEach(l -> {
            l.getDaywork().setProcessQualifiedNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            if (l.getStatus().equals("4")) {
                l.setStatus("7");
                updates.add(l);
                l.getDaywork().setDeptId(l.getDeptId());
            }
            if (l.getStatus().equals("7")) {
                BizDaywork daywork = l.getDaywork();
                daywork.setProtemProcessId(l.getProcessId());
                daywork.setProtemProcessStepNumber(l.getProcessStepNumber());
                // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
            }
            updateDaywork.add(l.getDaywork());

            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(l.getDayworkId());
            ;
            if (l.getDaywork().getIsAmend() == 1) {
                bizDayworkItem.setFormDayworkItemId(1L);
            }
            bizDayworkItem.setProcessStepNumber(l.getDaywork().getProcessStepNumber());
            bizDayworkItem.setProductionPlanDetailId(l.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessId(l.getDaywork().getTechnologicalProcessId());
            SysUser user = SecurityUtils.getLoginUser().getUser();
            bizDayworkItem.setUserId(user.getUserId());
            bizDayworkItem.setUserName(user.getUserName());
            bizDayworkItem.setProdNum(l.getDaywork().getTemporaryProcessQualifiedNum());
            bizDayworkItem.setNickName(user.getNickName());
            // 0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(l.getDaywork().getProcessId());
            bizDayworkItem.setTechnologicalProcessDetailId(l.getDaywork().getTechnologicalProcessDetailId());
            bizDayworkItem.setDeptId(l.getDeptId());
            bizDayworkItem.setIsSort(1);
            bizDayworkItem.setDeptName(l.getDeptName());
            bizDayworkItem.setLotId(l.getDaywork().getLotId());
            bizDayworkItem.setOutsourceDetailId(l.getOutsourceDetailId());
            bizDayworkItem.setTenantId(l.getTenantId());
            bizDayworkItem.setIsWx(1);
            adds.add(bizDayworkItem);
        });

        return toAjax((updates.isEmpty() || bizDayworkItemService.updateBatchById(updates)) && (updateDaywork.isEmpty() || bizDayworkService.updateBatchById(updateDaywork)) && bizDayworkItemService.saveBatch(adds));
    }

}
