package cn.ezhizao.project.business.product.domain;


import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 载具详情对象 biz_carrier
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@Data
@TableName(value = "biz_carrier")
public class BizCarrier extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户 id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 类别id */
    @ApiModelProperty(value = "${comment}")
    private Long categoryId;

    /** 载具编码 */
    @Excel(name = "载具编码")
    @ApiModelProperty(value = "载具编码")
    private String code;

    /** 载具状态（0：正常，1：废弃） */
    @Excel(name = "载具状态", readConverterExp = "0=：正常，1：废弃")
    @ApiModelProperty(value = "载具状态")
    private Integer isAbandoned;

    /** 报废日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "报废日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "报废日期")
    private Date abandonmentDate;

    /** 废弃原因 */
    @Excel(name = "废弃原因")
    @ApiModelProperty(value = "废弃原因")
    private String abandonmentReason;

    // 是否允许多批
    private Integer isAllowMore;

    @TableField(exist = false)
    private String processId;

    @TableField(exist = false)
    private List<String> processIds;

    @TableField(exist = false)
    private String processAlias;

    @TableField(exist = false)
    private Long carrierId;

    @TableField(exist = false)
    private String carrierCode;

    @TableField(exist = false)
    private Long planDetailId;

    @TableField(exist = false)
    private Long deptId;

    @TableField(exist = false)
    private String place;

    @TableField(exist = false)
    private Long dayworkId;

    @TableField(exist = false)
    private String lotCode;

    //是否为检查载具
    private Integer isInspection;
}
