package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

/**
 * 分选包装审核申请对象 biz_daywork_item_examine
 *
 * @author ezhizao
 * @date 2024-07-29
 */
@Data
@TableName(value = "biz_daywork_item_examine")
public class BizDayworkItemExamine extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** daywork的id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;

    /** 报工明细id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkItemId;

    /** 工段id */
    @ApiModelProperty(value = "${comment}")
    private Long deptId;

    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @ApiModelProperty(value = "产品描述")
    private String productDescription;

    /** 批次id */
    @ApiModelProperty(value = "${comment}")
    private Long lotId;

    /** 批次号 */
    @Excel(name = "批次号")
    @ApiModelProperty(value = "批次号")
    private String lotCode;

    /** 产品id */
    @ApiModelProperty(value = "批次号")
    private Long productId;

    /** 工艺id（通过工艺id，获取版本号） */
    @ApiModelProperty(value = "批次号")
    private Long technologicalProcessId;

    /** 当前工序id */
    @ApiModelProperty(value = "批次号")
    private Long technologicalProcessDetailId;

    /** 工序id */
    @ApiModelProperty(value = "批次号")
    private Long processId;

    /** 工序简称 */
    @Excel(name = "工序简称")
    @ApiModelProperty(value = "工序简称")
    private String processAlias;

    /** 审核状态 0待确认 2通过 1不通过 */
    @Excel(name = "审核状态 0待确认 2通过 1不通过")
    @ApiModelProperty(value = "审核状态 0待确认 2通过 1不通过")
    private Integer status;

    /** 审核人id */
    @ApiModelProperty(value = "审核状态 0待确认 2通过 1不通过")
    private Long reviewerId;
    @TableField(exist = false)
    private List<Long> dayworkIds;
}
