package cn.ezhizao.project.business.product.domain;


import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.business.auxiliaryDaywork.domain.BizDayworkAuxiliaryItemReject;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * 废品原因对象 biz_daywork_item_reject
 *
 * @author ezhizao
 * @date 2023-12-28
 */
@Data
@TableName(value = "biz_daywork_item_reject")
public class BizDayworkItemReject extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** daywork的id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;

    /** 计划单id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanId;

    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;
    private Long deptId;
    private Long processId;

    /** 子计划id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailId;

    /** 子计划工序对应的设备id？？？？？？？？？ */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailEquipmentId;

    /** 批次号 */
    @ApiModelProperty(value = "${comment}")
    private Long lotId;

    /** 报工明细id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkItemId;

    /** 废品原因 */
    @Excel(name = "废品原因")
    @ApiModelProperty(value = "废品原因")
    private String reason;

    @Excel(name = "序检 废品信息检查结果")
    @ApiModelProperty(value = "序检 废品信息检查结果")
    private String checkResult;

    @Excel(name = "检查标准")
    @ApiModelProperty(value = "检查标准")
    private String  checkStandard;

    @ApiModelProperty(value = "序检Id")
    private Long processInspectionId;

    /** 废品数 */
    @Excel(name = "废品数")
    @ApiModelProperty(value = "废品数")
    private Long rejectNum;

    @ApiModelProperty("检查指导书/分选标准")
    private Long inspectionInstructionId;

    @ApiModelProperty("类型")
    private Integer type;
    @TableField(exist = false)
    private Integer status;
    @TableField(exist = false)
    private String processAlias;
    @TableField(exist = false)
    private String nickName;
    @ApiModelProperty("辅助工序报工")
    private Long dayworkAuxiliaryItemId;
    @ApiModelProperty("辅助工序报工废品")
    private Long dayworkAuxiliaryItemRejectId;

    public BizDayworkItemReject() {
        super();
    }

    public BizDayworkItemReject(BizDayworkAuxiliaryItemReject l) {
        super();
        this.userId = l.getCreatorId();
        this.tenantId = l.getTenantId();
        this.dayworkId = l.getDayworkId();
        this.dayworkItemId = l.getDayworkItemId();
        this.reason = "5";
        this.rejectNum = l.getRejectNum() != null ? Long.valueOf(l.getRejectNum()) : 0L;
        this.dayworkAuxiliaryItemId = l.getDayworkAuxiliaryItemId();
        this.dayworkAuxiliaryItemRejectId = l.getId();
    }
}
