package cn.ezhizao.project.business.product.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import cn.ezhizao.project.business.product.domain.BizDayworkCarrier;

/**
 * 报工载具中间表Mapper接口
 *
 * @author ezhizao
 * @date 2023-12-04
 */
public interface BizDayworkCarrierMapper extends BaseMapper<BizDayworkCarrier>
{
    /**
     * 查询报工载具中间表列表
     *
     * @param bizDayworkCarrier 报工载具中间表
     * @return 报工载具中间表集合
     */
    public List<BizDayworkCarrier> getList(BizDayworkCarrier bizDayworkCarrier);
    public List<BizDayworkCarrier> getInfo(BizDayworkCarrier bizDayworkCarrier);
    public List<BizDayworkCarrier> getDayworkCarrierByCarrierCode(BizDayworkCarrier bizDayworkCarrier);

    /**
     * 物理删除
     * @param bizDayworkCarrier
     * @return 删除结果
    */
    public int physicalDelete(BizDayworkCarrier bizDayworkCarrier);

    public  int removeByDayworkId(Long dayworkId);

    BizDayworkCarrier getByCarrierCode(BizDayworkCarrier dayworkCarrier);

    /**
     * 根据dayworkId查询绑定信息
     * 在计算箱数时使用
     * @param dayworkItemId
     * @return
     */
    List<BizDayworkCarrier> getListBayDayworkId(List<Long> dayworkItemId);


}
