package cn.ezhizao.project.business.product.mapper;

import cn.ezhizao.project.business.product.domain.BizDaywork;
import cn.ezhizao.project.business.product.domain.BizProductionPlanDetailSubDetail;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;
import java.util.Map;

/**
 * 生产子计划明细Mapper接口
 *
 * @author ezhizao
 * @date 2023-11-15
 */
public interface BizProductionPlanDetailSubDetailMapper extends BaseMapper<BizProductionPlanDetailSubDetail> {
    /**
     * 查询生产子计划明细列表
     *
     * @param bizProductionPlanDetailSubDetail 生产子计划明细
     * @return 生产子计划明细集合
     */
    List<BizProductionPlanDetailSubDetail> getList(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail);

    /**
     * 根据人员绑定的设备查询生产子计划明细列表
     *
     *  生产子计划明细
     * @return 生产子计划明细集合
     */
    List<BizProductionPlanDetailSubDetail> getListByUserEquipment(Map<String, Object> data);


    /**
     * 物理删除
     *
     * @param bizProductionPlanDetailSubDetail
     * @return 删除结果
     */
    int physicalDelete(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail);

    /**
     * 根据关键字查询
     * @param keywords 关键字
     * @return List<BizProductionPlanDetailSubDetail> 列表
     */
    List<BizProductionPlanDetailSubDetail> getListByKeywords(String keywords);
}
