package cn.ezhizao.project.business.product.service;

import java.util.List;

import cn.ezhizao.project.business.product.domain.BizCarrier;
import cn.ezhizao.project.business.product.domain.BizDaywork;
import com.baomidou.mybatisplus.extension.service.IService;


/**
 * 报工Service接口
 *
 * @author ezhizao
 * @date 2023-11-29
 */
public interface IBizDayworkService extends IService<BizDaywork>
{
    /**
     * 查询报工列表
     *
     * @param bizDaywork 报工
     * @return 报工集合
     */
    public List<BizDaywork> getList(BizDaywork bizDaywork);
    public BizDaywork getDayworkInfoById(BizDaywork bizDaywork);

    /**
     * 物理删除
     * @param bizDaywork
     * @return 删除结果
     */
    public int physicalDelete(BizDaywork bizDaywork);

    /**
     * 物理删除
     * @param bizDaywork
     * @return 删除结果
     */
    public int turnoverDelete(BizDaywork bizDaywork);

    public List<BizCarrier> getAvailableCarrierList(BizCarrier bizCarrier);
    public BizDaywork getLotInfo(BizDaywork bizDaywork);
    public Integer getStatus(BizDaywork bizDaywork);

    /**
     * 判断批数不能大于投产批数
     */
    public Integer getLotNumber(Long productionPlanDetailId);

    public Integer getdayworkNum(Long productionPlanDetailId);

}
