package cn.ezhizao.project.business.product.service;

import cn.ezhizao.project.business.product.domain.BizProductionPlanDetailSubDetailEquipment;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * 生产计划明细Service接口
 *
 * @author ezhizao
 * @date 2023-11-15
 */
public interface IBizProductionPlanDetailSubDetailEquipmentService extends IService<BizProductionPlanDetailSubDetailEquipment> {
    /**
     * 查询生产计划明细列表
     *
     * @param data 子计划对应的工序指定的使用设备
     * @return 生产计划明细集合
     */
    List<BizProductionPlanDetailSubDetailEquipment> getList(Map<String, Object> data);
    /**
     * 查询生产计划明细列表
     *
     * @param data 生产计划明细
     * @return 生产计划明细集合
     */
    List<BizProductionPlanDetailSubDetailEquipment> getList(BizProductionPlanDetailSubDetailEquipment data);

    /**
     * 物理删除
     * @param bizProductionPlanDetailSubDetailEquipment 子计划对应的工序指定的使用设备
     * @return 删除结果
     */
    int physicalDelete(BizProductionPlanDetailSubDetailEquipment bizProductionPlanDetailSubDetailEquipment);

}
