package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.product.mapper.BizDayworkCarrierMapper;
import cn.ezhizao.project.business.product.domain.BizDayworkCarrier;
import cn.ezhizao.project.business.product.service.IBizDayworkCarrierService;

/**
 * 报工载具中间表Service业务层处理
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@Service
public class BizDayworkCarrierServiceImpl  extends ServiceImpl<BizDayworkCarrierMapper, BizDayworkCarrier> implements IBizDayworkCarrierService
{
    @Resource
    private BizDayworkCarrierMapper bizDayworkCarrierMapper;

    /**
     * 查询报工载具中间表列表
     *
     * @param bizDayworkCarrier 报工载具中间表
     * @return 报工载具中间表
     */
    @Override
    public List<BizDayworkCarrier> getList(BizDayworkCarrier bizDayworkCarrier)
    {
        return bizDayworkCarrierMapper.getList(bizDayworkCarrier);
    }
    @Override
    public List<BizDayworkCarrier> getInfo(BizDayworkCarrier bizDayworkCarrier)
    {
        return bizDayworkCarrierMapper.getInfo(bizDayworkCarrier);
    }

    @Override
    public List<BizDayworkCarrier> getDayworkCarrierByCarrierCode(BizDayworkCarrier bizDayworkCarrier) {
        return bizDayworkCarrierMapper.getDayworkCarrierByCarrierCode(bizDayworkCarrier);
    }

    /**
     * 物理删除
     * @param bizDayworkCarrier
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkCarrier bizDayworkCarrier){ return bizDayworkCarrierMapper.physicalDelete(bizDayworkCarrier); }

    @Override
    public int removeByDayworkId(Long dayworkId) {
        return bizDayworkCarrierMapper.removeByDayworkId(dayworkId);
    }

    @Override
    public BizDayworkCarrier getByCarrierCode(BizDayworkCarrier dayworkCarrier) {
        return bizDayworkCarrierMapper.getByCarrierCode(dayworkCarrier);
    }

    ;

}
