package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizDayworkItemReject;
import cn.ezhizao.project.business.product.mapper.BizDayworkItemRejectMapper;
import cn.ezhizao.project.business.product.service.IBizDayworkItemRejectService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * 废品原因Service业务层处理
 *
 * @author ezhizao
 * @date 2023-12-28
 */
@Service
public class BizDayworkItemRejectServiceImpl  extends ServiceImpl<BizDayworkItemRejectMapper, BizDayworkItemReject> implements IBizDayworkItemRejectService
{
    @Resource
    private BizDayworkItemRejectMapper bizDayworkItemRejectMapper;

    /**
     * 查询废品原因列表
     *
     * @param bizDayworkItemReject 废品原因
     * @return 废品原因
     */
    @Override
    public List<BizDayworkItemReject> getList(BizDayworkItemReject bizDayworkItemReject)
    {
        return bizDayworkItemRejectMapper.getList(bizDayworkItemReject);
    }

    /**
     * 物理删除
     * @param bizDayworkItemReject
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkItemReject bizDayworkItemReject){ return bizDayworkItemRejectMapper.physicalDelete(bizDayworkItemReject); }

    @Override
    public int removeReject(BizDayworkItemReject rej) {
        return bizDayworkItemRejectMapper.removeReject(rej);
    }



}
