package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizInspectionChamber;
import cn.ezhizao.project.business.product.mapper.BizInspectionChamberMapper;
import cn.ezhizao.project.business.product.service.IBizInspectionChamberService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 检测室配置Service业务层处理
 *
 * @author ezhizao
 * @date 2024-08-06
 */
@Service
public class BizInspectionChamberServiceImpl  extends ServiceImpl<BizInspectionChamberMapper, BizInspectionChamber> implements IBizInspectionChamberService
{
    @Resource
    private BizInspectionChamberMapper bizInspectionChamberMapper;

    /**
     * 查询检测室配置列表
     *
     * @param bizInspectionChamber 检测室配置
     * @return 检测室配置
     */
    @Override
    public List<BizInspectionChamber> getList(BizInspectionChamber bizInspectionChamber)
    {
        return bizInspectionChamberMapper.getList(bizInspectionChamber);
    }

    /**
     * 物理删除
     * @param bizInspectionChamber
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizInspectionChamber bizInspectionChamber){ return bizInspectionChamberMapper.physicalDelete(bizInspectionChamber); };

}
