package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizDayworkItemReject;
import cn.ezhizao.project.business.product.domain.BizProcessInspecion;
import cn.ezhizao.project.business.product.domain.BizProcessInspectionDetail;
import cn.ezhizao.project.business.product.mapper.BizProcessInspecionMapper;
import cn.ezhizao.project.business.product.service.IBizProcessInspecionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * 序检主Service业务层处理
 *
 * @author ezhizao
 * @date 2024-04-24
 */
@Service
public class BizProcessInspecionServiceImpl  extends ServiceImpl<BizProcessInspecionMapper, BizProcessInspecion> implements IBizProcessInspecionService
{
    @Resource
    private BizProcessInspecionMapper bizProcessInspecionMapper;

    /**
     * 查询序检主列表
     *
     * @param bizProcessInspecion 序检主
     * @return 序检主
     */
    @Override
    public List<BizProcessInspecion> getList(BizProcessInspecion bizProcessInspecion)
    {
        return bizProcessInspecionMapper.getList(bizProcessInspecion);
    }

    @Override
    public List<BizProcessInspecion> getExaminList(BizProcessInspecion bizProcessInspecion) {
        return bizProcessInspecionMapper.getExaminList(bizProcessInspecion);
    }

    @Override
    public List<BizProcessInspecion> getInfoByIds(List<Long> ids) {
        return bizProcessInspecionMapper.getInfoByIds(ids);
    }

    @Override
    public List<BizProcessInspectionDetail> getInspectionByDayworkId(BizProcessInspecion bizProcessInspecion) {
        return bizProcessInspecionMapper.getInspectionByDayworkId(bizProcessInspecion);
    }

    @Override
    public List<BizProcessInspecion> getInspection(BizProcessInspecion bizProcessInspecion) {
        return bizProcessInspecionMapper.getInspection(bizProcessInspecion);
    }

    @Override
    public List<BizProcessInspectionDetail> getDetailByProcessInspectionIds(List<Long> processInspectionIds) {
        return bizProcessInspecionMapper.getDetailByProcessInspectionIds(processInspectionIds);
    }

    /**
     * 物理删除
     * @param bizProcessInspecion
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProcessInspecion bizProcessInspecion){ return bizProcessInspecionMapper.physicalDelete(bizProcessInspecion); }

    @Override
    public List<BizProcessInspecion> getOutsourcedlist(BizProcessInspecion bizProcessInspecion) {
        return bizProcessInspecionMapper.getOutsourcedlist(bizProcessInspecion);
    }

    @Override
    public List<BizProcessInspecion> getAllList() {
        return bizProcessInspecionMapper.getAllList();
    }

    ;

}
