package cn.ezhizao.project.business.product.service.impl;

import cn.ezhizao.project.business.product.domain.BizProductionPlanDetailSubDetail;
import cn.ezhizao.project.business.product.mapper.BizProductionPlanDetailSubDetailMapper;
import cn.ezhizao.project.business.product.service.IBizProductionPlanDetailSubDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 生产子计划明细Service业务层处理
 *
 * @author ezhizao
 * @date 2023-11-15
 */
@Service
public class BizProductionPlanDetailSubDetailServiceImpl  extends ServiceImpl<BizProductionPlanDetailSubDetailMapper, BizProductionPlanDetailSubDetail> implements IBizProductionPlanDetailSubDetailService
{
    @Resource
    private BizProductionPlanDetailSubDetailMapper bizProductionPlanDetailSubDetailMapper;

    /**
     * 查询生产子计划明细列表
     *
     * @param bizProductionPlanDetailSubDetail 生产子计划明细
     * @return 生产子计划明细
     */
    @Override
    public List<BizProductionPlanDetailSubDetail> getList(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail)
    {
        return bizProductionPlanDetailSubDetailMapper.getList(bizProductionPlanDetailSubDetail);
    }

    /**
     * 物理删除
     * @param bizProductionPlanDetailSubDetail 实体
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail){ return bizProductionPlanDetailSubDetailMapper.physicalDelete(bizProductionPlanDetailSubDetail); };


    /**
     * 根据关键字查询
     * @param keywords 关键字
     * @return List<BizProductionPlanDetailSubDetail> 列表
     */
    @Override
    public List<BizProductionPlanDetailSubDetail> getListByKeywords(String keywords){
        return bizProductionPlanDetailSubDetailMapper.getListByKeywords(keywords);
    }

    @Override
    public List<BizProductionPlanDetailSubDetail> getListByUserEquipment(Map<String, Object> data) {
        return bizProductionPlanDetailSubDetailMapper.getListByUserEquipment(data);
    }

}
