package cn.ezhizao.project.business.resourceGroup.domain;

import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;


/**
 * 工段资源组明细对象 biz_production_resource_group_detail
 *
 * @author ezhizao
 * @date 2024-01-10
 */
@Data
@TableName(value = "biz_production_resource_group_detail")
public class BizProductionResourceGroupDetail extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 资源组id */
    @ApiModelProperty(value = "${comment}")
    private Long productionResourceGroupId;
    /** 资源id */
    private Long commonId;
    /** 资源编号 */
    private String commonCode;
    /** 资源类型 */
    private String commonType;
    /** 资源类型 */
    private String commonName;
    /** 设备使用部门 */
    @ApiModelProperty(value = "设备编码")
    private Long deptId;
    @TableField(exist = false)
    private String resourceCode;

    /** 邀请报工临时人员状态*/
    private Long protemDayworkId;
    /** 邀请报工临时人员状态*/
    private Long protemProcessId;
    /** 生产计划id*/
    @TableField(exist = false)
    private Long productionPlanDetailId;
    @TableField(exist = false)
    private List<Long> detailIds;
    @TableField(exist = false)
    private Long technologicalProcessDetailId;
    private String protemProcessStepNumber;
    @TableField(exist = false)
    private String protemCreatorName;
}
