package cn.ezhizao.project.business.resourceGroup.service.impl;



import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroup;
import cn.ezhizao.project.business.resourceGroup.mapper.BizProductionResourceGroupMapper;

import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 工段资源组Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-10
 */
@Service
public class BizProductionResourceGroupServiceImpl  extends ServiceImpl<BizProductionResourceGroupMapper, BizProductionResourceGroup> implements IBizProductionResourceGroupService
{
    @Resource
    private BizProductionResourceGroupMapper bizProductionResourceGroupMapper;

    /**
     * 查询工段资源组列表
     *
     * @param bizProductionResourceGroup 工段资源组
     * @return 工段资源组
     */
    @Override
    public List<BizProductionResourceGroup> getList(BizProductionResourceGroup bizProductionResourceGroup)
    {
        return bizProductionResourceGroupMapper.getList(bizProductionResourceGroup);
    }

    /**
     * 物理删除
     * @param bizProductionResourceGroup
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProductionResourceGroup bizProductionResourceGroup){ return bizProductionResourceGroupMapper.physicalDelete(bizProductionResourceGroup); };

}
