package cn.ezhizao.project.business.resourceGroup.service.impl;


import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupSubPlan;
import cn.ezhizao.project.business.resourceGroup.mapper.BizProductionResourceGroupSubPlanMapper;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupSubPlanService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 资源组任务分配Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-11
 */
@Service
public class BizProductionResourceGroupSubPlanServiceImpl  extends ServiceImpl<BizProductionResourceGroupSubPlanMapper, BizProductionResourceGroupSubPlan> implements IBizProductionResourceGroupSubPlanService
{
    @Resource
    private BizProductionResourceGroupSubPlanMapper bizProductionResourceGroupSubPlanMapper;

    /**
     * 查询资源组任务分配列表
     *
     * @param bizProductionResourceGroupSubPlan 资源组任务分配
     * @return 资源组任务分配
     */
    @Override
    public List<BizProductionResourceGroupSubPlan> getList(BizProductionResourceGroupSubPlan bizProductionResourceGroupSubPlan)
    {
        return bizProductionResourceGroupSubPlanMapper.getList(bizProductionResourceGroupSubPlan);
    }

    /**
     * 物理删除
     * @param bizProductionResourceGroupSubPlan
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProductionResourceGroupSubPlan bizProductionResourceGroupSubPlan){ return bizProductionResourceGroupSubPlanMapper.physicalDelete(bizProductionResourceGroupSubPlan); }

    @Override
    public List<BizProductionResourceGroupSubPlan> getAotList(BizProductionResourceGroupSubPlan subPlan) {
        return bizProductionResourceGroupSubPlanMapper.getAotList(subPlan);
    }

    ;

}
