package cn.ezhizao.project.business.storageRetrieval.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.storageRetrieval.domain.BizStorageRetrieval;
import cn.ezhizao.project.business.storageRetrieval.mapper.BizStorageRetrievalMapper;
import cn.ezhizao.project.business.storageRetrieval.service.IBizStorageRetrievalService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 零存零取Service业务层处理
 *
 * @author ezhizao
 * @date 2024-10-11
 */
@Service
public class BizStorageRetrievalServiceImpl  extends ServiceImpl<BizStorageRetrievalMapper, BizStorageRetrieval> implements IBizStorageRetrievalService
{
    @Resource
    private BizStorageRetrievalMapper bizStorageRetrievalMapper;

    /**
     * 查询零存零取列表
     *
     * @param bizStorageRetrieval 零存零取
     * @return 零存零取
     */
    @Override
    public List<BizStorageRetrieval> getList(BizStorageRetrieval bizStorageRetrieval)
    {
        return bizStorageRetrievalMapper.getList(bizStorageRetrieval);
    }

    /**
     * 物理删除
     * @param bizStorageRetrieval
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizStorageRetrieval bizStorageRetrieval){ return bizStorageRetrievalMapper.physicalDelete(bizStorageRetrieval); };

}
