package cn.ezhizao.project.business.takeStockPeriod.domain;

import java.util.Date;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * 盘点时间对象 biz_take_stock_period
 *
 * @author ezhizao
 * @date 2024-08-15
 */
@Data
@TableName(value = "biz_take_stock_period")
public class BizTakeStockPeriod extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 盘点状态（1:开始盘点，2：结束盘点） */
    @Excel(name = "盘点状态", readConverterExp = "1=:开始盘点，2：结束盘点")
    @ApiModelProperty(value = "盘点状态")
    private Integer status;

    /** 盘点开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "盘点开始时间", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "盘点开始时间")
    private Date startTime;

    /** 盘点结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "盘点结束时间", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "盘点结束时间")
    private Date endTime;
    @TableField(exist = false)
    private Long tenantId;
    @TableField(exist = false)
    private Long dayworkId;

}
