package cn.ezhizao.project.business.takeStockPeriod.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.takeStockPeriod.domain.BizTakeStockPeriod;
import cn.ezhizao.project.business.takeStockPeriod.mapper.BizTakeStockPeriodMapper;
import cn.ezhizao.project.business.takeStockPeriod.service.IBizTakeStockPeriodService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 盘点时间Service业务层处理
 *
 * @author ezhizao
 * @date 2024-08-15
 */
@Service
public class BizTakeStockPeriodServiceImpl  extends ServiceImpl<BizTakeStockPeriodMapper, BizTakeStockPeriod> implements IBizTakeStockPeriodService
{
    @Resource
    private BizTakeStockPeriodMapper bizTakeStockPeriodMapper;

    /**
     * 查询盘点时间列表
     *
     * @param bizTakeStockPeriod 盘点时间
     * @return 盘点时间
     */
    @Override
    public List<BizTakeStockPeriod> getList(BizTakeStockPeriod bizTakeStockPeriod)
    {
        return bizTakeStockPeriodMapper.getList(bizTakeStockPeriod);
    }

    /**
     * 物理删除
     * @param bizTakeStockPeriod
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTakeStockPeriod bizTakeStockPeriod){ return bizTakeStockPeriodMapper.physicalDelete(bizTakeStockPeriod); };

}
