package cn.ezhizao.project.business.technologicalProcessDetailDrawing.service.impl;


import cn.ezhizao.project.business.technologicalProcessDetailDrawing.domain.BizTechnologicalProcessDetailDrawing;
import cn.ezhizao.project.business.technologicalProcessDetailDrawing.mapper.BizTechnologicalProcessDetailDrawingMapper;
import cn.ezhizao.project.business.technologicalProcessDetailDrawing.service.IBizTechnologicalProcessDetailDrawingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

/**
 * 电子图纸Service业务层处理
 *
 * @author ezhizao
 * @date 2024-05-30
 */
@Service
public class BizTechnologicalProcessDetailDrawingServiceImpl extends ServiceImpl<BizTechnologicalProcessDetailDrawingMapper, BizTechnologicalProcessDetailDrawing> implements IBizTechnologicalProcessDetailDrawingService
{
    @Resource
    private BizTechnologicalProcessDetailDrawingMapper bizTechnologicalProcessDetailDrawingMapper;

    /**
     * 查询电子图纸列表
     *
     * @param bizTechnologicalProcessDetailDrawing 电子图纸
     * @return 电子图纸
     */
    @Override
    public List<BizTechnologicalProcessDetailDrawing> getList(BizTechnologicalProcessDetailDrawing bizTechnologicalProcessDetailDrawing)
    {
        return bizTechnologicalProcessDetailDrawingMapper.getList(bizTechnologicalProcessDetailDrawing);
    }

    /**
     * 物理删除
     * @param bizTechnologicalProcessDetailDrawing
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTechnologicalProcessDetailDrawing bizTechnologicalProcessDetailDrawing){ return bizTechnologicalProcessDetailDrawingMapper.physicalDelete(bizTechnologicalProcessDetailDrawing); }

    @Override
    public List<BizTechnologicalProcessDetailDrawing> getDrawingList(BizTechnologicalProcessDetailDrawing bizTechnologicalProcessDetailDrawing) {
        return bizTechnologicalProcessDetailDrawingMapper.getDrawingList(bizTechnologicalProcessDetailDrawing);
    }

    ;

}
